# -*- coding: utf-8 -*-
'''
Created on 14/feb/2012

@author: simone cittadini
'''
from django import forms
from django.forms.extras import widgets

from pbx.ivr.models import TimeSlot

ORE = (
       ((0, 0), '00:00'), ((0, 15), '00:15'), ((0, 30), '00:30'), ((0, 45), '00:45'), 
       ((1, 0), '01:00'), ((1, 15), '01:15'), ((1, 30), '01:30'), ((1, 45), '01:45'), 
       ((2, 0), '02:00'), ((2, 15), '02:15'), ((2, 30), '02:30'), ((2, 45), '02:45'), 
       ((3, 0), '03:00'), ((3, 15), '03:15'), ((3, 30), '03:30'), ((3, 45), '03:45'), 
       ((4, 0), '04:00'), ((4, 15), '04:15'), ((4, 30), '04:30'), ((4, 45), '04:45'), 
       ((5, 0), '05:00'), ((5, 15), '05:15'), ((5, 30), '05:30'), ((5, 45), '05:45'), 
       ((6, 0), '06:00'), ((6, 15), '06:15'), ((6, 30), '06:30'), ((6, 45), '06:45'), 
       ((7, 0), '07:00'), ((7, 15), '07:15'), ((7, 30), '07:30'), ((7, 45), '07:45'), 
       ((8, 0), '08:00'), ((8, 15), '08:15'), ((8, 30), '08:30'), ((8, 45), '08:45'), 
       ((9, 0), '09:00'), ((9, 15), '09:15'), ((9, 30), '09:30'), ((9, 45), '09:45'), 
       ((10, 0), '10:00'), ((10, 15), '10:15'), ((10, 30), '10:30'), ((10, 45), '10:45'), 
       ((11, 0), '11:00'), ((11, 15), '11:15'), ((11, 30), '11:30'), ((11, 45), '11:45'), 
       ((12, 0), '12:00'), ((12, 15), '12:15'), ((12, 30), '12:30'), ((12, 45), '12:45'), 
       ((13, 0), '13:00'), ((13, 15), '13:15'), ((13, 30), '13:30'), ((13, 45), '13:45'), 
       ((14, 0), '14:00'), ((14, 15), '14:15'), ((14, 30), '14:30'), ((14, 45), '14:45'), 
       ((15, 0), '15:00'), ((15, 15), '15:15'), ((15, 30), '15:30'), ((15, 45), '15:45'), 
       ((16, 0), '16:00'), ((16, 15), '16:15'), ((16, 30), '16:30'), ((16, 45), '16:45'), 
       ((17, 0), '17:00'), ((17, 15), '17:15'), ((17, 30), '17:30'), ((17, 45), '17:45'), 
       ((18, 0), '18:00'), ((18, 15), '18:15'), ((18, 30), '18:30'), ((18, 45), '18:45'), 
       ((19, 0), '19:00'), ((19, 15), '19:15'), ((19, 30), '19:30'), ((19, 45), '19:45'), 
       ((20, 0), '20:00'), ((20, 15), '20:15'), ((20, 30), '20:30'), ((20, 45), '20:45'), 
       ((21, 0), '21:00'), ((21, 15), '21:15'), ((21, 30), '21:30'), ((21, 45), '21:45'), 
       ((22, 0), '22:00'), ((22, 15), '22:15'), ((22, 30), '22:30'), ((22, 45), '22:45'), 
       ((23, 0), '23:00'), ((23, 15), '23:15'), ((23, 30), '23:30'), ((23, 45), '23:45'),
       )



class TimeTableForm(forms.Form):
    lun_abilitato = forms.BooleanField(label='lunedì')
    lun_dalle_mattina = forms.TimeField(widget=widgets.Select(choices=ORE, attrs={'width' : '40px'}), label='')
    lun_alle_mattina = forms.TimeField(widget=widgets.Select(choices=ORE, attrs={'width' : '40px'}), label='')
    lun_dalle_pomeriggio = forms.TimeField(widget=widgets.Select(choices=ORE, attrs={'width' : '40px'}), label='')
    lun_alle_pomeriggio = forms.TimeField(widget=widgets.Select(choices=ORE, attrs={'width' : '40px'}), label='')
    
    mar_abilitato = forms.BooleanField(label='martedì')
    mar_dalle_mattina = forms.TimeField(widget=widgets.Select(choices=ORE, attrs={'width' : '40px'}), label='')
    mar_alle_mattina = forms.TimeField(widget=widgets.Select(choices=ORE, attrs={'width' : '40px'}), label='')
    mar_dalle_pomeriggio = forms.TimeField(widget=widgets.Select(choices=ORE, attrs={'width' : '40px'}), label='')
    mar_alle_pomeriggio = forms.TimeField(widget=widgets.Select(choices=ORE, attrs={'width' : '40px'}), label='')
    
    mer_abilitato = forms.BooleanField(label='mercoledì')
    mer_dalle_mattina = forms.TimeField(widget=widgets.Select(choices=ORE, attrs={'width' : '40px'}), label='')
    mer_alle_mattina = forms.TimeField(widget=widgets.Select(choices=ORE, attrs={'width' : '40px'}), label='')
    mer_dalle_pomeriggio = forms.TimeField(widget=widgets.Select(choices=ORE, attrs={'width' : '40px'}), label='')
    mer_alle_pomeriggio = forms.TimeField(widget=widgets.Select(choices=ORE, attrs={'width' : '40px'}), label='')
    
    gio_abilitato = forms.BooleanField(label='giovedì')
    gio_dalle_mattina = forms.TimeField(widget=widgets.Select(choices=ORE, attrs={'width' : '40px'}), label='')
    gio_alle_mattina = forms.TimeField(widget=widgets.Select(choices=ORE, attrs={'width' : '40px'}), label='')
    gio_dalle_pomeriggio = forms.TimeField(widget=widgets.Select(choices=ORE, attrs={'width' : '40px'}), label='')
    gio_alle_pomeriggio = forms.TimeField(widget=widgets.Select(choices=ORE, attrs={'width' : '40px'}), label='')
    
    ven_abilitato = forms.BooleanField(label='venerdì')
    ven_dalle_mattina = forms.TimeField(widget=widgets.Select(choices=ORE, attrs={'width' : '40px'}), label='')
    ven_alle_mattina = forms.TimeField(widget=widgets.Select(choices=ORE, attrs={'width' : '40px'}), label='')
    ven_dalle_pomeriggio = forms.TimeField(widget=widgets.Select(choices=ORE, attrs={'width' : '40px'}), label='')
    ven_alle_pomeriggio = forms.TimeField(widget=widgets.Select(choices=ORE, attrs={'width' : '40px'}), label='')
    
    sab_abilitato = forms.BooleanField(label='sabato')
    sab_dalle_mattina = forms.TimeField(widget=widgets.Select(choices=ORE, attrs={'width' : '40px'}), label='')
    sab_alle_mattina = forms.TimeField(widget=widgets.Select(choices=ORE, attrs={'width' : '40px'}), label='')
    sab_dalle_pomeriggio = forms.TimeField(widget=widgets.Select(choices=ORE, attrs={'width' : '40px'}), label='')
    sab_alle_pomeriggio = forms.TimeField(widget=widgets.Select(choices=ORE, attrs={'width' : '40px'}), label='')
    
    dom_abilitato = forms.BooleanField(label='domenica')
    dom_dalle_mattina = forms.TimeField(widget=widgets.Select(choices=ORE, attrs={'width' : '40px'}), label='')
    dom_alle_mattina = forms.TimeField(widget=widgets.Select(choices=ORE, attrs={'width' : '40px'}), label='')
    dom_dalle_pomeriggio = forms.TimeField(widget=widgets.Select(choices=ORE, attrs={'width' : '40px'}), label='')
    dom_alle_pomeriggio = forms.TimeField(widget=widgets.Select(choices=ORE, attrs={'width' : '40px'}), label='')
    
    
    def __init__(self, *args, **kwargs):
        super(TimeTableForm, self).__init__(*args, **kwargs)
        ts_lun = TimeSlot.objects.get(weekday=1)
        ts_mar = TimeSlot.objects.get(weekday=2)
        ts_mer = TimeSlot.objects.get(weekday=3)
        ts_gio = TimeSlot.objects.get(weekday=4)
        ts_ven = TimeSlot.objects.get(weekday=5)
        ts_sab = TimeSlot.objects.get(weekday=6)
        ts_dom = TimeSlot.objects.get(weekday=7)
        
        self.fields['lun_abilitato'].initial = ts_lun.attivo
        self.fields['lun_dalle_mattina'].initial = (ts_lun.dalle_mattina.hour, ts_lun.dalle_mattina.minute)
        self.fields['lun_alle_mattina'].initial = (ts_lun.alle_mattina.hour, ts_lun.alle_mattina.minute)
        self.fields['lun_dalle_pomeriggio'].initial = (ts_lun.dalle_pomeriggio.hour, ts_lun.dalle_pomeriggio.minute)
        self.fields['lun_alle_pomeriggio'].initial = (ts_lun.alle_pomeriggio.hour, ts_lun.alle_pomeriggio.minute)
        
        self.fields['mar_abilitato'].initial = ts_mar.attivo
        self.fields['mar_dalle_mattina'].initial = (ts_mar.dalle_mattina.hour, ts_mar.dalle_mattina.minute)
        self.fields['mar_alle_mattina'].initial = (ts_mar.alle_mattina.hour, ts_mar.alle_mattina.minute)
        self.fields['mar_dalle_pomeriggio'].initial = (ts_mar.dalle_pomeriggio.hour, ts_mar.dalle_pomeriggio.minute)
        self.fields['mar_alle_pomeriggio'].initial = (ts_mar.alle_pomeriggio.hour, ts_mar.alle_pomeriggio.minute)
        
        self.fields['mer_abilitato'].initial = ts_mer.attivo
        self.fields['mer_dalle_mattina'].initial = (ts_mer.dalle_mattina.hour, ts_mer.dalle_mattina.minute)
        self.fields['mer_alle_mattina'].initial = (ts_mer.alle_mattina.hour, ts_mer.alle_mattina.minute)
        self.fields['mer_dalle_pomeriggio'].initial = (ts_mer.dalle_pomeriggio.hour, ts_mer.dalle_pomeriggio.minute)
        self.fields['mer_alle_pomeriggio'].initial = (ts_mer.alle_pomeriggio.hour, ts_mer.alle_pomeriggio.minute)
        
        self.fields['gio_abilitato'].initial = ts_gio.attivo
        self.fields['gio_dalle_mattina'].initial = (ts_gio.dalle_mattina.hour, ts_gio.dalle_mattina.minute)
        self.fields['gio_alle_mattina'].initial = (ts_gio.alle_mattina.hour, ts_gio.alle_mattina.minute)
        self.fields['gio_dalle_pomeriggio'].initial = (ts_gio.dalle_pomeriggio.hour, ts_gio.dalle_pomeriggio.minute)
        self.fields['gio_alle_pomeriggio'].initial = (ts_gio.alle_pomeriggio.hour, ts_gio.alle_pomeriggio.minute)
        
        self.fields['ven_abilitato'].initial = ts_ven.attivo
        self.fields['ven_dalle_mattina'].initial = (ts_ven.dalle_mattina.hour, ts_ven.dalle_mattina.minute)
        self.fields['ven_alle_mattina'].initial = (ts_ven.alle_mattina.hour, ts_ven.alle_mattina.minute)
        self.fields['ven_dalle_pomeriggio'].initial = (ts_ven.dalle_pomeriggio.hour, ts_ven.dalle_pomeriggio.minute)
        self.fields['ven_alle_pomeriggio'].initial = (ts_ven.alle_pomeriggio.hour, ts_ven.alle_pomeriggio.minute)
        
        self.fields['sab_abilitato'].initial = ts_sab.attivo
        self.fields['sab_dalle_mattina'].initial = (ts_sab.dalle_mattina.hour, ts_sab.dalle_mattina.minute)
        self.fields['sab_alle_mattina'].initial = (ts_sab.alle_mattina.hour, ts_sab.alle_mattina.minute)
        self.fields['sab_dalle_pomeriggio'].initial = (ts_sab.dalle_pomeriggio.hour, ts_sab.dalle_pomeriggio.minute)
        self.fields['sab_alle_pomeriggio'].initial = (ts_sab.alle_pomeriggio.hour, ts_sab.alle_pomeriggio.minute)
        
        self.fields['dom_dalle_mattina'].initial = (ts_dom.dalle_mattina.hour, ts_dom.dalle_mattina.minute)
        self.fields['dom_alle_mattina'].initial = (ts_dom.alle_mattina.hour, ts_dom.alle_mattina.minute)
        self.fields['dom_dalle_pomeriggio'].initial = (ts_dom.dalle_pomeriggio.hour, ts_dom.dalle_pomeriggio.minute)
        self.fields['dom_alle_pomeriggio'].initial = (ts_dom.alle_pomeriggio.hour, ts_dom.alle_pomeriggio.minute)
        
        