# encoding: utf-8
import datetime
from south.db import db
from south.v2 import SchemaMigration
from django.db import models

class Migration(SchemaMigration):

    def forwards(self, orm):
        
        # Adding model 'FileNodoInRegistrazione'
        db.create_table('ivr_filenodoinregistrazione', (
            ('id', self.gf('django.db.models.fields.AutoField')(primary_key=True)),
            ('filename', self.gf('django.db.models.fields.CharField')(max_length=32)),
        ))
        db.send_create_signal('ivr', ['FileNodoInRegistrazione'])

        # Adding model 'NodoIvr'
        db.create_table('ivr_nodoivr', (
            ('id', self.gf('django.db.models.fields.AutoField')(primary_key=True)),
            ('nome', self.gf('django.db.models.fields.CharField')(max_length=32)),
            ('padre', self.gf('django.db.models.fields.related.ForeignKey')(to=orm['ivr.NodoIvr'], null=True, blank=True)),
            ('tono', self.gf('django.db.models.fields.CharField')(max_length=1, null=True, blank=True)),
            ('filename', self.gf('django.db.models.fields.CharField')(max_length=32, null=True, blank=True)),
            ('timeout', self.gf('django.db.models.fields.PositiveSmallIntegerField')(default=0)),
            ('extension', self.gf('django.db.models.fields.CharField')(max_length=32, null=True, blank=True)),
        ))
        db.send_create_signal('ivr', ['NodoIvr'])

        # Adding unique constraint on 'NodoIvr', fields ['padre', 'tono']
        db.create_unique('ivr_nodoivr', ['padre_id', 'tono'])

        # Adding model 'TimeSlot'
        db.create_table('ivr_timeslot', (
            ('id', self.gf('django.db.models.fields.AutoField')(primary_key=True)),
            ('weekday', self.gf('django.db.models.fields.PositiveIntegerField')(default=0)),
            ('dalle_mattina', self.gf('django.db.models.fields.TimeField')()),
            ('alle_mattina', self.gf('django.db.models.fields.TimeField')()),
            ('dalle_pomeriggio', self.gf('django.db.models.fields.TimeField')()),
            ('alle_pomeriggio', self.gf('django.db.models.fields.TimeField')()),
            ('radice', self.gf('django.db.models.fields.related.ForeignKey')(to=orm['ivr.NodoIvr'])),
        ))
        db.send_create_signal('ivr', ['TimeSlot'])


    def backwards(self, orm):
        
        # Removing unique constraint on 'NodoIvr', fields ['padre', 'tono']
        db.delete_unique('ivr_nodoivr', ['padre_id', 'tono'])

        # Deleting model 'FileNodoInRegistrazione'
        db.delete_table('ivr_filenodoinregistrazione')

        # Deleting model 'NodoIvr'
        db.delete_table('ivr_nodoivr')

        # Deleting model 'TimeSlot'
        db.delete_table('ivr_timeslot')


    models = {
        'ivr.filenodoinregistrazione': {
            'Meta': {'object_name': 'FileNodoInRegistrazione'},
            'filename': ('django.db.models.fields.CharField', [], {'max_length': '32'}),
            'id': ('django.db.models.fields.AutoField', [], {'primary_key': 'True'})
        },
        'ivr.nodoivr': {
            'Meta': {'ordering': "('tono',)", 'unique_together': "(('padre', 'tono'),)", 'object_name': 'NodoIvr'},
            'extension': ('django.db.models.fields.CharField', [], {'max_length': '32', 'null': 'True', 'blank': 'True'}),
            'filename': ('django.db.models.fields.CharField', [], {'max_length': '32', 'null': 'True', 'blank': 'True'}),
            'id': ('django.db.models.fields.AutoField', [], {'primary_key': 'True'}),
            'nome': ('django.db.models.fields.CharField', [], {'max_length': '32'}),
            'padre': ('django.db.models.fields.related.ForeignKey', [], {'to': "orm['ivr.NodoIvr']", 'null': 'True', 'blank': 'True'}),
            'timeout': ('django.db.models.fields.PositiveSmallIntegerField', [], {'default': '0'}),
            'tono': ('django.db.models.fields.CharField', [], {'max_length': '1', 'null': 'True', 'blank': 'True'})
        },
        'ivr.timeslot': {
            'Meta': {'object_name': 'TimeSlot'},
            'alle_mattina': ('django.db.models.fields.TimeField', [], {}),
            'alle_pomeriggio': ('django.db.models.fields.TimeField', [], {}),
            'dalle_mattina': ('django.db.models.fields.TimeField', [], {}),
            'dalle_pomeriggio': ('django.db.models.fields.TimeField', [], {}),
            'id': ('django.db.models.fields.AutoField', [], {'primary_key': 'True'}),
            'radice': ('django.db.models.fields.related.ForeignKey', [], {'to': "orm['ivr.NodoIvr']"}),
            'weekday': ('django.db.models.fields.PositiveIntegerField', [], {'default': '0'})
        }
    }

    complete_apps = ['ivr']
