# encoding: utf-8
import datetime
from south.db import db
from south.v2 import SchemaMigration
from django.db import models

class Migration(SchemaMigration):

    def forwards(self, orm):
        
        # Deleting field 'TimeSlot.exact_day'
        db.delete_column('ivr_timeslot', 'exact_day')

        # Adding field 'TimeSlot.dal_day'
        db.add_column('ivr_timeslot', 'dal_day', self.gf('django.db.models.fields.DateField')(null=True, blank=True), keep_default=False)

        # Adding field 'TimeSlot.al_day'
        db.add_column('ivr_timeslot', 'al_day', self.gf('django.db.models.fields.DateField')(null=True, blank=True), keep_default=False)


    def backwards(self, orm):
        
        # Adding field 'TimeSlot.exact_day'
        db.add_column('ivr_timeslot', 'exact_day', self.gf('django.db.models.fields.DateField')(null=True, blank=True), keep_default=False)

        # Deleting field 'TimeSlot.dal_day'
        db.delete_column('ivr_timeslot', 'dal_day')

        # Deleting field 'TimeSlot.al_day'
        db.delete_column('ivr_timeslot', 'al_day')


    models = {
        'ivr.filenodoinregistrazione': {
            'Meta': {'object_name': 'FileNodoInRegistrazione'},
            'filename': ('django.db.models.fields.CharField', [], {'max_length': '32'}),
            'id': ('django.db.models.fields.AutoField', [], {'primary_key': 'True'})
        },
        'ivr.nodoivr': {
            'Meta': {'ordering': "('tono',)", 'unique_together': "(('padre', 'tono'),)", 'object_name': 'NodoIvr'},
            'extension': ('django.db.models.fields.CharField', [], {'max_length': '32', 'null': 'True', 'blank': 'True'}),
            'filename': ('django.db.models.fields.CharField', [], {'max_length': '32', 'null': 'True', 'blank': 'True'}),
            'id': ('django.db.models.fields.AutoField', [], {'primary_key': 'True'}),
            'nome': ('django.db.models.fields.CharField', [], {'max_length': '32'}),
            'padre': ('django.db.models.fields.related.ForeignKey', [], {'to': "orm['ivr.NodoIvr']", 'null': 'True', 'blank': 'True'}),
            'timeout': ('django.db.models.fields.PositiveSmallIntegerField', [], {'default': '0'}),
            'tono': ('django.db.models.fields.CharField', [], {'max_length': '1', 'null': 'True', 'blank': 'True'})
        },
        'ivr.timeslot': {
            'Meta': {'object_name': 'TimeSlot'},
            'al_day': ('django.db.models.fields.DateField', [], {'null': 'True', 'blank': 'True'}),
            'alle_mattina': ('django.db.models.fields.TimeField', [], {}),
            'alle_pomeriggio': ('django.db.models.fields.TimeField', [], {}),
            'attivo': ('django.db.models.fields.BooleanField', [], {'default': 'True'}),
            'dal_day': ('django.db.models.fields.DateField', [], {'null': 'True', 'blank': 'True'}),
            'dalle_mattina': ('django.db.models.fields.TimeField', [], {}),
            'dalle_pomeriggio': ('django.db.models.fields.TimeField', [], {}),
            'id': ('django.db.models.fields.AutoField', [], {'primary_key': 'True'}),
            'radice': ('django.db.models.fields.related.ForeignKey', [], {'to': "orm['ivr.NodoIvr']"}),
            'weekday': ('django.db.models.fields.PositiveIntegerField', [], {'default': '0'})
        }
    }

    complete_apps = ['ivr']
