# -*- coding: utf-8 -*-
'''
Created on 1/ago/2011

@author: simone cittadini
'''
from django.db import models
from django.utils.translation import ugettext_lazy as _


class Cdr (models.Model):
    calldate = models.DateTimeField(verbose_name=_('Date'))
    clid = models.CharField(max_length=80, verbose_name=_('Caller'),
                            help_text='Caller*ID with text')
    realsrc = models.CharField(max_length=80, verbose_name=_('Real Caller Number'),
                           help_text='Real Caller*ID number')
    src = models.CharField(max_length=80, verbose_name=_('Caller Number'),
                           help_text='Caller*ID number')
    realsrc = models.CharField(max_length=80, blank=True, null=True)
    dst = models.CharField(max_length=80, verbose_name=_('Destination'),
                           help_text='Destination extension')
    dcontext = models.CharField(max_length=80, verbose_name=_('Context'),
                                help_text='Destination context')
    channel = models.CharField(max_length=80,
                               verbose_name=_('Source Channel'),
                               help_text='Channel used')
    dstchannel = models.CharField(max_length=80,
                                  verbose_name=_('Dest. Channel'),
                                  help_text='Destination channel if appropriate'
                                  )
    lastapp = models.CharField(max_length=80,
                               verbose_name=_('Last Application'),
                               help_text='Last application if appropriate')
    lastdata = models.CharField(max_length=80,
                                verbose_name=_('Last application data'),
                                help_text='Last application data (arguments)')
    duration = models.IntegerField(verbose_name=_('Total Call Time'),
                                   help_text='Total time in system, in seconds')
    billsec = models.IntegerField(verbose_name=_('Total Call Pay Time'),
                                  help_text='Total time call is up, in seconds')
    disposition = models.CharField(max_length=80, verbose_name=_('Disposition'),
                                   help_text='What happened to the call')
    amaflags = models.IntegerField(verbose_name = '', help_text = '')
    accountcode = models.CharField(max_length = 20, verbose_name = '',
                                   help_text = '')
    userfield = models.CharField(max_length=255, verbose_name=_('User Field'),
                                 help_text='user configurable data')
    uniqueid = models.CharField(max_length=32)
    recorded_file = models.FilePathField(path='/var/spool/asterisk/monitor',
                                         blank=True, null=True)
