# -*- coding: utf-8 -*-
'''
Created on 07/apr/2011

@author: simone cittadini
'''
from django.contrib import admin
from django import forms

from models import Rotta, Terminazione, Peer

from jumbo.admin.options import ExtendibleModelAdmin
from jumbo.forms.models import AdminModelForm


class MyPeerAdminForm(AdminModelForm):
    class Meta:
        model = Peer
        exclude = ('terminazione',)
    nome_terminazione = forms.CharField(max_length=32)
    
    def __init__(self, *args, **kwargs):
        super(MyPeerAdminForm, self).__init__(*args, **kwargs)
        if 'instance' in kwargs.keys():
            self.fields['nome_terminazione'].initial = \
            kwargs['instance'].terminazione.nome

class PeerAdmin(ExtendibleModelAdmin):
    form = MyPeerAdminForm
    list_display = ('protocollo', 'address', 'get_edit_icon', 'get_delete_icon')


class MyRottaAdminForm(AdminModelForm):
    class Meta:
        model = Rotta

class RottaAdmin(ExtendibleModelAdmin):
    form = MyRottaAdminForm
    list_display = ('direttrice', 'terminazione', 'get_edit_icon',
                    'get_delete_icon')

admin.site.register(Rotta, RottaAdmin)
admin.site.register(Peer, PeerAdmin)
