import os

DEBUG = False
TEMPLATE_DEBUG = DEBUG

ADMINS = (
    ('Marco Minutoli', 'mminutoli@thundersystems.it'),
    ('Vittorino Parenti', 'vparenti@thundersystems.it'),
    ('Simone Cittadini', 'scittadini@thundersystems.it'),
)

PROJECT_PATH = os.path.dirname(os.path.realpath(__file__))

MANAGERS = ADMINS

TIME_ZONE = 'Europe/Rome'

LANGUAGE_CODE = 'it'

SITE_ID = 1

# If you set this to False, Django will make some optimizations so as not
# to load the internationalization machinery.
USE_I18N = True

# If you set this to False, Django will not format dates, numbers and
# calendars according to the current locale
USE_L10N = True

MEDIA_ROOT = ''.join([PROJECT_PATH, '/static/'])
# URL that handles the media served from MEDIA_ROOT. Make sure to use a
# trailing slash if there is a path component (optional in other cases).
# Examples: "http://media.lawrence.com", "http://example.com/media/"
MEDIA_URL = ''

# URL prefix for admin media -- CSS, JavaScript and images. Make sure to use a
# trailing slash.
# Examples: "http://foo.com/media/", "/media/".
ADMIN_MEDIA_PREFIX = '/media/'

# Make this unique, and don't share it with anybody.
SECRET_KEY = '-62c7&@(2fq13!453anpy-f5avi)%o_ab9(op*botp%s*)j4&u'

# List of callables that know how to import templates from various sources.
TEMPLATE_LOADERS = (
    'django.template.loaders.filesystem.Loader',
    'django.template.loaders.app_directories.Loader',
#     'django.template.loaders.eggs.Loader',
)

MIDDLEWARE_CLASSES = (
    'django.middleware.common.CommonMiddleware',
    'django.contrib.sessions.middleware.SessionMiddleware',
    'django.middleware.csrf.CsrfViewMiddleware',
    'django.contrib.auth.middleware.AuthenticationMiddleware',
    'django.contrib.messages.middleware.MessageMiddleware',
)

ROOT_URLCONF = 'pbx.urls'

TEMPLATE_DIRS = (
    # Put strings here, like "/home/html/django_templates" or "C:/www/django/templates".
    # Always use forward slashes, even on Windows.
    # Don't forget to use absolute paths, not relative paths.
)

INSTALLED_APPS = (
    'django.contrib.auth',
    'django.contrib.contenttypes',
    'django.contrib.sessions',
    'django.contrib.sites',
    'django.contrib.messages',
    
    'django.contrib.admin',
    
    'pbx.utenti',
    'pbx.switch',
    'pbx.reports',
    'pbx.ivr',

)

try:
    from local_settings import * #@UnusedWildImport
except ImportError:
    print "non trovo local settings"
    pass
