# -*- coding: utf-8 -*-
'''
Created on 27/gen/2012

@author: simone cittadini
'''
import sys
import threading
import httplib, urllib

import Image, ImageDraw, ImageFont

from django.http import HttpResponse, HttpResponseRedirect
from django.shortcuts import render_to_response
from django.template.loader import render_to_string
from django.db import transaction
from django.db.models import Q
from django.core.urlresolvers import reverse
from django.template.context import RequestContext

from jumbo.utils.functions import get_settings

from pbx.switch.models import Account, SERVERURL, Device
from pbx.utenti.models import EnabledCookie, BlacklistEntry


#ASTERISK_SPOOL = '/var/spool/asterisk/outgoing/'
CISCOIMAGESPATH = get_settings('pbx.switch.cisco.settings', 'CISCOIMAGESPATH')
#CISCOFONTTYPE = get_settings('switch.settings', 'CISCOFONTTYPE')
#CISCOFONTSIZE = get_settings('switch.settings', 'CISCOFONTSIZE')
CISCOFONTTYPE = '/usr/share/cups/fonts/FreeMono.ttf'
CISCOFONTSIZE = 10

POSITIONS = {1:(5, 1), 3:(5, 13), 5:(5, 25), 7:(5, 37),
             2:(135, 1), 4:(135, 13), 6:(135, 25), 8:(135, 37)}


def cisco_authentication(request):
    """
    Torna sempre "AUTHORIZED"
    """
    return HttpResponse("AUTHORIZED")

def cisco_directory(request):
    """
    Torna un XML con tutti i numeri
    """
    accounts = Account.objects.all()
    serverurl = SERVERURL
    num_account = accounts.count()
    xml = render_to_string('switch/cisco/directory.xml', locals())
    return HttpResponse(xml,  mimetype="text/xml")
    
def cisco_services(request, device_id):
    """
    Torna un XMl statico
    """
    serverurl = SERVERURL
    id = device_id
    xml = render_to_string('switch/cisco/services.xml', locals())
    return HttpResponse(xml,  mimetype="text/xml")

def cisco_services_speeddial(request, device_id):
    serverurl = SERVERURL
    id = device_id
    xml = render_to_string('switch/cisco/services/speeddial.xml', locals())
    return HttpResponse(xml, mimetype="text/xml")

def cisco_services_phonebook(request, device_id, first_index):
    serverurl = SERVERURL
    id = device_id
    accounts = Account.objects.all()
    accounts_count = accounts.count()
    next_index = int(first_index)+32
    accounts = accounts[first_index:next_index]
    xml = render_to_string('switch/cisco/services/phonebook.xml', locals())
    return HttpResponse(xml, mimetype="text/xml")

def cisco_services_phonebooksearch(request, device_id):
    serverurl = SERVERURL
    id = device_id
    xml = render_to_string('switch/cisco/services/phonebooksearch.xml', locals())
    return HttpResponse(xml, mimetype="text/xml")

def cisco_services_phonebookqs(request, device_id):
    serverurl = SERVERURL
    id = device_id
    search = request.GET['search']
    accounts = Account.objects.filter(Q(name__icontains=search) | 
                                      Q(utentepbx__nome__icontains=search))
    xml = render_to_string('switch/cisco/services/phonebookqs.xml', locals())
    return HttpResponse(xml, mimetype="text/xml")

def cisco_services_callwaiting(request, device_id):
    serverurl = SERVERURL
    id = device_id
    xml = render_to_string('switch/cisco/services/callwaiting.xml', locals())
    return HttpResponse(xml, mimetype="text/xml")

def cisco_services_queues(request, device_id):
    serverurl = SERVERURL
    id = device_id
    xml = render_to_string('switch/cisco/services/queues.xml', locals())
    return HttpResponse(xml, mimetype="text/xml")

def cisco_services_voicemail(request, device_id):
    serverurl = SERVERURL
    id = device_id
    xml = render_to_string('switch/cisco/services/voicemail.xml', locals())
    return HttpResponse(xml, mimetype="text/xml")

def cisco_services_blacklist(request, device_id):
    serverurl = SERVERURL
    id = device_id
    entries = BlacklistEntry.objects.all()
    xml = render_to_string('switch/cisco/services/blacklist.xml', locals())
    return HttpResponse(xml, mimetype="text/xml")

def cisco_services_pphonebook_search(request):
    serverurl = SERVERURL
    xml = render_to_string('switch/cisco/services/pphonebook_search.xml', locals())
    return HttpResponse(xml, mimetype="text/xml")

def cisco_services_pphonebook(request):
    serverurl = SERVERURL
    xml = render_to_string('switch/cisco/services/pphonebook.xml', locals())
    return HttpResponse(xml, mimetype="text/xml")

def cisco_services_phonebook_search(request):
    serverurl = SERVERURL
    xml = render_to_string('switch/cisco/services/phonebook_search.xml', locals())
    return HttpResponse(xml, mimetype="text/xml")

def cisco_services_iphonebook(request):
    serverurl = SERVERURL
    xml = render_to_string('switch/cisco/services/iphonebook.xml', locals())
    return HttpResponse(xml, mimetype="text/xml")

def cisco_services_blacklist_add(request):
    serverurl = SERVERURL
    xml = render_to_string('switch/cisco/services/blacklist_add.xml', locals())
    return HttpResponse(xml, mimetype="text/xml")

def cisco_services_attendant_enable(request):
    serverurl = SERVERURL
    xml = render_to_string('switch/cisco/services/attendant_enable.xml', locals())
    return HttpResponse(xml, mimetype="text/xml")

def cisco_services_attendant_disable(request):
    serverurl = SERVERURL
    xml = render_to_string('switch/cisco/services/attendant_disable.xml', locals())
    return HttpResponse(xml, mimetype="text/xml")

def cisco_services_attendant(request):
    serverurl = SERVERURL
    xml = render_to_string('switch/cisco/services/attendant.xml', locals())
    return HttpResponse(xml, mimetype="text/xml")

def cisco_services_sms(request):
    serverurl = SERVERURL
    xml = render_to_string('switch/cisco/services/sms.xml', locals())
    return HttpResponse(xml, mimetype="text/xml")


def cisco_helloworld(request):
    """
    Per prove
    """
    return HttpResponse("Hello World")

def cisco_push(request, function_name):
    """
    Scatena la push verso il cisco (per prove)
    """
    xml = { "XML" : '<CiscoIPPhoneExecute><ExecuteItem URL="%s/switch/cisco_%s/"/></CiscoIPPhoneExecute>' % (SERVERURL, function_name) }
    params = urllib.urlencode(xml)
    headers = {
               "TE": "deflate,gzip;q=0.3",
               "Connection": "TE, close",
               "Authorization": "Basic YWRtaW46Y2lzY28=",
               "User-Agent": "thunder-php-ua",
               }
    conn = httplib.HTTPConnection("172.16.2.129")
    conn.request("POST", "/CGI/Execute", params, headers)
    print >> sys.stderr, "request"
    res = conn.getresponse()
    print >> sys.stderr, "res %s" % res
    return HttpResponse(res)

def reset(request, cli):
    """
    Reset hw del cisco collegato all'account "cli"
    """
    a = Account.objects.get(name=cli)
    try:
        
        
        return HttpResponse("OK")
    except:
        return HttpResponse("KO")

def cisco_statusfile(request):
    """
    Boh
    """
    serverurl = SERVERURL
    xml = render_to_string('switch/cisco/statusfile.xml', locals())
    return HttpResponse(xml,  mimetype="text/xml")

def cisco_updatestatus_ringing(request, account_pk, cli, exten):
    """
    Ritorno il file che segna il cli come occupato a chiamare l'exten
    """
    serverurl = SERVERURL
    print >> sys.stderr, "torno xml che manda a: %s/switch/cisco_screen/%s/" % (serverurl, account_pk)
    xml = render_to_string('switch/cisco/statusupdate.xml', locals())
    return HttpResponse(xml,  mimetype="text/xml")

def cisco_updatestatus_calling(request, account_pk, cli, exten):
    """
    Ritorno il file che segna il cli come occupato in chiamata con l'exten
    """
    serverurl = SERVERURL
    print >> sys.stderr, "torno xml che manda a: %s/switch/cisco_screen/%s/" % (serverurl, account_pk)
    xml = render_to_string('switch/cisco/statusupdate.xml', locals())
    return HttpResponse(xml,  mimetype="text/xml")

def cisco_updatestatus_hanged(request, account_pk, cli, exten):
    """
    Ritorno il file che segna il cli come libero
    """
    serverurl = SERVERURL
    print >> sys.stderr, "torno xml che manda a: %s/switch/cisco_screen/%s/" % (serverurl, account_pk)
    xml = render_to_string('switch/cisco/statusupdate.xml', locals())
    return HttpResponse(xml,  mimetype="text/xml")

def cisco_restart(request):
    """
    Restart dei cisco
    """
    serverurl = SERVERURL
    xml = render_to_string('switch/cisco/restart.xml', locals())
    return HttpResponse(xml,  mimetype="text/xml")

def cisco_screen(request, account_pk):
    """
    Immagine da visualizzare sul display del cisco
    """
    a = Account.objects.get(pk=account_pk)
    u = a.utentepbx
    mostrati_attivi = []
    mostrati_free = []
    monitorati = u.utenti_monitorati.all()
    for monitorato in monitorati:
        for account in monitorato.accounts_utentepbx.all():
            if account.stato == 'calling' or account.stato == 'ringing':
                mostrati_attivi.append(account)
            else:
#                mostrati_free.append(account)
                mostrati_attivi.append(account)
#    if len(mostrati_attivi) < 8:
#        for account in mostrati_free:
#            if len(mostrati_attivi) < 8:
#                mostrati_attivi.append(account)
    img = Image.new('RGB', (252, 50), (102, 153, 204))
    imgDrawer = ImageDraw.Draw(img)
    font = ImageFont.truetype(CISCOFONTTYPE, CISCOFONTSIZE)
    for mostrato in mostrati_attivi[0:8]:
        user = mostrato.utentepbx.get_user()
        if mostrato.stato == 'free':
            fill= (153, 255, 255)
        else:
            fill = (255,255,102)
        if mostrato.stato == 'ringing':
            try:
                if mostrato.currently_calling:
                    user_label = "%s" % mostrato.currently_calling
                else:
                    user_label = "%s" % mostrato.currently_calledby
            except:
                user_label = "no name"         
        else:
            try:
                user_label = "%s %s." % (user.last_name, user.first_name[0:1])
            except:
                user_label = "no name"
        if len(user_label) > 13:
            user_label = user_label[0:13]
        txt = "%s <%s> %s" % (mostrato.stato[0:1].upper(), mostrato.name, user_label)
        imgDrawer.text(POSITIONS[mostrati_attivi.index(mostrato)+1], txt,
                       font=font, fill=fill)
    img.save("%s%s-screen.png" % (CISCOIMAGESPATH, u.pk))
        
    image = open("%s%s-screen.png" % (CISCOIMAGESPATH, u.pk), "rb").read()
    return HttpResponse(image, mimetype="image/png")
