# encoding: utf-8
import datetime
from south.db import db
from south.v2 import SchemaMigration
from django.db import models

class Migration(SchemaMigration):

    def forwards(self, orm):
        
        # Adding model 'SedeServer'
        db.create_table('switch_sedeserver', (
            ('id', self.gf('django.db.models.fields.AutoField')(primary_key=True)),
            ('nome', self.gf('django.db.models.fields.CharField')(max_length=128)),
            ('ip', self.gf('django.db.models.fields.IPAddressField')(max_length=15)),
        ))
        db.send_create_signal('switch', ['SedeServer'])

        # Adding model 'Account'
        db.create_table('switch_account', (
            ('id', self.gf('django.db.models.fields.AutoField')(primary_key=True)),
            ('utentepbx', self.gf('django.db.models.fields.related.ForeignKey')(related_name='accounts_utentepbx', to=orm['utenti.UtentePBX'])),
            ('sedeserver', self.gf('django.db.models.fields.related.ForeignKey')(blank=True, related_name='accounts_sede', null=True, to=orm['switch.SedeServer'])),
            ('stato', self.gf('django.db.models.fields.CharField')(max_length=32)),
            ('currently_calling', self.gf('django.db.models.fields.CharField')(max_length=32, null=True, blank=True)),
            ('currently_calledby', self.gf('django.db.models.fields.CharField')(max_length=32, null=True, blank=True)),
            ('name', self.gf('django.db.models.fields.CharField')(unique=True, max_length=80)),
            ('context', self.gf('django.db.models.fields.CharField')(default='from-internal', max_length=80)),
            ('callingpres', self.gf('django.db.models.fields.CharField')(default='allowed_not_screened', max_length=80)),
            ('deny', self.gf('django.db.models.fields.CharField')(max_length=95, null=True, blank=True)),
            ('permit', self.gf('django.db.models.fields.CharField')(max_length=95, null=True, blank=True)),
            ('secret', self.gf('django.db.models.fields.CharField')(max_length=80, null=True, blank=True)),
            ('md5secret', self.gf('django.db.models.fields.CharField')(max_length=80, null=True, blank=True)),
            ('remotesecret', self.gf('django.db.models.fields.CharField')(max_length=250, null=True, blank=True)),
            ('transport', self.gf('django.db.models.fields.CharField')(max_length=7, null=True, blank=True)),
            ('host', self.gf('django.db.models.fields.CharField')(default='dynamic', max_length=31)),
            ('nat', self.gf('django.db.models.fields.CharField')(default='no', max_length=5)),
            ('type', self.gf('django.db.models.fields.CharField')(default='friend', max_length=6)),
            ('accountcode', self.gf('django.db.models.fields.CharField')(max_length=20, null=True, blank=True)),
            ('amaflags', self.gf('django.db.models.fields.CharField')(max_length=13, null=True, blank=True)),
            ('callgroup', self.gf('django.db.models.fields.CharField')(default='1', max_length=10, null=True, blank=True)),
            ('callerid', self.gf('django.db.models.fields.CharField')(max_length=80, null=True, blank=True)),
            ('defaultip', self.gf('django.db.models.fields.CharField')(max_length=15, null=True, blank=True)),
            ('dtmfmode', self.gf('django.db.models.fields.CharField')(max_length=7, null=True, blank=True)),
            ('fromdomain', self.gf('django.db.models.fields.CharField')(max_length=80, null=True, blank=True)),
            ('insecure', self.gf('django.db.models.fields.CharField')(max_length=4, null=True, blank=True)),
            ('language', self.gf('django.db.models.fields.CharField')(max_length=2, null=True, blank=True)),
            ('mailbox', self.gf('django.db.models.fields.CharField')(max_length=50, null=True, blank=True)),
            ('pickupgroup', self.gf('django.db.models.fields.CharField')(default='1', max_length=10, null=True, blank=True)),
            ('qualify', self.gf('django.db.models.fields.CharField')(default='yes', max_length=3, null=True, blank=True)),
            ('regexten', self.gf('django.db.models.fields.CharField')(max_length=80, null=True, blank=True)),
            ('rtptimeout', self.gf('django.db.models.fields.CharField')(max_length=3, null=True, blank=True)),
            ('rtpholdtimeout', self.gf('django.db.models.fields.CharField')(max_length=3, null=True, blank=True)),
            ('disallow', self.gf('django.db.models.fields.CharField')(default='all', max_length=100)),
            ('allow', self.gf('django.db.models.fields.CharField')(default='alaw;', max_length=100)),
            ('fullcontact', self.gf('django.db.models.fields.CharField')(default='', max_length=80)),
            ('ipaddr', self.gf('django.db.models.fields.IPAddressField')(max_length=15, null=True, blank=True)),
            ('port', self.gf('django.db.models.fields.PositiveSmallIntegerField')(default=0)),
            ('defaultuser', self.gf('django.db.models.fields.CharField')(default='', max_length=80)),
            ('subscribecontext', self.gf('django.db.models.fields.CharField')(max_length=80, null=True, blank=True)),
            ('directmedia', self.gf('django.db.models.fields.CharField')(default='no', max_length=3)),
            ('trustrpid', self.gf('django.db.models.fields.CharField')(default='yes', max_length=3)),
            ('sendrpid', self.gf('django.db.models.fields.CharField')(default='yes', max_length=3)),
            ('progressinband', self.gf('django.db.models.fields.CharField')(default='never', max_length=5)),
            ('promiscredir', self.gf('django.db.models.fields.CharField')(default='no', max_length=3)),
            ('useclientcode', self.gf('django.db.models.fields.CharField')(default='no', max_length=3)),
            ('callcounter', self.gf('django.db.models.fields.CharField')(default='yes', max_length=3)),
            ('busylevel', self.gf('django.db.models.fields.PositiveSmallIntegerField')(default=0)),
            ('allowoverlap', self.gf('django.db.models.fields.CharField')(default='yes', max_length=3)),
            ('allowsubscribe', self.gf('django.db.models.fields.CharField')(default='yes', max_length=3)),
            ('allowtransfer', self.gf('django.db.models.fields.CharField')(default='yes', max_length=3)),
            ('ignoresdpversion', self.gf('django.db.models.fields.CharField')(default='no', max_length=3)),
            ('template', self.gf('django.db.models.fields.CharField')(max_length=100, null=True, blank=True)),
            ('videosupport', self.gf('django.db.models.fields.CharField')(default='no', max_length=6)),
            ('maxcallbitrate', self.gf('django.db.models.fields.PositiveSmallIntegerField')(default=0)),
            ('rfc2833compensate', self.gf('django.db.models.fields.CharField')(default='yes', max_length=3)),
            ('session_timers', self.gf('django.db.models.fields.CharField')(default='accept', max_length=9, db_column='session-timers')),
            ('session_expires', self.gf('django.db.models.fields.PositiveSmallIntegerField')(default=1800, db_column='session-expires')),
            ('session_minse', self.gf('django.db.models.fields.PositiveSmallIntegerField')(default=90, db_column='session-minse')),
            ('session_refresher', self.gf('django.db.models.fields.CharField')(default='uas', max_length=3, db_column='session-refresher')),
            ('t38pt_usertpsource', self.gf('django.db.models.fields.CharField')(default='no', max_length=3, db_column='t38pt-usertpsource')),
            ('outboundproxy', self.gf('django.db.models.fields.CharField')(max_length=250, null=True, blank=True)),
            ('callbackextension', self.gf('django.db.models.fields.CharField')(max_length=250, null=True, blank=True)),
            ('registertrying', self.gf('django.db.models.fields.CharField')(default='yes', max_length=3)),
            ('timert1', self.gf('django.db.models.fields.PositiveSmallIntegerField')(default=500)),
            ('timerb', self.gf('django.db.models.fields.PositiveSmallIntegerField')(default=32000)),
            ('qualifyfreq', self.gf('django.db.models.fields.PositiveSmallIntegerField')(default=120)),
            ('contactpermit', self.gf('django.db.models.fields.CharField')(max_length=250, null=True, blank=True)),
            ('contactdeny', self.gf('django.db.models.fields.CharField')(max_length=250, null=True, blank=True)),
            ('lastms', self.gf('django.db.models.fields.IntegerField')(default=0)),
            ('regserver', self.gf('django.db.models.fields.CharField')(default='0.0.0.0', max_length=100)),
            ('regseconds', self.gf('django.db.models.fields.IntegerField')(default=0)),
            ('useragent', self.gf('django.db.models.fields.CharField')(default='noone', max_length=50)),
            ('setvar', self.gf('django.db.models.fields.CharField')(max_length=128, null=True, blank=True)),
            ('fax', self.gf('django.db.models.fields.CharField')(default='no', max_length=3)),
        ))
        db.send_create_signal('switch', ['Account'])

        # Adding model 'AccountFunctions'
        db.create_table('switch_accountfunctions', (
            ('id', self.gf('django.db.models.fields.AutoField')(primary_key=True)),
            ('account', self.gf('django.db.models.fields.related.ForeignKey')(related_name='functions', unique=True, to=orm['switch.Account'])),
            ('do_not_disturb', self.gf('django.db.models.fields.BooleanField')(default=False)),
            ('call_waiting', self.gf('django.db.models.fields.BooleanField')(default=False)),
            ('voice_mail', self.gf('django.db.models.fields.BooleanField')(default=False)),
            ('forward', self.gf('django.db.models.fields.BooleanField')(default=False)),
            ('forward_number', self.gf('django.db.models.fields.CharField')(max_length=64, null=True, blank=True)),
        ))
        db.send_create_signal('switch', ['AccountFunctions'])

        # Adding model 'CallGroup'
        db.create_table('switch_callgroup', (
            ('id', self.gf('django.db.models.fields.AutoField')(primary_key=True)),
            ('exten', self.gf('django.db.models.fields.CharField')(max_length=16)),
        ))
        db.send_create_signal('switch', ['CallGroup'])

        # Adding M2M table for field accounts on 'CallGroup'
        db.create_table('switch_callgroup_accounts', (
            ('id', models.AutoField(verbose_name='ID', primary_key=True, auto_created=True)),
            ('callgroup', models.ForeignKey(orm['switch.callgroup'], null=False)),
            ('account', models.ForeignKey(orm['switch.account'], null=False))
        ))
        db.create_unique('switch_callgroup_accounts', ['callgroup_id', 'account_id'])

        # Adding model 'VoiceMail'
        db.create_table('switch_voicemail', (
            ('id', self.gf('django.db.models.fields.AutoField')(primary_key=True)),
            ('customer_id', self.gf('django.db.models.fields.CharField')(max_length=20, null=True, blank=True)),
            ('context', self.gf('django.db.models.fields.CharField')(default='voicemail', max_length=80)),
            ('mailbox', self.gf('django.db.models.fields.CharField')(max_length=80)),
            ('password', self.gf('django.db.models.fields.CharField')(max_length=80)),
            ('fullname', self.gf('django.db.models.fields.CharField')(max_length=80)),
            ('email', self.gf('django.db.models.fields.CharField')(max_length=80)),
            ('pager', self.gf('django.db.models.fields.CharField')(max_length=80, null=True, blank=True)),
            ('attach', self.gf('django.db.models.fields.CharField')(default='yes', max_length=3)),
            ('attachfmt', self.gf('django.db.models.fields.CharField')(max_length=10, null=True, blank=True)),
            ('servermail', self.gf('django.db.models.fields.CharField')(max_length=80, null=True, blank=True)),
            ('language', self.gf('django.db.models.fields.CharField')(max_length=20, null=True, blank=True)),
            ('tz', self.gf('django.db.models.fields.CharField')(max_length=30, null=True, blank=True)),
            ('deletevoicemail', self.gf('django.db.models.fields.CharField')(default='no', max_length=3)),
            ('saycid', self.gf('django.db.models.fields.CharField')(default='yes', max_length=3)),
            ('sendvoicemail', self.gf('django.db.models.fields.CharField')(default='yes', max_length=3)),
            ('review', self.gf('django.db.models.fields.CharField')(default='yes', max_length=3)),
            ('tempgreetwarn', self.gf('django.db.models.fields.CharField')(default='yes', max_length=3)),
            ('operator', self.gf('django.db.models.fields.CharField')(default='no', max_length=3)),
            ('envelope', self.gf('django.db.models.fields.CharField')(default='no', max_length=3)),
            ('sayduration', self.gf('django.db.models.fields.CharField')(default='no', max_length=3)),
            ('saydurationm', self.gf('django.db.models.fields.PositiveSmallIntegerField')(default=1)),
            ('forcename', self.gf('django.db.models.fields.CharField')(default='no', max_length=3)),
            ('forcegreetings', self.gf('django.db.models.fields.CharField')(default='no', max_length=3)),
            ('dialout', self.gf('django.db.models.fields.CharField')(max_length=20, null=True, blank=True)),
            ('callback', self.gf('django.db.models.fields.CharField')(max_length=20, null=True, blank=True)),
            ('exitcontext', self.gf('django.db.models.fields.CharField')(max_length=80, null=True, blank=True)),
            ('maxmsg', self.gf('django.db.models.fields.IntegerField')(default=32)),
            ('volgain', self.gf('django.db.models.fields.FloatField')(default='0.0')),
            ('imapuser', self.gf('django.db.models.fields.CharField')(max_length=80, null=True, blank=True)),
            ('imappassword', self.gf('django.db.models.fields.CharField')(max_length=80, null=True, blank=True)),
            ('stamp', self.gf('django.db.models.fields.DateTimeField')(auto_now_add=True, blank=True)),
        ))
        db.send_create_signal('switch', ['VoiceMail'])

        # Adding model 'Queue'
        db.create_table('switch_queue', (
            ('id', self.gf('django.db.models.fields.AutoField')(primary_key=True)),
            ('name', self.gf('django.db.models.fields.CharField')(unique=True, max_length=128)),
            ('musiconhold', self.gf('django.db.models.fields.CharField')(default='queue', max_length=128, null=True, blank=True)),
            ('announce', self.gf('django.db.models.fields.CharField')(max_length=128, null=True, blank=True)),
            ('context', self.gf('django.db.models.fields.CharField')(max_length=128, null=True, blank=True)),
            ('timeout', self.gf('django.db.models.fields.IntegerField')(default=0)),
            ('monitor_join', self.gf('django.db.models.fields.BooleanField')(default=False)),
            ('monitor_format', self.gf('django.db.models.fields.CharField')(default='wav', max_length=128)),
            ('queue_youarenext', self.gf('django.db.models.fields.CharField')(default='queue-youarenext', max_length=128, null=True, blank=True)),
            ('queue_thereare', self.gf('django.db.models.fields.CharField')(default='queue-thereare', max_length=128, null=True, blank=True)),
            ('queue_callswaiting', self.gf('django.db.models.fields.CharField')(default='queue-callswaiting', max_length=128, null=True, blank=True)),
            ('queue_holdtime', self.gf('django.db.models.fields.CharField')(default='queue-holdtime', max_length=128, null=True, blank=True)),
            ('queue_minutes', self.gf('django.db.models.fields.CharField')(default='queue-minutes', max_length=128, null=True, blank=True)),
            ('queue_seconds', self.gf('django.db.models.fields.CharField')(default='queue-seconds', max_length=128, null=True, blank=True)),
            ('queue_lessthan', self.gf('django.db.models.fields.CharField')(default='queue-lessthan', max_length=128, null=True, blank=True)),
            ('queue_thankyou', self.gf('django.db.models.fields.CharField')(default='queue-thankyou', max_length=128, null=True, blank=True)),
            ('queue_reporthold', self.gf('django.db.models.fields.CharField')(default='queue-reporthold', max_length=128, null=True, blank=True)),
            ('announce_frequency', self.gf('django.db.models.fields.IntegerField')(default=0)),
            ('announce_round_seconds', self.gf('django.db.models.fields.IntegerField')(default=0)),
            ('announce_holdtime', self.gf('django.db.models.fields.CharField')(default='yes', max_length=128)),
            ('retry', self.gf('django.db.models.fields.IntegerField')(default=0)),
            ('wrapuptime', self.gf('django.db.models.fields.IntegerField')(default=0)),
            ('maxlen', self.gf('django.db.models.fields.IntegerField')(default=0)),
            ('servicelevel', self.gf('django.db.models.fields.IntegerField')(default=0)),
            ('strategy', self.gf('django.db.models.fields.CharField')(default='ringall', max_length=128)),
            ('joinempty', self.gf('django.db.models.fields.CharField')(default='yes', max_length=128)),
            ('leavewhenempty', self.gf('django.db.models.fields.CharField')(default='no', max_length=128)),
            ('eventmemberstatus', self.gf('django.db.models.fields.BooleanField')(default=False)),
            ('eventwhencalled', self.gf('django.db.models.fields.BooleanField')(default=False)),
            ('reportholdtime', self.gf('django.db.models.fields.BooleanField')(default=False)),
            ('memberdelay', self.gf('django.db.models.fields.IntegerField')(default=0)),
            ('weight', self.gf('django.db.models.fields.IntegerField')(default=0)),
            ('timeoutrestart', self.gf('django.db.models.fields.BooleanField')(default=False)),
            ('periodic_announce', self.gf('django.db.models.fields.CharField')(max_length=50, null=True, blank=True)),
            ('periodic_announce_frequency', self.gf('django.db.models.fields.IntegerField')(default=0)),
            ('ringinuse', self.gf('django.db.models.fields.BooleanField')(default=False)),
            ('setinterfacevar', self.gf('django.db.models.fields.BooleanField')(default=False)),
        ))
        db.send_create_signal('switch', ['Queue'])

        # Adding model 'QueueMember'
        db.create_table('switch_queuemember', (
            ('uniqueid', self.gf('django.db.models.fields.AutoField')(primary_key=True)),
            ('membername', self.gf('django.db.models.fields.CharField')(max_length=40, null=True, blank=True)),
            ('queue_name', self.gf('django.db.models.fields.CharField')(max_length=128, null=True, blank=True)),
            ('interface', self.gf('django.db.models.fields.CharField')(max_length=128, null=True, blank=True)),
            ('penalty', self.gf('django.db.models.fields.IntegerField')(default=0)),
            ('paused', self.gf('django.db.models.fields.IntegerField')(default=0)),
        ))
        db.send_create_signal('switch', ['QueueMember'])

        # Adding unique constraint on 'QueueMember', fields ['queue_name', 'interface', 'membername']
        db.create_unique('switch_queuemember', ['queue_name', 'interface', 'membername'])

        # Adding model 'RecallBooking'
        db.create_table('switch_recallbooking', (
            ('id', self.gf('django.db.models.fields.AutoField')(primary_key=True)),
            ('timestamp', self.gf('django.db.models.fields.DateTimeField')(auto_now=True, blank=True)),
            ('caller', self.gf('django.db.models.fields.related.ForeignKey')(related_name='booked_recalls', to=orm['switch.Account'])),
            ('called', self.gf('django.db.models.fields.related.ForeignKey')(related_name='booked_waiting', to=orm['switch.Account'])),
        ))
        db.send_create_signal('switch', ['RecallBooking'])

        # Adding model 'MeetMe'
        db.create_table('switch_meetme', (
            ('id', self.gf('django.db.models.fields.AutoField')(primary_key=True)),
            ('confno', self.gf('django.db.models.fields.CharField')(default='0', unique=True, max_length=80)),
            ('starttime', self.gf('django.db.models.fields.DateTimeField')(default=datetime.datetime(2012, 6, 15, 11, 31, 18, 440586))),
            ('endtime', self.gf('django.db.models.fields.DateTimeField')(default=datetime.datetime(2012, 6, 15, 11, 31, 18, 440629))),
            ('pin', self.gf('django.db.models.fields.CharField')(max_length=20, null=True, blank=True)),
            ('adminpin', self.gf('django.db.models.fields.CharField')(max_length=20, null=True, blank=True)),
            ('opts', self.gf('django.db.models.fields.CharField')(max_length=20, null=True, blank=True)),
            ('adminopts', self.gf('django.db.models.fields.CharField')(max_length=20, null=True, blank=True)),
            ('recordingfilename', self.gf('django.db.models.fields.CharField')(max_length=80, null=True, blank=True)),
            ('recordingformat', self.gf('django.db.models.fields.CharField')(default='wav', max_length=10, null=True, blank=True)),
            ('maxusers', self.gf('django.db.models.fields.IntegerField')(default=0)),
        ))
        db.send_create_signal('switch', ['MeetMe'])

        # Adding model 'MeetMeUser'
        db.create_table('switch_meetmeuser', (
            ('id', self.gf('django.db.models.fields.AutoField')(primary_key=True)),
            ('meetme', self.gf('django.db.models.fields.related.ForeignKey')(to=orm['switch.MeetMe'])),
            ('login_time', self.gf('django.db.models.fields.DateTimeField')(auto_now_add=True, blank=True)),
            ('account', self.gf('django.db.models.fields.related.ForeignKey')(to=orm['switch.Account'])),
            ('number', self.gf('django.db.models.fields.IntegerField')()),
        ))
        db.send_create_signal('switch', ['MeetMeUser'])

        # Adding unique constraint on 'MeetMeUser', fields ['meetme', 'account']
        db.create_unique('switch_meetmeuser', ['meetme_id', 'account_id'])

        # Adding model 'Device'
        db.create_table('switch_device', (
            ('id', self.gf('django.db.models.fields.AutoField')(primary_key=True)),
            ('content_type', self.gf('django.db.models.fields.related.ForeignKey')(to=orm['contenttypes.ContentType'], null=True)),
            ('nome', self.gf('django.db.models.fields.CharField')(max_length=64)),
            ('mac_address', self.gf('pbx.switch.models.MACAddressField')(max_length=17)),
            ('account', self.gf('django.db.models.fields.related.ForeignKey')(to=orm['switch.Account'], null=True, blank=True)),
        ))
        db.send_create_signal('switch', ['Device'])


    def backwards(self, orm):
        
        # Removing unique constraint on 'MeetMeUser', fields ['meetme', 'account']
        db.delete_unique('switch_meetmeuser', ['meetme_id', 'account_id'])

        # Removing unique constraint on 'QueueMember', fields ['queue_name', 'interface', 'membername']
        db.delete_unique('switch_queuemember', ['queue_name', 'interface', 'membername'])

        # Deleting model 'SedeServer'
        db.delete_table('switch_sedeserver')

        # Deleting model 'Account'
        db.delete_table('switch_account')

        # Deleting model 'AccountFunctions'
        db.delete_table('switch_accountfunctions')

        # Deleting model 'CallGroup'
        db.delete_table('switch_callgroup')

        # Removing M2M table for field accounts on 'CallGroup'
        db.delete_table('switch_callgroup_accounts')

        # Deleting model 'VoiceMail'
        db.delete_table('switch_voicemail')

        # Deleting model 'Queue'
        db.delete_table('switch_queue')

        # Deleting model 'QueueMember'
        db.delete_table('switch_queuemember')

        # Deleting model 'RecallBooking'
        db.delete_table('switch_recallbooking')

        # Deleting model 'MeetMe'
        db.delete_table('switch_meetme')

        # Deleting model 'MeetMeUser'
        db.delete_table('switch_meetmeuser')

        # Deleting model 'Device'
        db.delete_table('switch_device')


    models = {
        'auth.group': {
            'Meta': {'object_name': 'Group'},
            'id': ('django.db.models.fields.AutoField', [], {'primary_key': 'True'}),
            'name': ('django.db.models.fields.CharField', [], {'unique': 'True', 'max_length': '80'}),
            'permissions': ('django.db.models.fields.related.ManyToManyField', [], {'to': "orm['auth.Permission']", 'symmetrical': 'False', 'blank': 'True'})
        },
        'auth.permission': {
            'Meta': {'ordering': "('content_type__app_label', 'content_type__model', 'codename')", 'unique_together': "(('content_type', 'codename'),)", 'object_name': 'Permission'},
            'codename': ('django.db.models.fields.CharField', [], {'max_length': '100'}),
            'content_type': ('django.db.models.fields.related.ForeignKey', [], {'to': "orm['contenttypes.ContentType']"}),
            'id': ('django.db.models.fields.AutoField', [], {'primary_key': 'True'}),
            'name': ('django.db.models.fields.CharField', [], {'max_length': '50'})
        },
        'auth.user': {
            'Meta': {'object_name': 'User'},
            'date_joined': ('django.db.models.fields.DateTimeField', [], {'default': 'datetime.datetime.now'}),
            'email': ('django.db.models.fields.EmailField', [], {'max_length': '75', 'blank': 'True'}),
            'first_name': ('django.db.models.fields.CharField', [], {'max_length': '30', 'blank': 'True'}),
            'groups': ('django.db.models.fields.related.ManyToManyField', [], {'to': "orm['auth.Group']", 'symmetrical': 'False', 'blank': 'True'}),
            'id': ('django.db.models.fields.AutoField', [], {'primary_key': 'True'}),
            'is_active': ('django.db.models.fields.BooleanField', [], {'default': 'True'}),
            'is_staff': ('django.db.models.fields.BooleanField', [], {'default': 'False'}),
            'is_superuser': ('django.db.models.fields.BooleanField', [], {'default': 'False'}),
            'last_login': ('django.db.models.fields.DateTimeField', [], {'default': 'datetime.datetime.now'}),
            'last_name': ('django.db.models.fields.CharField', [], {'max_length': '30', 'blank': 'True'}),
            'password': ('django.db.models.fields.CharField', [], {'max_length': '128'}),
            'user_permissions': ('django.db.models.fields.related.ManyToManyField', [], {'to': "orm['auth.Permission']", 'symmetrical': 'False', 'blank': 'True'}),
            'username': ('django.db.models.fields.CharField', [], {'unique': 'True', 'max_length': '30'})
        },
        'contenttypes.contenttype': {
            'Meta': {'ordering': "('name',)", 'unique_together': "(('app_label', 'model'),)", 'object_name': 'ContentType', 'db_table': "'django_content_type'"},
            'app_label': ('django.db.models.fields.CharField', [], {'max_length': '100'}),
            'id': ('django.db.models.fields.AutoField', [], {'primary_key': 'True'}),
            'model': ('django.db.models.fields.CharField', [], {'max_length': '100'}),
            'name': ('django.db.models.fields.CharField', [], {'max_length': '100'})
        },
        'profile.scprofile': {
            'Meta': {'object_name': 'SCProfile'},
            'content_type': ('django.db.models.fields.related.ForeignKey', [], {'to': "orm['contenttypes.ContentType']", 'null': 'True'}),
            'id': ('django.db.models.fields.AutoField', [], {'primary_key': 'True'}),
            'scprofiles': ('django.db.models.fields.related.ForeignKey', [], {'to': "orm['profile.SCProfiles']"})
        },
        'profile.scprofiles': {
            'Meta': {'object_name': 'SCProfiles'},
            'id': ('django.db.models.fields.AutoField', [], {'primary_key': 'True'}),
            'user': ('django.db.models.fields.related.OneToOneField', [], {'to': "orm['auth.User']", 'unique': 'True'})
        },
        'switch.account': {
            'Meta': {'ordering': "['utentepbx', 'name', 'ipaddr']", 'object_name': 'Account'},
            'accountcode': ('django.db.models.fields.CharField', [], {'max_length': '20', 'null': 'True', 'blank': 'True'}),
            'allow': ('django.db.models.fields.CharField', [], {'default': "'alaw;'", 'max_length': '100'}),
            'allowoverlap': ('django.db.models.fields.CharField', [], {'default': "'yes'", 'max_length': '3'}),
            'allowsubscribe': ('django.db.models.fields.CharField', [], {'default': "'yes'", 'max_length': '3'}),
            'allowtransfer': ('django.db.models.fields.CharField', [], {'default': "'yes'", 'max_length': '3'}),
            'amaflags': ('django.db.models.fields.CharField', [], {'max_length': '13', 'null': 'True', 'blank': 'True'}),
            'busylevel': ('django.db.models.fields.PositiveSmallIntegerField', [], {'default': '0'}),
            'callbackextension': ('django.db.models.fields.CharField', [], {'max_length': '250', 'null': 'True', 'blank': 'True'}),
            'callcounter': ('django.db.models.fields.CharField', [], {'default': "'yes'", 'max_length': '3'}),
            'callerid': ('django.db.models.fields.CharField', [], {'max_length': '80', 'null': 'True', 'blank': 'True'}),
            'callgroup': ('django.db.models.fields.CharField', [], {'default': "'1'", 'max_length': '10', 'null': 'True', 'blank': 'True'}),
            'callingpres': ('django.db.models.fields.CharField', [], {'default': "'allowed_not_screened'", 'max_length': '80'}),
            'contactdeny': ('django.db.models.fields.CharField', [], {'max_length': '250', 'null': 'True', 'blank': 'True'}),
            'contactpermit': ('django.db.models.fields.CharField', [], {'max_length': '250', 'null': 'True', 'blank': 'True'}),
            'context': ('django.db.models.fields.CharField', [], {'default': "'from-internal'", 'max_length': '80'}),
            'currently_calledby': ('django.db.models.fields.CharField', [], {'max_length': '32', 'null': 'True', 'blank': 'True'}),
            'currently_calling': ('django.db.models.fields.CharField', [], {'max_length': '32', 'null': 'True', 'blank': 'True'}),
            'defaultip': ('django.db.models.fields.CharField', [], {'max_length': '15', 'null': 'True', 'blank': 'True'}),
            'defaultuser': ('django.db.models.fields.CharField', [], {'default': "''", 'max_length': '80'}),
            'deny': ('django.db.models.fields.CharField', [], {'max_length': '95', 'null': 'True', 'blank': 'True'}),
            'directmedia': ('django.db.models.fields.CharField', [], {'default': "'no'", 'max_length': '3'}),
            'disallow': ('django.db.models.fields.CharField', [], {'default': "'all'", 'max_length': '100'}),
            'dtmfmode': ('django.db.models.fields.CharField', [], {'max_length': '7', 'null': 'True', 'blank': 'True'}),
            'fax': ('django.db.models.fields.CharField', [], {'default': "'no'", 'max_length': '3'}),
            'fromdomain': ('django.db.models.fields.CharField', [], {'max_length': '80', 'null': 'True', 'blank': 'True'}),
            'fullcontact': ('django.db.models.fields.CharField', [], {'default': "''", 'max_length': '80'}),
            'host': ('django.db.models.fields.CharField', [], {'default': "'dynamic'", 'max_length': '31'}),
            'id': ('django.db.models.fields.AutoField', [], {'primary_key': 'True'}),
            'ignoresdpversion': ('django.db.models.fields.CharField', [], {'default': "'no'", 'max_length': '3'}),
            'insecure': ('django.db.models.fields.CharField', [], {'max_length': '4', 'null': 'True', 'blank': 'True'}),
            'ipaddr': ('django.db.models.fields.IPAddressField', [], {'max_length': '15', 'null': 'True', 'blank': 'True'}),
            'language': ('django.db.models.fields.CharField', [], {'max_length': '2', 'null': 'True', 'blank': 'True'}),
            'lastms': ('django.db.models.fields.IntegerField', [], {'default': '0'}),
            'mailbox': ('django.db.models.fields.CharField', [], {'max_length': '50', 'null': 'True', 'blank': 'True'}),
            'maxcallbitrate': ('django.db.models.fields.PositiveSmallIntegerField', [], {'default': '0'}),
            'md5secret': ('django.db.models.fields.CharField', [], {'max_length': '80', 'null': 'True', 'blank': 'True'}),
            'name': ('django.db.models.fields.CharField', [], {'unique': 'True', 'max_length': '80'}),
            'nat': ('django.db.models.fields.CharField', [], {'default': "'no'", 'max_length': '5'}),
            'outboundproxy': ('django.db.models.fields.CharField', [], {'max_length': '250', 'null': 'True', 'blank': 'True'}),
            'permit': ('django.db.models.fields.CharField', [], {'max_length': '95', 'null': 'True', 'blank': 'True'}),
            'pickupgroup': ('django.db.models.fields.CharField', [], {'default': "'1'", 'max_length': '10', 'null': 'True', 'blank': 'True'}),
            'port': ('django.db.models.fields.PositiveSmallIntegerField', [], {'default': '0'}),
            'progressinband': ('django.db.models.fields.CharField', [], {'default': "'never'", 'max_length': '5'}),
            'promiscredir': ('django.db.models.fields.CharField', [], {'default': "'no'", 'max_length': '3'}),
            'qualify': ('django.db.models.fields.CharField', [], {'default': "'yes'", 'max_length': '3', 'null': 'True', 'blank': 'True'}),
            'qualifyfreq': ('django.db.models.fields.PositiveSmallIntegerField', [], {'default': '120'}),
            'regexten': ('django.db.models.fields.CharField', [], {'max_length': '80', 'null': 'True', 'blank': 'True'}),
            'registertrying': ('django.db.models.fields.CharField', [], {'default': "'yes'", 'max_length': '3'}),
            'regseconds': ('django.db.models.fields.IntegerField', [], {'default': '0'}),
            'regserver': ('django.db.models.fields.CharField', [], {'default': "'0.0.0.0'", 'max_length': '100'}),
            'remotesecret': ('django.db.models.fields.CharField', [], {'max_length': '250', 'null': 'True', 'blank': 'True'}),
            'rfc2833compensate': ('django.db.models.fields.CharField', [], {'default': "'yes'", 'max_length': '3'}),
            'rtpholdtimeout': ('django.db.models.fields.CharField', [], {'max_length': '3', 'null': 'True', 'blank': 'True'}),
            'rtptimeout': ('django.db.models.fields.CharField', [], {'max_length': '3', 'null': 'True', 'blank': 'True'}),
            'secret': ('django.db.models.fields.CharField', [], {'max_length': '80', 'null': 'True', 'blank': 'True'}),
            'sedeserver': ('django.db.models.fields.related.ForeignKey', [], {'blank': 'True', 'related_name': "'accounts_sede'", 'null': 'True', 'to': "orm['switch.SedeServer']"}),
            'sendrpid': ('django.db.models.fields.CharField', [], {'default': "'yes'", 'max_length': '3'}),
            'session_expires': ('django.db.models.fields.PositiveSmallIntegerField', [], {'default': '1800', 'db_column': "'session-expires'"}),
            'session_minse': ('django.db.models.fields.PositiveSmallIntegerField', [], {'default': '90', 'db_column': "'session-minse'"}),
            'session_refresher': ('django.db.models.fields.CharField', [], {'default': "'uas'", 'max_length': '3', 'db_column': "'session-refresher'"}),
            'session_timers': ('django.db.models.fields.CharField', [], {'default': "'accept'", 'max_length': '9', 'db_column': "'session-timers'"}),
            'setvar': ('django.db.models.fields.CharField', [], {'max_length': '128', 'null': 'True', 'blank': 'True'}),
            'stato': ('django.db.models.fields.CharField', [], {'max_length': '32'}),
            'subscribecontext': ('django.db.models.fields.CharField', [], {'max_length': '80', 'null': 'True', 'blank': 'True'}),
            't38pt_usertpsource': ('django.db.models.fields.CharField', [], {'default': "'no'", 'max_length': '3', 'db_column': "'t38pt-usertpsource'"}),
            'template': ('django.db.models.fields.CharField', [], {'max_length': '100', 'null': 'True', 'blank': 'True'}),
            'timerb': ('django.db.models.fields.PositiveSmallIntegerField', [], {'default': '32000'}),
            'timert1': ('django.db.models.fields.PositiveSmallIntegerField', [], {'default': '500'}),
            'transport': ('django.db.models.fields.CharField', [], {'max_length': '7', 'null': 'True', 'blank': 'True'}),
            'trustrpid': ('django.db.models.fields.CharField', [], {'default': "'yes'", 'max_length': '3'}),
            'type': ('django.db.models.fields.CharField', [], {'default': "'friend'", 'max_length': '6'}),
            'useclientcode': ('django.db.models.fields.CharField', [], {'default': "'no'", 'max_length': '3'}),
            'useragent': ('django.db.models.fields.CharField', [], {'default': "'noone'", 'max_length': '50'}),
            'utentepbx': ('django.db.models.fields.related.ForeignKey', [], {'related_name': "'accounts_utentepbx'", 'to': "orm['utenti.UtentePBX']"}),
            'videosupport': ('django.db.models.fields.CharField', [], {'default': "'no'", 'max_length': '6'})
        },
        'switch.accountfunctions': {
            'Meta': {'object_name': 'AccountFunctions'},
            'account': ('django.db.models.fields.related.ForeignKey', [], {'related_name': "'functions'", 'unique': 'True', 'to': "orm['switch.Account']"}),
            'call_waiting': ('django.db.models.fields.BooleanField', [], {'default': 'False'}),
            'do_not_disturb': ('django.db.models.fields.BooleanField', [], {'default': 'False'}),
            'forward': ('django.db.models.fields.BooleanField', [], {'default': 'False'}),
            'forward_number': ('django.db.models.fields.CharField', [], {'max_length': '64', 'null': 'True', 'blank': 'True'}),
            'id': ('django.db.models.fields.AutoField', [], {'primary_key': 'True'}),
            'voice_mail': ('django.db.models.fields.BooleanField', [], {'default': 'False'})
        },
        'switch.callgroup': {
            'Meta': {'object_name': 'CallGroup'},
            'accounts': ('django.db.models.fields.related.ManyToManyField', [], {'related_name': "'gruppi_di_chiamata'", 'symmetrical': 'False', 'to': "orm['switch.Account']"}),
            'exten': ('django.db.models.fields.CharField', [], {'max_length': '16'}),
            'id': ('django.db.models.fields.AutoField', [], {'primary_key': 'True'})
        },
        'switch.device': {
            'Meta': {'object_name': 'Device'},
            'account': ('django.db.models.fields.related.ForeignKey', [], {'to': "orm['switch.Account']", 'null': 'True', 'blank': 'True'}),
            'content_type': ('django.db.models.fields.related.ForeignKey', [], {'to': "orm['contenttypes.ContentType']", 'null': 'True'}),
            'id': ('django.db.models.fields.AutoField', [], {'primary_key': 'True'}),
            'mac_address': ('pbx.switch.models.MACAddressField', [], {'max_length': '17'}),
            'nome': ('django.db.models.fields.CharField', [], {'max_length': '64'})
        },
        'switch.meetme': {
            'Meta': {'object_name': 'MeetMe'},
            'adminopts': ('django.db.models.fields.CharField', [], {'max_length': '20', 'null': 'True', 'blank': 'True'}),
            'adminpin': ('django.db.models.fields.CharField', [], {'max_length': '20', 'null': 'True', 'blank': 'True'}),
            'confno': ('django.db.models.fields.CharField', [], {'default': "'0'", 'unique': 'True', 'max_length': '80'}),
            'endtime': ('django.db.models.fields.DateTimeField', [], {'default': 'datetime.datetime(2012, 6, 15, 11, 31, 18, 440629)'}),
            'id': ('django.db.models.fields.AutoField', [], {'primary_key': 'True'}),
            'maxusers': ('django.db.models.fields.IntegerField', [], {'default': '0'}),
            'opts': ('django.db.models.fields.CharField', [], {'max_length': '20', 'null': 'True', 'blank': 'True'}),
            'pin': ('django.db.models.fields.CharField', [], {'max_length': '20', 'null': 'True', 'blank': 'True'}),
            'recordingfilename': ('django.db.models.fields.CharField', [], {'max_length': '80', 'null': 'True', 'blank': 'True'}),
            'recordingformat': ('django.db.models.fields.CharField', [], {'default': "'wav'", 'max_length': '10', 'null': 'True', 'blank': 'True'}),
            'starttime': ('django.db.models.fields.DateTimeField', [], {'default': 'datetime.datetime(2012, 6, 15, 11, 31, 18, 440586)'})
        },
        'switch.meetmeuser': {
            'Meta': {'unique_together': "(('meetme', 'account'),)", 'object_name': 'MeetMeUser'},
            'account': ('django.db.models.fields.related.ForeignKey', [], {'to': "orm['switch.Account']"}),
            'id': ('django.db.models.fields.AutoField', [], {'primary_key': 'True'}),
            'login_time': ('django.db.models.fields.DateTimeField', [], {'auto_now_add': 'True', 'blank': 'True'}),
            'meetme': ('django.db.models.fields.related.ForeignKey', [], {'to': "orm['switch.MeetMe']"}),
            'number': ('django.db.models.fields.IntegerField', [], {})
        },
        'switch.queue': {
            'Meta': {'object_name': 'Queue'},
            'announce': ('django.db.models.fields.CharField', [], {'max_length': '128', 'null': 'True', 'blank': 'True'}),
            'announce_frequency': ('django.db.models.fields.IntegerField', [], {'default': '0'}),
            'announce_holdtime': ('django.db.models.fields.CharField', [], {'default': "'yes'", 'max_length': '128'}),
            'announce_round_seconds': ('django.db.models.fields.IntegerField', [], {'default': '0'}),
            'context': ('django.db.models.fields.CharField', [], {'max_length': '128', 'null': 'True', 'blank': 'True'}),
            'eventmemberstatus': ('django.db.models.fields.BooleanField', [], {'default': 'False'}),
            'eventwhencalled': ('django.db.models.fields.BooleanField', [], {'default': 'False'}),
            'id': ('django.db.models.fields.AutoField', [], {'primary_key': 'True'}),
            'joinempty': ('django.db.models.fields.CharField', [], {'default': "'yes'", 'max_length': '128'}),
            'leavewhenempty': ('django.db.models.fields.CharField', [], {'default': "'no'", 'max_length': '128'}),
            'maxlen': ('django.db.models.fields.IntegerField', [], {'default': '0'}),
            'memberdelay': ('django.db.models.fields.IntegerField', [], {'default': '0'}),
            'monitor_format': ('django.db.models.fields.CharField', [], {'default': "'wav'", 'max_length': '128'}),
            'monitor_join': ('django.db.models.fields.BooleanField', [], {'default': 'False'}),
            'musiconhold': ('django.db.models.fields.CharField', [], {'default': "'queue'", 'max_length': '128', 'null': 'True', 'blank': 'True'}),
            'name': ('django.db.models.fields.CharField', [], {'unique': 'True', 'max_length': '128'}),
            'periodic_announce': ('django.db.models.fields.CharField', [], {'max_length': '50', 'null': 'True', 'blank': 'True'}),
            'periodic_announce_frequency': ('django.db.models.fields.IntegerField', [], {'default': '0'}),
            'queue_callswaiting': ('django.db.models.fields.CharField', [], {'default': "'queue-callswaiting'", 'max_length': '128', 'null': 'True', 'blank': 'True'}),
            'queue_holdtime': ('django.db.models.fields.CharField', [], {'default': "'queue-holdtime'", 'max_length': '128', 'null': 'True', 'blank': 'True'}),
            'queue_lessthan': ('django.db.models.fields.CharField', [], {'default': "'queue-lessthan'", 'max_length': '128', 'null': 'True', 'blank': 'True'}),
            'queue_minutes': ('django.db.models.fields.CharField', [], {'default': "'queue-minutes'", 'max_length': '128', 'null': 'True', 'blank': 'True'}),
            'queue_reporthold': ('django.db.models.fields.CharField', [], {'default': "'queue-reporthold'", 'max_length': '128', 'null': 'True', 'blank': 'True'}),
            'queue_seconds': ('django.db.models.fields.CharField', [], {'default': "'queue-seconds'", 'max_length': '128', 'null': 'True', 'blank': 'True'}),
            'queue_thankyou': ('django.db.models.fields.CharField', [], {'default': "'queue-thankyou'", 'max_length': '128', 'null': 'True', 'blank': 'True'}),
            'queue_thereare': ('django.db.models.fields.CharField', [], {'default': "'queue-thereare'", 'max_length': '128', 'null': 'True', 'blank': 'True'}),
            'queue_youarenext': ('django.db.models.fields.CharField', [], {'default': "'queue-youarenext'", 'max_length': '128', 'null': 'True', 'blank': 'True'}),
            'reportholdtime': ('django.db.models.fields.BooleanField', [], {'default': 'False'}),
            'retry': ('django.db.models.fields.IntegerField', [], {'default': '0'}),
            'ringinuse': ('django.db.models.fields.BooleanField', [], {'default': 'False'}),
            'servicelevel': ('django.db.models.fields.IntegerField', [], {'default': '0'}),
            'setinterfacevar': ('django.db.models.fields.BooleanField', [], {'default': 'False'}),
            'strategy': ('django.db.models.fields.CharField', [], {'default': "'ringall'", 'max_length': '128'}),
            'timeout': ('django.db.models.fields.IntegerField', [], {'default': '0'}),
            'timeoutrestart': ('django.db.models.fields.BooleanField', [], {'default': 'False'}),
            'weight': ('django.db.models.fields.IntegerField', [], {'default': '0'}),
            'wrapuptime': ('django.db.models.fields.IntegerField', [], {'default': '0'})
        },
        'switch.queuemember': {
            'Meta': {'unique_together': "(('queue_name', 'interface', 'membername'),)", 'object_name': 'QueueMember'},
            'interface': ('django.db.models.fields.CharField', [], {'max_length': '128', 'null': 'True', 'blank': 'True'}),
            'membername': ('django.db.models.fields.CharField', [], {'max_length': '40', 'null': 'True', 'blank': 'True'}),
            'paused': ('django.db.models.fields.IntegerField', [], {'default': '0'}),
            'penalty': ('django.db.models.fields.IntegerField', [], {'default': '0'}),
            'queue_name': ('django.db.models.fields.CharField', [], {'max_length': '128', 'null': 'True', 'blank': 'True'}),
            'uniqueid': ('django.db.models.fields.AutoField', [], {'primary_key': 'True'})
        },
        'switch.recallbooking': {
            'Meta': {'ordering': "('timestamp',)", 'object_name': 'RecallBooking'},
            'called': ('django.db.models.fields.related.ForeignKey', [], {'related_name': "'booked_waiting'", 'to': "orm['switch.Account']"}),
            'caller': ('django.db.models.fields.related.ForeignKey', [], {'related_name': "'booked_recalls'", 'to': "orm['switch.Account']"}),
            'id': ('django.db.models.fields.AutoField', [], {'primary_key': 'True'}),
            'timestamp': ('django.db.models.fields.DateTimeField', [], {'auto_now': 'True', 'blank': 'True'})
        },
        'switch.sedeserver': {
            'Meta': {'object_name': 'SedeServer'},
            'id': ('django.db.models.fields.AutoField', [], {'primary_key': 'True'}),
            'ip': ('django.db.models.fields.IPAddressField', [], {'max_length': '15'}),
            'nome': ('django.db.models.fields.CharField', [], {'max_length': '128'})
        },
        'switch.voicemail': {
            'Meta': {'object_name': 'VoiceMail'},
            'attach': ('django.db.models.fields.CharField', [], {'default': "'yes'", 'max_length': '3'}),
            'attachfmt': ('django.db.models.fields.CharField', [], {'max_length': '10', 'null': 'True', 'blank': 'True'}),
            'callback': ('django.db.models.fields.CharField', [], {'max_length': '20', 'null': 'True', 'blank': 'True'}),
            'context': ('django.db.models.fields.CharField', [], {'default': "'voicemail'", 'max_length': '80'}),
            'customer_id': ('django.db.models.fields.CharField', [], {'max_length': '20', 'null': 'True', 'blank': 'True'}),
            'deletevoicemail': ('django.db.models.fields.CharField', [], {'default': "'no'", 'max_length': '3'}),
            'dialout': ('django.db.models.fields.CharField', [], {'max_length': '20', 'null': 'True', 'blank': 'True'}),
            'email': ('django.db.models.fields.CharField', [], {'max_length': '80'}),
            'envelope': ('django.db.models.fields.CharField', [], {'default': "'no'", 'max_length': '3'}),
            'exitcontext': ('django.db.models.fields.CharField', [], {'max_length': '80', 'null': 'True', 'blank': 'True'}),
            'forcegreetings': ('django.db.models.fields.CharField', [], {'default': "'no'", 'max_length': '3'}),
            'forcename': ('django.db.models.fields.CharField', [], {'default': "'no'", 'max_length': '3'}),
            'fullname': ('django.db.models.fields.CharField', [], {'max_length': '80'}),
            'id': ('django.db.models.fields.AutoField', [], {'primary_key': 'True'}),
            'imappassword': ('django.db.models.fields.CharField', [], {'max_length': '80', 'null': 'True', 'blank': 'True'}),
            'imapuser': ('django.db.models.fields.CharField', [], {'max_length': '80', 'null': 'True', 'blank': 'True'}),
            'language': ('django.db.models.fields.CharField', [], {'max_length': '20', 'null': 'True', 'blank': 'True'}),
            'mailbox': ('django.db.models.fields.CharField', [], {'max_length': '80'}),
            'maxmsg': ('django.db.models.fields.IntegerField', [], {'default': '32'}),
            'operator': ('django.db.models.fields.CharField', [], {'default': "'no'", 'max_length': '3'}),
            'pager': ('django.db.models.fields.CharField', [], {'max_length': '80', 'null': 'True', 'blank': 'True'}),
            'password': ('django.db.models.fields.CharField', [], {'max_length': '80'}),
            'review': ('django.db.models.fields.CharField', [], {'default': "'yes'", 'max_length': '3'}),
            'saycid': ('django.db.models.fields.CharField', [], {'default': "'yes'", 'max_length': '3'}),
            'sayduration': ('django.db.models.fields.CharField', [], {'default': "'no'", 'max_length': '3'}),
            'saydurationm': ('django.db.models.fields.PositiveSmallIntegerField', [], {'default': '1'}),
            'sendvoicemail': ('django.db.models.fields.CharField', [], {'default': "'yes'", 'max_length': '3'}),
            'servermail': ('django.db.models.fields.CharField', [], {'max_length': '80', 'null': 'True', 'blank': 'True'}),
            'stamp': ('django.db.models.fields.DateTimeField', [], {'auto_now_add': 'True', 'blank': 'True'}),
            'tempgreetwarn': ('django.db.models.fields.CharField', [], {'default': "'yes'", 'max_length': '3'}),
            'tz': ('django.db.models.fields.CharField', [], {'max_length': '30', 'null': 'True', 'blank': 'True'}),
            'volgain': ('django.db.models.fields.FloatField', [], {'default': "'0.0'"})
        },
        'utenti.reparto': {
            'Meta': {'object_name': 'Reparto'},
            'id': ('django.db.models.fields.AutoField', [], {'primary_key': 'True'}),
            'nome': ('django.db.models.fields.CharField', [], {'unique': 'True', 'max_length': '128'})
        },
        'utenti.utentepbx': {
            'Meta': {'ordering': "('nome',)", 'object_name': 'UtentePBX', '_ormbases': ['profile.SCProfile']},
            'is_admin': ('django.db.models.fields.BooleanField', [], {'default': 'False'}),
            'nome': ('django.db.models.fields.CharField', [], {'max_length': '64'}),
            'reparti': ('django.db.models.fields.related.ManyToManyField', [], {'blank': 'True', 'related_name': "'utentipbx'", 'null': 'True', 'symmetrical': 'False', 'to': "orm['utenti.Reparto']"}),
            'scprofile_ptr': ('django.db.models.fields.related.OneToOneField', [], {'to': "orm['profile.SCProfile']", 'unique': 'True', 'primary_key': 'True'}),
            'utenti_monitorati': ('django.db.models.fields.related.ManyToManyField', [], {'blank': 'True', 'related_name': "'osservatori'", 'null': 'True', 'symmetrical': 'False', 'to': "orm['utenti.UtentePBX']"})
        }
    }

    complete_apps = ['switch']
