# encoding: utf-8
import datetime
from south.db import db
from south.v2 import SchemaMigration
from django.db import models

class Migration(SchemaMigration):

    def forwards(self, orm):
        
        # Adding unique constraint on 'VoiceMail', fields ['mailbox']
        db.create_unique('switch_voicemail', ['mailbox'])


    def backwards(self, orm):
        
        # Removing unique constraint on 'VoiceMail', fields ['mailbox']
        db.delete_unique('switch_voicemail', ['mailbox'])


    models = {
        'auth.group': {
            'Meta': {'object_name': 'Group'},
            'id': ('django.db.models.fields.AutoField', [], {'primary_key': 'True'}),
            'name': ('django.db.models.fields.CharField', [], {'unique': 'True', 'max_length': '80'}),
            'permissions': ('django.db.models.fields.related.ManyToManyField', [], {'to': "orm['auth.Permission']", 'symmetrical': 'False', 'blank': 'True'})
        },
        'auth.permission': {
            'Meta': {'ordering': "('content_type__app_label', 'content_type__model', 'codename')", 'unique_together': "(('content_type', 'codename'),)", 'object_name': 'Permission'},
            'codename': ('django.db.models.fields.CharField', [], {'max_length': '100'}),
            'content_type': ('django.db.models.fields.related.ForeignKey', [], {'to': "orm['contenttypes.ContentType']"}),
            'id': ('django.db.models.fields.AutoField', [], {'primary_key': 'True'}),
            'name': ('django.db.models.fields.CharField', [], {'max_length': '50'})
        },
        'auth.user': {
            'Meta': {'object_name': 'User'},
            'date_joined': ('django.db.models.fields.DateTimeField', [], {'default': 'datetime.datetime.now'}),
            'email': ('django.db.models.fields.EmailField', [], {'max_length': '75', 'blank': 'True'}),
            'first_name': ('django.db.models.fields.CharField', [], {'max_length': '30', 'blank': 'True'}),
            'groups': ('django.db.models.fields.related.ManyToManyField', [], {'to': "orm['auth.Group']", 'symmetrical': 'False', 'blank': 'True'}),
            'id': ('django.db.models.fields.AutoField', [], {'primary_key': 'True'}),
            'is_active': ('django.db.models.fields.BooleanField', [], {'default': 'True'}),
            'is_staff': ('django.db.models.fields.BooleanField', [], {'default': 'False'}),
            'is_superuser': ('django.db.models.fields.BooleanField', [], {'default': 'False'}),
            'last_login': ('django.db.models.fields.DateTimeField', [], {'default': 'datetime.datetime.now'}),
            'last_name': ('django.db.models.fields.CharField', [], {'max_length': '30', 'blank': 'True'}),
            'password': ('django.db.models.fields.CharField', [], {'max_length': '128'}),
            'user_permissions': ('django.db.models.fields.related.ManyToManyField', [], {'to': "orm['auth.Permission']", 'symmetrical': 'False', 'blank': 'True'}),
            'username': ('django.db.models.fields.CharField', [], {'unique': 'True', 'max_length': '30'})
        },
        'contenttypes.contenttype': {
            'Meta': {'ordering': "('name',)", 'unique_together': "(('app_label', 'model'),)", 'object_name': 'ContentType', 'db_table': "'django_content_type'"},
            'app_label': ('django.db.models.fields.CharField', [], {'max_length': '100'}),
            'id': ('django.db.models.fields.AutoField', [], {'primary_key': 'True'}),
            'model': ('django.db.models.fields.CharField', [], {'max_length': '100'}),
            'name': ('django.db.models.fields.CharField', [], {'max_length': '100'})
        },
        'profile.scprofile': {
            'Meta': {'object_name': 'SCProfile'},
            'content_type': ('django.db.models.fields.related.ForeignKey', [], {'to': "orm['contenttypes.ContentType']", 'null': 'True'}),
            'id': ('django.db.models.fields.AutoField', [], {'primary_key': 'True'}),
            'scprofiles': ('django.db.models.fields.related.ForeignKey', [], {'to': "orm['profile.SCProfiles']"})
        },
        'profile.scprofiles': {
            'Meta': {'object_name': 'SCProfiles'},
            'id': ('django.db.models.fields.AutoField', [], {'primary_key': 'True'}),
            'user': ('django.db.models.fields.related.OneToOneField', [], {'to': "orm['auth.User']", 'unique': 'True'})
        },
        'switch.account': {
            'Meta': {'ordering': "['utentepbx', 'name', 'ipaddr']", 'object_name': 'Account'},
            'accountcode': ('django.db.models.fields.CharField', [], {'max_length': '20', 'null': 'True', 'blank': 'True'}),
            'allow': ('django.db.models.fields.CharField', [], {'default': "'alaw;'", 'max_length': '100'}),
            'allowoverlap': ('django.db.models.fields.CharField', [], {'default': "'yes'", 'max_length': '3'}),
            'allowsubscribe': ('django.db.models.fields.CharField', [], {'default': "'yes'", 'max_length': '3'}),
            'allowtransfer': ('django.db.models.fields.CharField', [], {'default': "'yes'", 'max_length': '3'}),
            'amaflags': ('django.db.models.fields.CharField', [], {'max_length': '13', 'null': 'True', 'blank': 'True'}),
            'busylevel': ('django.db.models.fields.PositiveSmallIntegerField', [], {'default': '0'}),
            'callbackextension': ('django.db.models.fields.CharField', [], {'max_length': '250', 'null': 'True', 'blank': 'True'}),
            'callcounter': ('django.db.models.fields.CharField', [], {'default': "'yes'", 'max_length': '3'}),
            'callerid': ('django.db.models.fields.CharField', [], {'max_length': '80', 'null': 'True', 'blank': 'True'}),
            'callgroup': ('django.db.models.fields.CharField', [], {'default': "'1'", 'max_length': '10', 'null': 'True', 'blank': 'True'}),
            'callingpres': ('django.db.models.fields.CharField', [], {'default': "'allowed_not_screened'", 'max_length': '80'}),
            'contactdeny': ('django.db.models.fields.CharField', [], {'max_length': '250', 'null': 'True', 'blank': 'True'}),
            'contactpermit': ('django.db.models.fields.CharField', [], {'max_length': '250', 'null': 'True', 'blank': 'True'}),
            'context': ('django.db.models.fields.CharField', [], {'default': "'from-internal'", 'max_length': '80'}),
            'currently_calledby': ('django.db.models.fields.CharField', [], {'max_length': '32', 'null': 'True', 'blank': 'True'}),
            'currently_calling': ('django.db.models.fields.CharField', [], {'max_length': '32', 'null': 'True', 'blank': 'True'}),
            'defaultip': ('django.db.models.fields.CharField', [], {'max_length': '15', 'null': 'True', 'blank': 'True'}),
            'defaultuser': ('django.db.models.fields.CharField', [], {'default': "''", 'max_length': '80'}),
            'deny': ('django.db.models.fields.CharField', [], {'max_length': '95', 'null': 'True', 'blank': 'True'}),
            'directmedia': ('django.db.models.fields.CharField', [], {'default': "'no'", 'max_length': '3'}),
            'disallow': ('django.db.models.fields.CharField', [], {'default': "'all'", 'max_length': '100'}),
            'dtmfmode': ('django.db.models.fields.CharField', [], {'max_length': '7', 'null': 'True', 'blank': 'True'}),
            'fax': ('django.db.models.fields.CharField', [], {'default': "'no'", 'max_length': '3'}),
            'fromdomain': ('django.db.models.fields.CharField', [], {'max_length': '80', 'null': 'True', 'blank': 'True'}),
            'fullcontact': ('django.db.models.fields.CharField', [], {'default': "''", 'max_length': '80'}),
            'host': ('django.db.models.fields.CharField', [], {'default': "'dynamic'", 'max_length': '31'}),
            'id': ('django.db.models.fields.AutoField', [], {'primary_key': 'True'}),
            'ignoresdpversion': ('django.db.models.fields.CharField', [], {'default': "'no'", 'max_length': '3'}),
            'insecure': ('django.db.models.fields.CharField', [], {'max_length': '4', 'null': 'True', 'blank': 'True'}),
            'ipaddr': ('django.db.models.fields.IPAddressField', [], {'max_length': '15', 'null': 'True', 'blank': 'True'}),
            'language': ('django.db.models.fields.CharField', [], {'max_length': '2', 'null': 'True', 'blank': 'True'}),
            'lastms': ('django.db.models.fields.IntegerField', [], {'default': '0'}),
            'mailbox': ('django.db.models.fields.CharField', [], {'max_length': '50', 'null': 'True', 'blank': 'True'}),
            'maxcallbitrate': ('django.db.models.fields.PositiveSmallIntegerField', [], {'default': '0'}),
            'md5secret': ('django.db.models.fields.CharField', [], {'max_length': '80', 'null': 'True', 'blank': 'True'}),
            'name': ('django.db.models.fields.CharField', [], {'unique': 'True', 'max_length': '80'}),
            'nat': ('django.db.models.fields.CharField', [], {'default': "'no'", 'max_length': '5'}),
            'outboundproxy': ('django.db.models.fields.CharField', [], {'max_length': '250', 'null': 'True', 'blank': 'True'}),
            'permit': ('django.db.models.fields.CharField', [], {'max_length': '95', 'null': 'True', 'blank': 'True'}),
            'pickupgroup': ('django.db.models.fields.CharField', [], {'default': "'1'", 'max_length': '10', 'null': 'True', 'blank': 'True'}),
            'port': ('django.db.models.fields.PositiveSmallIntegerField', [], {'default': '0'}),
            'progressinband': ('django.db.models.fields.CharField', [], {'default': "'never'", 'max_length': '5'}),
            'promiscredir': ('django.db.models.fields.CharField', [], {'default': "'no'", 'max_length': '3'}),
            'qualify': ('django.db.models.fields.CharField', [], {'default': "'yes'", 'max_length': '3', 'null': 'True', 'blank': 'True'}),
            'qualifyfreq': ('django.db.models.fields.PositiveSmallIntegerField', [], {'default': '120'}),
            'regexten': ('django.db.models.fields.CharField', [], {'max_length': '80', 'null': 'True', 'blank': 'True'}),
            'registertrying': ('django.db.models.fields.CharField', [], {'default': "'yes'", 'max_length': '3'}),
            'regseconds': ('django.db.models.fields.IntegerField', [], {'default': '0'}),
            'regserver': ('django.db.models.fields.CharField', [], {'default': "'0.0.0.0'", 'max_length': '100'}),
            'remotesecret': ('django.db.models.fields.CharField', [], {'max_length': '250', 'null': 'True', 'blank': 'True'}),
            'rfc2833compensate': ('django.db.models.fields.CharField', [], {'default': "'yes'", 'max_length': '3'}),
            'rtpholdtimeout': ('django.db.models.fields.CharField', [], {'max_length': '3', 'null': 'True', 'blank': 'True'}),
            'rtptimeout': ('django.db.models.fields.CharField', [], {'max_length': '3', 'null': 'True', 'blank': 'True'}),
            'secret': ('django.db.models.fields.CharField', [], {'max_length': '80', 'null': 'True', 'blank': 'True'}),
            'sedeserver': ('django.db.models.fields.related.ForeignKey', [], {'blank': 'True', 'related_name': "'accounts_sede'", 'null': 'True', 'to': "orm['switch.SedeServer']"}),
            'sendrpid': ('django.db.models.fields.CharField', [], {'default': "'yes'", 'max_length': '3'}),
            'session_expires': ('django.db.models.fields.PositiveSmallIntegerField', [], {'default': '1800', 'db_column': "'session-expires'"}),
            'session_minse': ('django.db.models.fields.PositiveSmallIntegerField', [], {'default': '90', 'db_column': "'session-minse'"}),
            'session_refresher': ('django.db.models.fields.CharField', [], {'default': "'uas'", 'max_length': '3', 'db_column': "'session-refresher'"}),
            'session_timers': ('django.db.models.fields.CharField', [], {'default': "'accept'", 'max_length': '9', 'db_column': "'session-timers'"}),
            'setvar': ('django.db.models.fields.CharField', [], {'max_length': '128', 'null': 'True', 'blank': 'True'}),
            'stato': ('django.db.models.fields.CharField', [], {'max_length': '32'}),
            'subscribecontext': ('django.db.models.fields.CharField', [], {'max_length': '80', 'null': 'True', 'blank': 'True'}),
            't38pt_usertpsource': ('django.db.models.fields.CharField', [], {'default': "'no'", 'max_length': '3', 'db_column': "'t38pt-usertpsource'"}),
            'template': ('django.db.models.fields.CharField', [], {'max_length': '100', 'null': 'True', 'blank': 'True'}),
            'timerb': ('django.db.models.fields.PositiveSmallIntegerField', [], {'default': '32000'}),
            'timert1': ('django.db.models.fields.PositiveSmallIntegerField', [], {'default': '500'}),
            'transport': ('django.db.models.fields.CharField', [], {'max_length': '7', 'null': 'True', 'blank': 'True'}),
            'trustrpid': ('django.db.models.fields.CharField', [], {'default': "'yes'", 'max_length': '3'}),
            'type': ('django.db.models.fields.CharField', [], {'default': "'friend'", 'max_length': '6'}),
            'useclientcode': ('django.db.models.fields.CharField', [], {'default': "'no'", 'max_length': '3'}),
            'useragent': ('django.db.models.fields.CharField', [], {'default': "'noone'", 'max_length': '50'}),
            'utentepbx': ('django.db.models.fields.related.ForeignKey', [], {'related_name': "'accounts_utentepbx'", 'to': "orm['utenti.UtentePBX']"}),
            'videosupport': ('django.db.models.fields.CharField', [], {'default': "'no'", 'max_length': '6'})
        },
        'switch.accountfunctions': {
            'Meta': {'object_name': 'AccountFunctions'},
            'account': ('django.db.models.fields.related.ForeignKey', [], {'related_name': "'functions'", 'unique': 'True', 'to': "orm['switch.Account']"}),
            'call_waiting': ('django.db.models.fields.BooleanField', [], {'default': 'False'}),
            'do_not_disturb': ('django.db.models.fields.BooleanField', [], {'default': 'False'}),
            'forward': ('django.db.models.fields.BooleanField', [], {'default': 'False'}),
            'forward_number': ('django.db.models.fields.CharField', [], {'max_length': '64', 'null': 'True', 'blank': 'True'}),
            'id': ('django.db.models.fields.AutoField', [], {'primary_key': 'True'}),
            'voice_mail': ('django.db.models.fields.BooleanField', [], {'default': 'False'})
        },
        'switch.callgroup': {
            'Meta': {'object_name': 'CallGroup'},
            'accounts': ('django.db.models.fields.related.ManyToManyField', [], {'related_name': "'gruppi_di_chiamata'", 'symmetrical': 'False', 'to': "orm['switch.Account']"}),
            'exten': ('django.db.models.fields.CharField', [], {'max_length': '16'}),
            'id': ('django.db.models.fields.AutoField', [], {'primary_key': 'True'})
        },
        'switch.device': {
            'Meta': {'object_name': 'Device'},
            'account': ('django.db.models.fields.related.ForeignKey', [], {'to': "orm['switch.Account']", 'null': 'True', 'blank': 'True'}),
            'content_type': ('django.db.models.fields.related.ForeignKey', [], {'to': "orm['contenttypes.ContentType']", 'null': 'True'}),
            'id': ('django.db.models.fields.AutoField', [], {'primary_key': 'True'}),
            'mac_address': ('pbx.switch.models.MACAddressField', [], {'max_length': '17'}),
            'nome': ('django.db.models.fields.CharField', [], {'max_length': '64'})
        },
        'switch.meetme': {
            'Meta': {'object_name': 'MeetMe'},
            'adminopts': ('django.db.models.fields.CharField', [], {'max_length': '20', 'null': 'True', 'blank': 'True'}),
            'adminpin': ('django.db.models.fields.CharField', [], {'max_length': '20', 'null': 'True', 'blank': 'True'}),
            'confno': ('django.db.models.fields.CharField', [], {'default': "'0'", 'unique': 'True', 'max_length': '80'}),
            'endtime': ('django.db.models.fields.DateTimeField', [], {'default': 'datetime.datetime(2012, 6, 15, 11, 31, 32, 852192)'}),
            'id': ('django.db.models.fields.AutoField', [], {'primary_key': 'True'}),
            'maxusers': ('django.db.models.fields.IntegerField', [], {'default': '0'}),
            'opts': ('django.db.models.fields.CharField', [], {'max_length': '20', 'null': 'True', 'blank': 'True'}),
            'pin': ('django.db.models.fields.CharField', [], {'max_length': '20', 'null': 'True', 'blank': 'True'}),
            'recordingfilename': ('django.db.models.fields.CharField', [], {'max_length': '80', 'null': 'True', 'blank': 'True'}),
            'recordingformat': ('django.db.models.fields.CharField', [], {'default': "'wav'", 'max_length': '10', 'null': 'True', 'blank': 'True'}),
            'starttime': ('django.db.models.fields.DateTimeField', [], {'default': 'datetime.datetime(2012, 6, 15, 11, 31, 32, 852151)'})
        },
        'switch.meetmeuser': {
            'Meta': {'unique_together': "(('meetme', 'account'),)", 'object_name': 'MeetMeUser'},
            'account': ('django.db.models.fields.related.ForeignKey', [], {'to': "orm['switch.Account']"}),
            'id': ('django.db.models.fields.AutoField', [], {'primary_key': 'True'}),
            'login_time': ('django.db.models.fields.DateTimeField', [], {'auto_now_add': 'True', 'blank': 'True'}),
            'meetme': ('django.db.models.fields.related.ForeignKey', [], {'to': "orm['switch.MeetMe']"}),
            'number': ('django.db.models.fields.IntegerField', [], {})
        },
        'switch.queue': {
            'Meta': {'object_name': 'Queue'},
            'announce': ('django.db.models.fields.CharField', [], {'max_length': '128', 'null': 'True', 'blank': 'True'}),
            'announce_frequency': ('django.db.models.fields.IntegerField', [], {'default': '0'}),
            'announce_holdtime': ('django.db.models.fields.CharField', [], {'default': "'yes'", 'max_length': '128'}),
            'announce_round_seconds': ('django.db.models.fields.IntegerField', [], {'default': '0'}),
            'context': ('django.db.models.fields.CharField', [], {'max_length': '128', 'null': 'True', 'blank': 'True'}),
            'eventmemberstatus': ('django.db.models.fields.BooleanField', [], {'default': 'False'}),
            'eventwhencalled': ('django.db.models.fields.BooleanField', [], {'default': 'False'}),
            'id': ('django.db.models.fields.AutoField', [], {'primary_key': 'True'}),
            'joinempty': ('django.db.models.fields.CharField', [], {'default': "'yes'", 'max_length': '128'}),
            'leavewhenempty': ('django.db.models.fields.CharField', [], {'default': "'no'", 'max_length': '128'}),
            'maxlen': ('django.db.models.fields.IntegerField', [], {'default': '0'}),
            'memberdelay': ('django.db.models.fields.IntegerField', [], {'default': '0'}),
            'monitor_format': ('django.db.models.fields.CharField', [], {'default': "'wav'", 'max_length': '128'}),
            'monitor_join': ('django.db.models.fields.BooleanField', [], {'default': 'False'}),
            'musiconhold': ('django.db.models.fields.CharField', [], {'default': "'queue'", 'max_length': '128', 'null': 'True', 'blank': 'True'}),
            'name': ('django.db.models.fields.CharField', [], {'unique': 'True', 'max_length': '128'}),
            'periodic_announce': ('django.db.models.fields.CharField', [], {'max_length': '50', 'null': 'True', 'blank': 'True'}),
            'periodic_announce_frequency': ('django.db.models.fields.IntegerField', [], {'default': '0'}),
            'queue_callswaiting': ('django.db.models.fields.CharField', [], {'default': "'queue-callswaiting'", 'max_length': '128', 'null': 'True', 'blank': 'True'}),
            'queue_holdtime': ('django.db.models.fields.CharField', [], {'default': "'queue-holdtime'", 'max_length': '128', 'null': 'True', 'blank': 'True'}),
            'queue_lessthan': ('django.db.models.fields.CharField', [], {'default': "'queue-lessthan'", 'max_length': '128', 'null': 'True', 'blank': 'True'}),
            'queue_minutes': ('django.db.models.fields.CharField', [], {'default': "'queue-minutes'", 'max_length': '128', 'null': 'True', 'blank': 'True'}),
            'queue_reporthold': ('django.db.models.fields.CharField', [], {'default': "'queue-reporthold'", 'max_length': '128', 'null': 'True', 'blank': 'True'}),
            'queue_seconds': ('django.db.models.fields.CharField', [], {'default': "'queue-seconds'", 'max_length': '128', 'null': 'True', 'blank': 'True'}),
            'queue_thankyou': ('django.db.models.fields.CharField', [], {'default': "'queue-thankyou'", 'max_length': '128', 'null': 'True', 'blank': 'True'}),
            'queue_thereare': ('django.db.models.fields.CharField', [], {'default': "'queue-thereare'", 'max_length': '128', 'null': 'True', 'blank': 'True'}),
            'queue_youarenext': ('django.db.models.fields.CharField', [], {'default': "'queue-youarenext'", 'max_length': '128', 'null': 'True', 'blank': 'True'}),
            'reportholdtime': ('django.db.models.fields.BooleanField', [], {'default': 'False'}),
            'retry': ('django.db.models.fields.IntegerField', [], {'default': '0'}),
            'ringinuse': ('django.db.models.fields.BooleanField', [], {'default': 'False'}),
            'servicelevel': ('django.db.models.fields.IntegerField', [], {'default': '0'}),
            'setinterfacevar': ('django.db.models.fields.BooleanField', [], {'default': 'False'}),
            'strategy': ('django.db.models.fields.CharField', [], {'default': "'ringall'", 'max_length': '128'}),
            'timeout': ('django.db.models.fields.IntegerField', [], {'default': '0'}),
            'timeoutrestart': ('django.db.models.fields.BooleanField', [], {'default': 'False'}),
            'weight': ('django.db.models.fields.IntegerField', [], {'default': '0'}),
            'wrapuptime': ('django.db.models.fields.IntegerField', [], {'default': '0'})
        },
        'switch.queuemember': {
            'Meta': {'unique_together': "(('queue_name', 'interface', 'membername'),)", 'object_name': 'QueueMember'},
            'interface': ('django.db.models.fields.CharField', [], {'max_length': '128', 'null': 'True', 'blank': 'True'}),
            'membername': ('django.db.models.fields.CharField', [], {'max_length': '40', 'null': 'True', 'blank': 'True'}),
            'paused': ('django.db.models.fields.IntegerField', [], {'default': '0'}),
            'penalty': ('django.db.models.fields.IntegerField', [], {'default': '0'}),
            'queue_name': ('django.db.models.fields.CharField', [], {'max_length': '128', 'null': 'True', 'blank': 'True'}),
            'uniqueid': ('django.db.models.fields.AutoField', [], {'primary_key': 'True'})
        },
        'switch.recallbooking': {
            'Meta': {'ordering': "('timestamp',)", 'object_name': 'RecallBooking'},
            'called': ('django.db.models.fields.related.ForeignKey', [], {'related_name': "'booked_waiting'", 'to': "orm['switch.Account']"}),
            'caller': ('django.db.models.fields.related.ForeignKey', [], {'related_name': "'booked_recalls'", 'to': "orm['switch.Account']"}),
            'id': ('django.db.models.fields.AutoField', [], {'primary_key': 'True'}),
            'timestamp': ('django.db.models.fields.DateTimeField', [], {'auto_now': 'True', 'blank': 'True'})
        },
        'switch.sedeserver': {
            'Meta': {'object_name': 'SedeServer'},
            'id': ('django.db.models.fields.AutoField', [], {'primary_key': 'True'}),
            'ip': ('django.db.models.fields.IPAddressField', [], {'max_length': '15'}),
            'nome': ('django.db.models.fields.CharField', [], {'max_length': '128'})
        },
        'switch.voicemail': {
            'Meta': {'object_name': 'VoiceMail'},
            'attach': ('django.db.models.fields.CharField', [], {'default': "'yes'", 'max_length': '3'}),
            'attachfmt': ('django.db.models.fields.CharField', [], {'max_length': '10', 'null': 'True', 'blank': 'True'}),
            'callback': ('django.db.models.fields.CharField', [], {'max_length': '20', 'null': 'True', 'blank': 'True'}),
            'context': ('django.db.models.fields.CharField', [], {'default': "'voicemail'", 'max_length': '80'}),
            'customer_id': ('django.db.models.fields.CharField', [], {'max_length': '20', 'null': 'True', 'blank': 'True'}),
            'deletevoicemail': ('django.db.models.fields.CharField', [], {'default': "'no'", 'max_length': '3'}),
            'dialout': ('django.db.models.fields.CharField', [], {'max_length': '20', 'null': 'True', 'blank': 'True'}),
            'email': ('django.db.models.fields.CharField', [], {'max_length': '80'}),
            'envelope': ('django.db.models.fields.CharField', [], {'default': "'no'", 'max_length': '3'}),
            'exitcontext': ('django.db.models.fields.CharField', [], {'max_length': '80', 'null': 'True', 'blank': 'True'}),
            'forcegreetings': ('django.db.models.fields.CharField', [], {'default': "'no'", 'max_length': '3'}),
            'forcename': ('django.db.models.fields.CharField', [], {'default': "'no'", 'max_length': '3'}),
            'fullname': ('django.db.models.fields.CharField', [], {'max_length': '80'}),
            'id': ('django.db.models.fields.AutoField', [], {'primary_key': 'True'}),
            'imappassword': ('django.db.models.fields.CharField', [], {'max_length': '80', 'null': 'True', 'blank': 'True'}),
            'imapuser': ('django.db.models.fields.CharField', [], {'max_length': '80', 'null': 'True', 'blank': 'True'}),
            'language': ('django.db.models.fields.CharField', [], {'max_length': '20', 'null': 'True', 'blank': 'True'}),
            'mailbox': ('django.db.models.fields.CharField', [], {'unique': 'True', 'max_length': '80'}),
            'maxmsg': ('django.db.models.fields.IntegerField', [], {'default': '32'}),
            'operator': ('django.db.models.fields.CharField', [], {'default': "'no'", 'max_length': '3'}),
            'pager': ('django.db.models.fields.CharField', [], {'max_length': '80', 'null': 'True', 'blank': 'True'}),
            'password': ('django.db.models.fields.CharField', [], {'max_length': '80'}),
            'review': ('django.db.models.fields.CharField', [], {'default': "'yes'", 'max_length': '3'}),
            'saycid': ('django.db.models.fields.CharField', [], {'default': "'yes'", 'max_length': '3'}),
            'sayduration': ('django.db.models.fields.CharField', [], {'default': "'no'", 'max_length': '3'}),
            'saydurationm': ('django.db.models.fields.PositiveSmallIntegerField', [], {'default': '1'}),
            'sendvoicemail': ('django.db.models.fields.CharField', [], {'default': "'yes'", 'max_length': '3'}),
            'servermail': ('django.db.models.fields.CharField', [], {'max_length': '80', 'null': 'True', 'blank': 'True'}),
            'stamp': ('django.db.models.fields.DateTimeField', [], {'auto_now_add': 'True', 'blank': 'True'}),
            'tempgreetwarn': ('django.db.models.fields.CharField', [], {'default': "'yes'", 'max_length': '3'}),
            'tz': ('django.db.models.fields.CharField', [], {'max_length': '30', 'null': 'True', 'blank': 'True'}),
            'volgain': ('django.db.models.fields.FloatField', [], {'default': "'0.0'"})
        },
        'utenti.reparto': {
            'Meta': {'object_name': 'Reparto'},
            'id': ('django.db.models.fields.AutoField', [], {'primary_key': 'True'}),
            'nome': ('django.db.models.fields.CharField', [], {'unique': 'True', 'max_length': '128'})
        },
        'utenti.utentepbx': {
            'Meta': {'ordering': "('nome',)", 'object_name': 'UtentePBX', '_ormbases': ['profile.SCProfile']},
            'is_admin': ('django.db.models.fields.BooleanField', [], {'default': 'False'}),
            'nome': ('django.db.models.fields.CharField', [], {'max_length': '64'}),
            'reparti': ('django.db.models.fields.related.ManyToManyField', [], {'blank': 'True', 'related_name': "'utentipbx'", 'null': 'True', 'symmetrical': 'False', 'to': "orm['utenti.Reparto']"}),
            'scprofile_ptr': ('django.db.models.fields.related.OneToOneField', [], {'to': "orm['profile.SCProfile']", 'unique': 'True', 'primary_key': 'True'}),
            'utenti_monitorati': ('django.db.models.fields.related.ManyToManyField', [], {'blank': 'True', 'related_name': "'osservatori'", 'null': 'True', 'symmetrical': 'False', 'to': "orm['utenti.UtentePBX']"})
        }
    }

    complete_apps = ['switch']
