# -*- coding: utf-8 -*-
'''
Created on 1/ago/2011

@author: simone cittadini
'''
import os, sys
import re
import httplib, urllib
import shlex
import subprocess
import time
import base64
import threading
import datetime


from lxml import etree
from django.db import models
from django.db.models.query import QuerySet
from django.utils.translation import ugettext_lazy as _
from django.forms import fields
from django.contrib.contenttypes.models import ContentType

from django.template.loader import render_to_string
import settings as local_settings

from pbx.utenti.models import UtentePBX
from pbx.switch.callfile import CallFile
from pbx.switch.callfileexceptions import NoAsteriskPermission

from south.modelsinspector import add_introspection_rules
add_introspection_rules([], ["^pbx\.switch\.models\.MACAddressField"])


ASTERISK_SPOOL = '/var/spool/asterisk/outgoing/'
SERVERURL = getattr(local_settings, 'SERVERURL')
SERVERIP = getattr(local_settings, 'SERVERIP')
#CISCOIMAGESPATH = get_settings('switch.settings', 'CISCOIMAGESPATH')
#CISCOWAITFORPUSH = get_settings('switch.settings', 'CISCOWAITFORPUSH')

PROTOCOLLI = (("SIP", "SIP"),
              ("ZAP", "ZAP"),
              ("IAX", "IAX"),
              ("323", "323"))

TYPES = (("user","user"),
         ("peer","peer"),
         ("friends","friends"))

BOOLEAN = (("yes","yes"),
           ("no","no"))

CHOICES_CALLINGPRES = (('allowed_not_screened', 'allowed_not_screened'),
                       ('allowed_passed_screen', 'allowed_passed_screen'),
                       ('allowed_failed_screen', 'allowed_failed_screen'),
                       ('allowed', 'allowed'),
                       ('prohib_not_screened', 'prohib_not_screened'),
                       ('prohib_passed_screen', 'prohib_passed_screen'),
                       ('prohib_failed_screen', 'prohib_failed_screen'),
                       ('prohib', 'prohib'),
                       ('unavailable', 'unavailable'))

CHOICES_TRANSPORT = (('tcp', 'tcp'),
                     ('udp', 'udp'))

CHOICES_TYPE = (('user', 'user'),
                ('peer', 'peer'),
                ('friend', 'friend'))

CHOICES_NAT = (('yes', 'yes'),
               ('no', 'no'))
 
CHOICES_BOOL = (('yes', 'yes'),
                ('no', 'no'))

CHOICES_BOOL_INT = ((1, 'yes'),
                (0, 'no'))

CHOICES_YNN = (('yes', 'yes'),
               ('no', 'no'),
               ('never', 'never'))

CHOICES_YNA = (('yes', 'yes'),
               ('no', 'no'),
               ('always', 'always'))

CHOICES_TIMERS = (('originate', 'originate'),
                  ('accept', 'accept'),
                  ('refuse', 'refuse'))

CHOICES_REFRESHER = (('uac', 'uac'),
                     ('uas', 'uas'))

CHOICES_ACCOUNTSTATE = (('ringing', 'ringing'), # sta squillando
                        ('calling', 'calling'), # chiamata in corso
                        ('free', 'free'),       # linea libera
                        ('dontdisturb', 'dontdisturb'), # linea libera ma non chiamabile
                        ('noreg', 'noreg'),     # nessun device registrato
                        ('called', 'called'))   # chiamata in corso (ricevente)

CHOICES_STRATEGY = (('ringall', 'ringall'),
                    #('lastrecent', 'lastrecent'),
                    #('fewestcalls', 'fewestcalls'),
                    ('random', 'casuale'),
                    ('rrordered', 'round robin'),
                    ('linear', 'consecutivo'),
                    #('wrandom', 'wrandom'),
                    #('rrmemory', 'rrmemory'),
                    )

MAC_RE = r'^([0-9a-fA-F]{2}([:-]?|$)){6}$'
mac_re = re.compile(MAC_RE)


def psse(message):
    print >> sys.stderr, message


class ThreadPredialCaller(threading.Thread):
    def __init__(self, device, called, *args, **kwargs):
        threading.Thread.__init__(self)
        self.device = device
        self.called = called
    def run(self):
        self.device.action_predial_caller(self.called)#TODO, *args, **kwargs)
        
class ThreadPredialCalled(threading.Thread):
    def __init__(self, device, caller, *args, **kwargs):
        threading.Thread.__init__(self)
        self.device = device
        self.caller = caller
    def run(self):
        self.device.action_predial_called(self.caller)#TODO, *args, **kwargs)
        
class ThreadPredialMonitoring(threading.Thread):
    def __init__(self, device, account, *args, **kwargs):
        threading.Thread.__init__(self)
        self.device = device
        self.account = account
    def run(self):
        self.device.action_predial_monitoring(self.account)#TODO, *args, **kwargs)
        
class ThreadPredialMonitored(threading.Thread):
    def __init__(self, device, account, *args, **kwargs):
        threading.Thread.__init__(self)
        self.device = device
        self.account = account
    def run(self):
        self.device.action_predial_monitored(self.account)#TODO, *args, **kwargs)
        
class ThreadAnswerCaller(threading.Thread):
    def __init__(self, device, called, *args, **kwargs):
        threading.Thread.__init__(self)
        self.device = device
        self.called = called
    def run(self):
        self.device.action_answer_caller(self.called)#TODO, *args, **kwargs)
        
class ThreadAnswerCalled(threading.Thread):
    def __init__(self, device, caller, *args, **kwargs):
        threading.Thread.__init__(self)
        self.device = device
        self.caller = caller
    def run(self):
        self.device.action_answer_called(self.caller)#TODO, *args, **kwargs)
        
class ThreadAnswerMonitoring(threading.Thread):
    def __init__(self, device, account, *args, **kwargs):
        threading.Thread.__init__(self)
        self.device = device
        self.account = account
    def run(self):
        self.device.action_answer_monitoring(self.account)#TODO, *args, **kwargs)
        
class ThreadAnswerMonitored(threading.Thread):
    def __init__(self, device, account, *args, **kwargs):
        threading.Thread.__init__(self)
        self.device = device
        self.account = account
    def run(self):
        self.device.action_answer_monitored(self.account)#TODO, *args, **kwargs) 
        
class ThreadPostdialCaller(threading.Thread):
    def __init__(self, device, called, *args, **kwargs):
        threading.Thread.__init__(self)
        self.device = device
        self.called = called
    def run(self):
        self.device.action_postdial_caller(self.called)#TODO, *args, **kwargs)
        
class ThreadPostdialCalled(threading.Thread):
    def __init__(self, device, caller, *args, **kwargs):
        threading.Thread.__init__(self)
        self.device = device
        self.caller = caller
    def run(self):
        self.device.action_postdial_called(self.caller)#TODO, *args, **kwargs)
        
class ThreadPostdialMonitoring(threading.Thread):
    def __init__(self, device, account, *args, **kwargs):
        threading.Thread.__init__(self)
        self.device = device
        self.account = account
    def run(self):
        self.device.action_postdial_monitoring(self.account)#TODO,CHOICES_NAT *args, **kwargs)
        
class ThreadPostdialMonitored(threading.Thread):
    def __init__(self, device, account, *args, **kwargs):
        threading.Thread.__init__(self)
        self.device = device
        self.account = account
    def run(self):
        self.device.action_postdial_monitored(self.account)#TODO, *args, **kwargs) 

        
class ThreadAstReload(threading.Thread):
    def __init__(self):
        threading.Thread.__init__(self)
        print >> sys.stderr, "init account save thread"
    def run(self):
        exit_status = subprocess.call(["asterisk", "-rx" "sip reload"])
        print >> sys.stderr, "fine run account save thread: %s" % exit_status


class MACAddressFormField(fields.RegexField):
    default_error_messages = {
        'invalid': _(u'Enter a valid MAC address.'),
    }

    def __init__(self, *args, **kwargs):
        super(MACAddressFormField, self).__init__(mac_re, *args, **kwargs)
        
class MACAddressField(models.Field):
    
    description = "A CharField accepting only strings valid as mac addresses"
    
    def __init__(self, *args, **kwargs):
        kwargs['max_length'] = 17
        super(MACAddressField, self).__init__(*args, **kwargs)

    def get_internal_type(self):
        return "CharField"

    def formfield(self, **kwargs):
        defaults = {'form_class': MACAddressFormField}
        defaults.update(kwargs)
        return super(MACAddressField, self).formfield(**defaults)

        
class SedeServer(models.Model):
    nome = models.CharField(max_length=128)
    ip = models.IPAddressField()
    
    def __unicode__(self):
        return self.nome
    
    class Meta:
        verbose_name_plural = 'Sedi Server'

class Account(models.Model):
    utentepbx = models.ForeignKey(UtentePBX, related_name='accounts_utentepbx',
                                  null=True, blank=True)
    sedeserver = models.ForeignKey(SedeServer, null=True, blank=True,
                                   editable=False, related_name='accounts_sede')
    stato = models.CharField(max_length=32, choices=CHOICES_ACCOUNTSTATE)
    currently_calling = models.CharField(max_length=32, null=True, blank=True)
    currently_calledby = models.CharField(max_length=32, null=True, blank=True)

    name = models.CharField(max_length=80, unique=True,
                            verbose_name = _('Number'),)
    context = models.CharField(max_length=80, default='from-internal')
    callingpres = models.CharField(max_length=80, choices=CHOICES_CALLINGPRES,
                                   default='allowed_not_screened')
    deny = models.CharField(max_length=95, null=True, blank=True) 
    permit = models.CharField(max_length=95, null=True, blank=True)
    secret = models.CharField(max_length=80, null=True, blank=True)
    md5secret = models.CharField(max_length=80, null=True, blank=True)
    remotesecret = models.CharField(max_length=250, null=True, blank=True)
    transport = models.CharField(max_length=7, choices=CHOICES_TRANSPORT,
                                 null=True, blank=True)
    host = models.CharField(max_length=31, default='dynamic')
    nat = models.CharField(max_length=5, default='no', choices=CHOICES_NAT)
    type = models.CharField(max_length=6, choices=CHOICES_TYPE,
                            default='friend')
    accountcode = models.CharField(max_length=20, null=True, blank=True)
    amaflags =  models.CharField(max_length=13, null=True, blank=True) 
    callgroup = models.CharField(max_length=10, default='1',
                                 null=True, blank=True)
    callerid =  models.CharField(max_length=80, null=True, blank=True) 
    defaultip = models.CharField(max_length=15, null=True, blank=True)
    dtmfmode = models.CharField(max_length=7, null=True, blank=True)
#    fromuser = models.CharField(max_length=80, null=True, blank=True)
    fromdomain =  models.CharField(max_length=80, null=True, blank=True)
    insecure = models.CharField(max_length=4, null=True, blank=True)
    language = models.CharField(max_length=2, null=True, blank=True)
    mailbox = models.CharField(max_length=50, null=True, blank=True)
    pickupgroup = models.CharField(max_length=10, default='1',
                                   null=True, blank=True)
    qualify = models.CharField(max_length=3, null=True, blank=True,
                               default='yes')
    regexten =  models.CharField(max_length=80, null=True, blank=True)
    rtptimeout = models.CharField(max_length=3, null=True, blank=True)
    rtpholdtimeout = models.CharField(max_length=3, null=True, blank=True)
    setvar =  models.CharField(max_length=100, null=True, blank=True)
    disallow =  models.CharField(max_length=100, default='all')
    allow =  models.CharField(max_length=100, default='alaw;')
    fullcontact = models.CharField(max_length=80, default='')
    ipaddr = models.IPAddressField(null=True, blank=True)
    port = models.PositiveSmallIntegerField(default=0)
    defaultuser = models.CharField(max_length=80, default='')
    subscribecontext = models.CharField(max_length=80, null=True, blank=True)
    directmedia = models.CharField(max_length=3, default='no',
                                   choices=CHOICES_BOOL)
    trustrpid = models.CharField(max_length=3, default='yes',
                                 choices=CHOICES_BOOL)
    sendrpid = models.CharField(max_length=3, default='yes',
                                choices=CHOICES_BOOL)
    progressinband = models.CharField(max_length=5, default='never',
                                      choices=CHOICES_YNN)
    promiscredir = models.CharField(max_length=3, default='no',
                                    choices=CHOICES_BOOL) 
    useclientcode = models.CharField(max_length=3, default='no',
                                     choices=CHOICES_BOOL)
    callcounter = models.CharField(max_length=3, default='yes',
                                   choices=CHOICES_BOOL)
    busylevel = models.PositiveSmallIntegerField(default=0)
    allowoverlap = models.CharField(max_length=3, default='yes',
                                    choices=CHOICES_BOOL)
    allowsubscribe = models.CharField(max_length=3, default='yes',
                                      choices=CHOICES_BOOL)
    allowtransfer = models.CharField(max_length=3, default='yes',
                                     choices=CHOICES_BOOL)
    ignoresdpversion = models.CharField(max_length=3, default='no',
                                        choices=CHOICES_BOOL)
    template = models.CharField(max_length=100, null=True, blank=True)
    videosupport = models.CharField(max_length=6, default='no',
                                    choices=CHOICES_YNA)
    maxcallbitrate = models.PositiveSmallIntegerField(default=0)
    rfc2833compensate = models.CharField(max_length=3, default='yes',
                                         choices=CHOICES_BOOL)
    session_timers = models.CharField(max_length=9, default='accept',
                                      choices=CHOICES_TIMERS,
                                      db_column='session-timers')
    session_expires = models.PositiveSmallIntegerField(default=1800,
                                                    db_column='session-expires')
    session_minse = models.PositiveSmallIntegerField(default=90,
                                                     db_column='session-minse')
    session_refresher = models.CharField(max_length=3, default='uas',
                                         choices=CHOICES_REFRESHER,
                                         db_column='session-refresher')
    t38pt_usertpsource = models.CharField(max_length=3, default='no',
                                          choices=CHOICES_BOOL,
                                          db_column='t38pt-usertpsource')
    outboundproxy = models.CharField(max_length=250, null=True, blank=True)
    callbackextension = models.CharField(max_length=250, null=True, blank=True)
    registertrying = models.CharField(max_length=3, default='yes',
                                      choices=CHOICES_BOOL)
    timert1 = models.PositiveSmallIntegerField(default=500)
    timerb = models.PositiveSmallIntegerField(default=32000)
    qualifyfreq = models.PositiveSmallIntegerField(default=120)
    contactpermit = models.CharField(max_length=250, null=True, blank=True)
    contactdeny = models.CharField(max_length=250, null=True, blank=True)
    lastms = models.IntegerField(default=0)
    regserver = models.CharField(max_length=100, default='0.0.0.0')
    regseconds = models.IntegerField(default=0)
    useragent = models.CharField(max_length=50, default='noone')
    
    setvar = models.CharField(max_length=128, null=True, blank=True)
    fax = models.CharField(max_length=3, default='no', choices=CHOICES_BOOL)

    class Meta:
        ordering = ['utentepbx', 'name', 'ipaddr']
        
    def __unicode__(self):
        return "%s - %s" % (self.utentepbx, self.name)
        
    def save(self, *args, **kwargs):
        
        if self.pk == None:
            self.stato = 'free'
        if self.callerid == None or self.callerid == '':
            try:
                self.callerid = "\"%s %s.\" <%s>" % (self.utentepbx.get_user().last_name,
                                                     self.utentepbx.get_user().first_name[0:1],
                                                     self.name)
            except Exception, e:
                print >> sys.stderr, "Exception in Account.save: %s" % str(e)
                self.callerid = self.name
        self.defaultuser = self.name
        self.mailbox = self.name
        oldname = 'oldname'
        if self.pk:
            oldname = Account.objects.get(pk=self.pk).name
        super(Account, self).save(*args, **kwargs)
        try:
            if oldname != self.name:
                t = ThreadAstReload()
                t.start()
        except:
            pass
        AccountFunctions.objects.get_or_create(account=self)
        VoiceMail.objects.get_or_create(mailbox=self.name, defaults={
                                        'password' : self.name,
                                        'fullname' : str(self.utentepbx),
                                        'email' : self.utentepbx.get_user().email})
        
            
    @property
    def do_not_disturb(self):
        return AccountFunctions.objects.get(account=self).do_not_disturb
    
    @property
    def voice_mail(self):
        return AccountFunctions.objects.get(account=self).voice_mail
    
    @property
    def call_waiting(self):
        return AccountFunctions.objects.get(account=self).call_waiting
    
    @property
    def forward(self):
        return AccountFunctions.objects.get(account=self).forward
    
    @property
    def forward_number(self):
        return AccountFunctions.objects.get(account=self).forward_number

    def action_predial_caller(self, called, *args, **kwargs):
        """
        Azione da compiere prima della chiamata se si è il chiamante.
        """
        psse('%s.action_predial_caller: called:%s' % (self, called))
        psse("\tstato/calling/called\n \tfrom %s/%s/%s" % \
             (self.stato, self.currently_calling, self.currently_calledby))
        self.stato = 'calling'
        self.currently_calledby = None
        self.currently_calling = called
        self.save()
        psse("\tto %s/%s/%s" % \
             (self.stato, self.currently_calling, self.currently_calledby))
        for d in Device.objects.filter(account__exact=self):
            t = ThreadPredialCaller(d, called, *args, **kwargs)
            t.start()
        VoiceMail.objects.get_or_create(mailbox=self.name, password=self.name,
                                        fullname=str(self.utentepbx),
                                        email=self.utentepbx.get_user().email)
#        AccountFunctions.objects.get_or_create()
        
#class AccountFunctions(models.Model):
#    account = models.ForeignKey(Account, unique=True, related_name='functions')
#    do_not_disturb = models.BooleanField(default=False)
#    call_waiting = models.BooleanField(default=False)
#    voice_mail = models.BooleanField(default=False)
#    forward = models.BooleanField(default=False)
#    forward_number = models.CharField(max_length=64, null=True, blank=True)
    
#    def __unicode__(self):
#        return str(self.account)

    def action_predial_called(self, caller, *args, **kwargs):
        """
        Azione da compiere prima della chiamata se si è il chiamato.
        """
        psse('%s.action_predial_called: caller:%s' % (self, caller))
        psse("\tstato/calling/called\n \tfrom %s/%s/%s" % \
             (self.stato, self.currently_calling, self.currently_calledby))
        if self.stato == 'free':
            self.stato = 'ringing'
            self.currently_calledby = caller
            self.currently_calling = None
            self.save()
        psse("\tto %s/%s/%s" % \
             (self.stato, self.currently_calling, self.currently_calledby))
        for d in Device.objects.filter(account__exact=self):
            t = ThreadPredialCalled(d, caller, *args, **kwargs)
            t.start()
            
    def action_predial_monitoring(self, account, *args, **kwargs):
        """
        Azione da compiere se sono fra i monitoranti di un account in predial.
        """
        psse('%s.action_predial_monitoring: account:%s' % (self, account))
        for d in Device.objects.filter(account__exact=self):
            d.action_predial_monitoring(account, *args, **kwargs)
            
            
    def action_predial_monitored(self, account, *args, **kwargs):
        """
        Azione da compiere se sono fra i monitorati di un account in predial.
        """
        psse('%s.action_predial_monitored: account:%s' % (self, account))
        for d in Device.objects.filter(account__exact=self):
            d.action_predial_monitored(account, *args, **kwargs)

    def action_answer_caller(self, called, *args, **kwargs):
        """
        Azione da compiere all'answer se si è il chiamante.
        """
        psse('%s.action_answer_caller: called:%s' % (self, called))
        psse("\tstato/calling/called\n \tfrom %s/%s/%s" % \
             (self.stato, self.currently_calling, self.currently_calledby))
        self.stato = 'calling'
        self.currently_calledby = None
        self.currently_calling = called
        self.save()    
        psse("\tto %s/%s/%s" % \
             (self.stato, self.currently_calling, self.currently_calledby))
        for d in Device.objects.filter(account__exact=self):
            d.action_answer_caller(called, *args, **kwargs)
        
    def action_answer_called(self, caller, *args, **kwargs):
        """
        Azione da compiere all'answer se si è il chiamato.
        """
        psse('%s.action_answer_called: caller:%s' % (self, caller))
        psse("\tstato/calling/called\n \tfrom %s/%s/%s" % \
             (self.stato, self.currently_calling, self.currently_calledby))
        self.stato = 'calling'
        self.currently_calledby = caller
        self.currently_calling = None
        self.save()
        psse("\tto %s/%s/%s" % \
             (self.stato, self.currently_calling, self.currently_calledby))
        for d in Device.objects.filter(account__exact=self):
            d.action_answer_called(caller, *args, **kwargs)
            
    def action_answer_monitoring(self, account, *args, **kwargs):
        """
        Azione da compiere se sono fra i monitoranti di un account in answer.
        """
        psse('%s.action_answer_monitoring: account:%s' % (self, account))
        for d in Device.objects.filter(account__exact=self):
            d.action_answer_monitoring(account, *args, **kwargs)
            
            
    def action_answer_monitored(self, account, *args, **kwargs):
        """
        Azione da compiere se sono fra i monitorati di un account in answer.
        """
        psse('%s.action_answer_monitored: account:%s' % (self, account))
        for d in Device.objects.filter(account__exact=self):
            d.action_answer_monitored(account, *args, **kwargs)
        
    def action_postdial_caller(self, called, *args, **kwargs):
        """
        Azione da compiere all'hangup se si è il chiamante.
        """
        psse('%s.action_postdial_caller: called%s' % (self, called))
        psse("\tstato/calling/called\n \tfrom %s/%s/%s" % \
             (self.stato, self.currently_calling, self.currently_calledby))
        if self.currently_calling == called:
            self.stato = 'free'
            self.currently_calledby = None
            self.currently_calling = None
            self.save()    
        psse("\tto %s/%s/%s" % \
             (self.stato, self.currently_calling, self.currently_calledby))
        for d in Device.objects.filter(account__exact=self):
            d.action_postdial_caller(called, *args, **kwargs)

    def action_postdial_called(self, caller, *args, **kwargs):
        """
        Azione da compiere all'hangup se si è il chiamato.
        """
        psse('%s.action_postdial_called: caller:%s' % (self, caller))
        psse("\tstato/calling/called\n \tfrom %s/%s/%s" % \
             (self.stato, self.currently_calling, self.currently_calledby))
        if self.currently_calledby == caller:
            self.stato = 'free'
            self.currently_calledby = None
            self.currently_calling = None
            self.save()
        psse("\tto %s/%s/%s" % \
             (self.stato, self.currently_calling, self.currently_calledby))
        for d in Device.objects.filter(account__exact=self):
            d.action_postdial_called(caller, *args, **kwargs)
   
    def action_postdial_monitoring(self, account, *args, **kwargs):
        """
        Azione da compiere se sono fra i monitoranti di un account in postdial.
        """
        psse('%s.action_postdial_monitoring: account:%s' % (self, account))
        for d in Device.objects.filter(account__exact=self):
            d.action_postdial_monitoring(account, *args, **kwargs)
            
            
    def action_postdial_monitored(self, account, *args, **kwargs):
        """
        Azione da compiere se sono fra i monitorati di un account in postdial.
        """
        psse('%s.action_postdial_monitored: account:%s' % (self, account))
        for d in Device.objects.filter(account__exact=self):
            d.action_postdial_monitored(account, *args, **kwargs)
            
class AccountFunctions(models.Model):
    account = models.ForeignKey(Account, unique=True, related_name='functions')
    do_not_disturb = models.BooleanField(default=False)
    call_waiting = models.BooleanField(default=False)
    voice_mail = models.BooleanField(default=False)
    forward = models.BooleanField(default=False)
    forward_number = models.CharField(max_length=64, null=True, blank=True)
    
    class Meta:
        verbose_name = "Funzioni dell'Account"
        verbose_name_plural = "Funzioni degli Account"
    
    def __unicode__(self):
        return str(self.account)
    
    def save(self, *args, **kwargs):
        old_dnd = False
        if self.pk:
            old_dnd = AccountFunctions.objects.get(pk=self.pk).do_not_disturb
        super(AccountFunctions, self).save(*args, **kwargs)
        if self.do_not_disturb == False and old_dnd == True:
            RecallBooking.recall(self.account)
    
class CallGroup(models.Model):
    exten = models.CharField(max_length=16)
    accounts = models.ManyToManyField(Account, related_name='gruppi_di_chiamata')
    
    def __unicode__(self):
        return self.exten
    
    def save(self, *args, **kwargs):
        super(CallGroup, self).save(*args, **kwargs)
        VoiceMail.objects.get_or_create(mailbox=self.exten, password=self.exten,
                                        fullname="callgroup %s" % self.exten,
                                        email="")
        
    def get_other_members(self, account_id):
        return self.accounts.exclude(pk__exact=account_id)
    
class VoiceMail(models.Model):
    customer_id = models.CharField(max_length=20, blank=True, null=True, editable=False)
    context = models.CharField(max_length=80, default='voicemail', editable=False)
    mailbox = models.CharField(max_length=80, unique=True, editable=False)
    password = models.CharField(max_length=80)
    fullname = models.CharField(max_length=80, editable=False)
    email = models.CharField(max_length=80, editable=False)
    pager = models.CharField(max_length=80, blank=True, null=True, editable=False)
    tz = models.CharField(max_length=10, default='central', editable=False)
    attach = models.CharField(max_length=3, choices=CHOICES_BOOL, default='yes')
    attachfmt = models.CharField(max_length=10, blank=True, null=True, editable=False)
    servermail = models.CharField(max_length=80, blank=True, null=True, editable=False)
    language = models.CharField(max_length=20, blank=True, null=True, editable=False)
    deletevoicemail = models.CharField(max_length=3, choices=CHOICES_BOOL, default='no')
    saycid = models.CharField(max_length=3, choices=CHOICES_BOOL, default='yes', editable=False)
    sendvoicemail = models.CharField(max_length=3, choices=CHOICES_BOOL, default='yes')
    review = models.CharField(max_length=3, choices=CHOICES_BOOL, default='yes', editable=False)
    tempgreetwarn = models.CharField(max_length=3, choices=CHOICES_BOOL, default='yes', editable=False)
    operator = models.CharField(max_length=3, choices=CHOICES_BOOL, default='no', editable=False)
    envelope = models.CharField(max_length=3, choices=CHOICES_BOOL, default='no', editable=False)
    sayduration = models.CharField(max_length=3, choices=CHOICES_BOOL, default='no', editable=False)
    saydurationm = models.PositiveSmallIntegerField(default=1, editable=False)
    forcename = models.CharField(max_length=3, choices=CHOICES_BOOL, default='no', editable=False)
    forcegreetings = models.CharField(max_length=3, choices=CHOICES_BOOL, default='no', editable=False)
    dialout = models.CharField(max_length=20, blank=True, null=True, editable=False)
    callback = models.CharField(max_length=20, blank=True, null=True, editable=False)
    exitcontext = models.CharField(max_length=80, blank=True, null=True, editable=False)
    maxmsg = models.IntegerField(default=32, editable=False)
    volgain = models.FloatField(default='0.0', editable=False)
    imapuser  = models.CharField(max_length=80, blank=True, null=True, editable=False)
    imappassword  = models.CharField(max_length=80, blank=True, null=True, editable=False)
    stamp = models.DateTimeField(auto_now_add=True, editable=False)
    
    def __unicode__(self):
        return self.fullname
    
class Queue(models.Model):
    name = models.CharField(max_length=128, unique=True, verbose_name='numero')
    musiconhold = models.CharField(max_length=128, null=True, blank=True, default='queue')
    announce = models.CharField(max_length=128, editable=False, null=True, blank=True)
    context = models.CharField(max_length=128, editable=False, null=True, blank=True)
    timeout = models.IntegerField(default=0)
    monitor_join = models.BooleanField(default=False, editable=False)
    monitor_format = models.CharField(max_length=128, editable=False, default='wav')
    queue_youarenext = models.CharField(max_length=128, editable=False, default='queue-youarenext', null=True, blank=True)
    queue_thereare = models.CharField(max_length=128, editable=False, default='queue-thereare', null=True, blank=True)
    queue_callswaiting = models.CharField(max_length=128, editable=False, default='queue-callswaiting', null=True, blank=True)
    queue_holdtime = models.CharField(max_length=128, editable=False, default='queue-holdtime', null=True, blank=True)
    queue_minutes = models.CharField(max_length=128, editable=False, default='queue-minutes', null=True, blank=True)
    queue_seconds = models.CharField(max_length=128, editable=False, default='queue-seconds', null=True, blank=True)
    queue_lessthan = models.CharField(max_length=128, editable=False, default='queue-lessthan', null=True, blank=True)
    queue_thankyou = models.CharField(max_length=128, editable=False, default='queue-thankyou', null=True, blank=True)
    queue_reporthold = models.CharField(max_length=128, editable=False, default='queue-reporthold', null=True, blank=True)
    announce_frequency = models.IntegerField(default=0)
    announce_round_seconds = models.IntegerField(default=0, editable=False)
    announce_holdtime = models.CharField(max_length=128, choices=BOOLEAN, default='yes')
    retry = models.IntegerField(default=0)
    wrapuptime = models.IntegerField(default=0, editable=False)
    maxlen = models.IntegerField(default=0, editable=False)
    servicelevel = models.IntegerField(default=0, editable=False)
    strategy = models.CharField(max_length=128, choices=CHOICES_STRATEGY, default='ringall')
    joinempty = models.CharField(max_length=128, editable=False, default='yes')
    leavewhenempty = models.CharField(max_length=128, editable=False, default='no')
    eventmemberstatus = models.BooleanField(default=False, editable=False)
    eventwhencalled = models.BooleanField(default=False, editable=False)
    reportholdtime = models.BooleanField(default=False, editable=False)
    memberdelay = models.IntegerField(default=0, editable=False)
    weight = models.IntegerField(default=0, editable=False)
    timeoutrestart = models.BooleanField(default=False, editable=False)
    periodic_announce = models.CharField(max_length=50, null=True, blank=True)
    periodic_announce_frequency = models.IntegerField(default=0)
    ringinuse = models.BooleanField(default=False, editable=False)
    setinterfacevar = models.BooleanField(default=False, editable=False)
    
    class Meta:
        verbose_name = 'Coda'
        verbose_name_plural = 'Code'
    
class QueueMember(models.Model):
    uniqueid = models.AutoField(primary_key=True, editable=False)
    membername = models.CharField(max_length=40, null=True, blank=True)
    queue_name = models.CharField(max_length=128, null=True, blank=True)
    interface = models.CharField(max_length=128, null=True, blank=True,
                                 editable=False)
    penalty = models.IntegerField(default=0, editable=False)
    paused = models.IntegerField(default=0, choices=CHOICES_BOOL_INT)
    
    class Meta:
        unique_together = (('queue_name', 'interface', 'membername'),)
        verbose_name = 'Membro di una coda'
        verbose_name_plural = 'Membri di una coda'
        
    def __unicode__(self):
        return "%s - %s" % (self.queue_name, Account.objects.get(name=self.membername).utentepbx)
        
    def save(self, *args, **kwargs):
        a = Account.objects.get(name=self.membername)
        self.interface = 'Local/%s@%s' % (self.membername, a.context)
        super(QueueMember, self).save(*args, **kwargs)
        t = ThreadAstReload()
        t.start()
        
    @property
    def utentepbx(self):
        return Account.objects.get(name=self.membername).utentepbx
        
class RecallBooking(models.Model):
    timestamp = models.DateTimeField(auto_now=True)
    caller = models.ForeignKey(Account, related_name='booked_recalls')
    called = models.ForeignKey(Account, related_name='booked_waiting')
    
    class Meta:
        ordering = (('timestamp'),)
    
    def __unicode__(self):
        return "%s -> %s @%s" % (self.caller, self.called, self.timestamp)
    
    @staticmethod
    def recall(called):
        psse("recall called:%s" % called.pk)
        for rb in RecallBooking.objects.filter(called__exact=called):
            if rb.called.stato == 'free' and AccountFunctions.objects.get(account=rb.called).do_not_disturb == False:
                callfile = CallFile(
                                    trunk_type = 'SIP',
                                    trunk_name = None,
                                    number = rb.caller.name,
                                    caller_id = rb.caller.callerid,
                                    context = 'from-internal',
                                    extension = rb.called.name,
                                    priority = '1',
                                    max_retries = '0',
                                    sets = {'SRC' : rb.caller.name,
                                            'DST' : rb.called.name},
                                    dir = ASTERISK_SPOOL)
                rb.delete()
                try:
                    callfile.run()
                except NoAsteriskPermission:
                    psse("NoAsteriskPermission")
                return
        
    
class MeetMe(models.Model):
    confno = models.CharField(max_length=80, unique=True, default='0', verbose_name=_("Interno"))
    starttime = models.DateTimeField(default=datetime.datetime.now(), verbose_name=_("Inizio"))
    endtime = models.DateTimeField(default=datetime.datetime.now(), verbose_name=_("Fine"))
    pin = models.CharField(max_length=20, null=True, blank=True)
    adminpin = models.CharField(max_length=20, null=True, blank=True)
    opts = models.CharField(max_length=20, null=True, blank=True)
    adminopts = models.CharField(max_length=20, null=True, blank=True, editable=False)
    recordingfilename = models.CharField(max_length=80, null=True, blank=True)
    recordingformat = models.CharField(max_length=10, null=True, blank=True,
                                       default='wav', editable=False)
    maxusers = models.IntegerField(default=0)
    members = models.IntegerField(default=0, editable=False)
    
    class Meta:
        verbose_name = _('Conference Room')
        verbose_name_plural = _('Conference Rooms')
    
    def __unicode__(self):
        return self.confno
    
    @property
    def members(self):
        return MeetMeUser.objects.filter(meetme=self)
    
class MeetMeUser(models.Model):
    meetme = models.ForeignKey(MeetMe)
    login_time = models.DateTimeField(auto_now_add=True)
    account = models.ForeignKey(Account)
    number = models.IntegerField()
    
    class Meta:
        unique_together = (('meetme', 'account'),)
        verbose_name = _('Conference User')
        verbose_name_plural = _('Conference Users')
    
    def __unicode__(self):
        return str(self.account)
    
    def save(self, *args, **kwargs):
        if self.pk == None:
            users_no = MeetMeUser.objects.filter(meetme__exact=self.meetme).count()
            self.number = users_no + 1
        super(MeetMeUser, self).save(*args, **kwargs)
        

class SubclassingQuerySet(QuerySet):
    def __getitem__(self, k):
        result = super(SubclassingQuerySet, self).__getitem__(k)
        if isinstance(result, models.Model) :
            return result.as_specific()
        else :
            return result

    def __iter__(self):
        for item in super(SubclassingQuerySet, self).__iter__():
            yield item.as_specific()

class DeviceManager(models.Manager):
    def get_query_set(self):
        return SubclassingQuerySet(self.model)


class Device(models.Model):
    content_type = models.ForeignKey(ContentType, editable=False, null=True)
    nome = models.CharField(max_length=64)
    mac_address = MACAddressField()
    account = models.ForeignKey(Account, blank=True, null=True)
    objects = DeviceManager()
    
    def __unicode__(self):
        return "%s - %s" % (self.__class__, self.nome)
    
    def save(self, *args, **kwargs):
        if not self.content_type:
            self.content_type = ContentType.objects.get_for_model(self.__class__)
        super(Device, self).save(*args, **kwargs)

    def as_specific(self):
        content_type = self.content_type
        model = content_type.model_class()
        if(model == Device):
            return self
        return model.objects.get(id=self.id)

    # REFACTOR
    
    def action_predial_caller(self, called, *args, **kwargs):
        psse('%s.action_predial_caller: not implemented' % self)
        
    def action_predial_called(self, caller, *args, **kwargs):
        psse('%s.action_predial_called: not implemented' % self)
            
    def action_predial_monitoring(self, account, *args, **kwargs):
        psse('%s.action_predial_monitoring: not implemented' % self)
            
    def action_predial_monitored(self, account, *args, **kwargs):
        psse('%s.action_predial_monitored: not implemented' % self)

    def action_answer_caller(self, called, *args, **kwargs):
        psse('%s.action_answer_caller: not implemented' % self)
        
    def action_answer_called(self, caller, *args, **kwargs):
        psse('%s.action_answer_called: not implemented' % self)
        
    def action_answer_monitoring(self, account, *args, **kwargs):
        psse('%s.action_answer_monitoring: not implemented' % self)
            
    def action_answer_monitored(self, account, *args, **kwargs):
        psse('%s.action_answer_monitored: not implemented' % self)
        
    def action_postdial_caller(self, called, *args, **kwargs):
        psse('%s.action_postdial_caller: not implemented' % self)

    def action_postdial_called(self, caller, *args, **kwargs):
        psse('%s.action_postdial_called: not implemented' % self)
        
    def action_postdial_monitoring(self, account, *args, **kwargs):
        psse('%s.action_postdial_monitoring: not implemented' % self)
            
    def action_postdial_monitored(self, account, *args, **kwargs):
        psse('%s.action_postdial_monitored: not implemented' % self)
    
    # OLD

    def create_provision_file(self):
        """
        Crea un file adatto al provisioning prendendo eventuali valori fuori
        dallo scope del package da un dizionario e lo salva.
        """
        raise NotImplementedError
    
    def pre_dial_action(self, cli, exten):
        """
        Eventuale azione da svolgere prima che il device inizi una chiamata.
        """
        raise NotImplementedError
    
    def answer_action(self, cli, exten):
        """
        Eventuale azione da svolgere quando il device risponde una chiamata.
        """
        raise NotImplementedError
    
    def post_dial_action(self, cli, exten):
        """
        Eventuale azione da svolgere dopo che il device ha terminato una chimata.
        """
        raise NotImplementedError
    
#class Screen(models.Model):
#    device = models.OneToOneField(Device)


#class DeviceDummy(Device):
#    """
#    Implementazione a solo scopo di test.
#    Ha tre tag subito sotto root "nome", "mac" e "proxy"
#    """
#            
#    def create_provision_file(self):
#        with open("/tmp/dummy.xml") as f:
#            root = etree.parse(f)
#            for e in dict.keys():
#                found = root.iter(e)
#                if found:
#                    found.text = dict[e]
#                else:
#                    newel = etree.Element[e]
#                    newel.text = dict[e]
#                    root.append(newel)
#            root.write("/tmp/dummy.xml")


#class DevicePolycom(Device):
#    
#    def save(self, *args, **kwargs):
#        super(DevicePolycom, self).save(*args, **kwargs)
#        self.create_provision_file()
#        
#    def create_provision_file(self):
#        account = self.account
#        utente = account.utentepbx
#        user = utente.get_user()
#        
#        # mac.cfg
#        ctx_dict = { 'number' : account.name }
#        content = render_to_string('switch/polycom/mac.cfg', ctx_dict)
#        file = open("/srv/tftp/%s.cfg" % self.mac_address.replace(':', '').upper(),
#                    "w")
#        file.write(content)
#        file.close()
#        
#        # phonenum.cfg
#        ctx_dict['password'] = account.secret
#        content = render_to_string('switch/polycom/phonenum.cfg', ctx_dict)
#        file = open("/srv/tftp/phone%s.cfg" % self.account.name,
#                    "w")
#        file.write(content)
#        file.close()


#    def pre_dial_action(self, cli, exten):
#        print >> sys.stderr, "INTO POLYCOM PREDIAL %s %s" % (cli, exten)        
#        # se il cli sono io mando ai miei monitoranti la push 
#        # allo stato di calling
#        try:
#            if DevicePolycom.objects.get(account__name=cli) == self:
#                print >> sys.stderr, "mi dichiaro calling"
#                for u in self.account.utentepbx.osservatori.all():
#                    xml = { "XML" : '<CiscoIPPhoneExecute>\
#                                     <ExecuteItem URL="%s/switch/cisco_updatestatus_calling/%s/%s/%s/"/>\
#                                     </CiscoIPPhoneExecute>' %  (SERVERURL, u.pk, cli, exten)}
#                    params = urllib.urlencode(xml)
#                    headers = {"TE": "deflate,gzip;q=0.3",
#                               "Connection": "TE, close",
#                               "Authorization": "Basic YWRtaW46Y2lzY28=",
#                               "User-Agent": "thunder-php-ua",
#                               }
#                    for a in u.accounts_utentepbx.all():
#                        print >> sys.stderr, "mando il post a %s" % a.ipaddr
#                        conn = httplib.HTTPConnection("%s" % a.ipaddr)
#                        conn.request("POST", "/CGI/Execute", params, headers)
#        except:
#            pass
#        # se sono io l'exten chiamata mando ai miei monitoranti la push
#        # allo stati di ringing
#        try:
#            if DevicePolycom.objects.get(account__name=exten) == self:
#                print >> sys.stderr, "mi dichiaro ringing"
#                for u in self.account.utentepbx.osservatori.all():
#                    xml = { "XML" : '<CiscoIPPhoneExecute>\
#                                     <ExecuteItem URL="%s/switch/cisco_updatestatus_ringing/%s/%s/%s/"/>\
#                                     </CiscoIPPhoneExecute>' %  (SERVERURL, u.pk, cli, exten)}
#                    params = urllib.urlencode(xml)
#                    headers = {"TE": "deflate,gzip;q=0.3",
#                               "Connection": "TE, close",
#                               "Authorization": "Basic YWRtaW46Y2lzY28=",
#                               "User-Agent": "thunder-php-ua",
#                               }
#                    for a in u.accounts_utentepbx.all():
#                        print >> sys.stderr, "mando il post a %s" % a.ipaddr
#                        conn = httplib.HTTPConnection("%s" % a.ipaddr)
#                        conn.request("POST", "/CGI/Execute", params, headers)
#        except:
#            pass
#            
#    def answer_action(self, cli, exten):
#        print >> sys.stderr, "INTO POLYCOM ANSWER %s %s" % (cli, exten)        
#        # se sono io l'exten chiamata mando ai miei monitoranti la push
#        # allo stato di calling
#        try:
#            if DevicePolycom.objects.get(account__name=exten) == self:
#                print >> sys.stderr, "mi dichiaro calling"
#                for u in self.account.utentepbx.osservatori.all():
#                    xml = { "XML" : '<CiscoIPPhoneExecute>\
#                                    <ExecuteItem URL="%s/switch/cisco_updatestatus_calling/%s/%s/%s/"/>\
#                                    </CiscoIPPhoneExecute>' %  (SERVERURL, u.pk, cli, exten)}
#                    params = urllib.urlencode(xml)
#                    headers = {"TE": "deflate,gzip;q=0.3",
#                               "Connection": "TE, close",
#                               "Authorization": "Basic YWRtaW46Y2lzY28=",
#                               "User-Agent": "thunder-php-ua",
#                               }
#                    for a in u.accounts_utentepbx.all():
#                        print >> sys.stderr, "mando il post a %s" % a.ipaddr
#                        conn = httplib.HTTPConnection("%s" % a.ipaddr)
#                        conn.request("POST", "/CGI/Execute", params, headers)
#        except:
#            pass
#        
#    def post_dial_action(self, cli, exten):
#        print >> sys.stderr, "INTO POLYCOM POSTDIAL %s %s" % (cli, exten)        
#        # mando ai miei monitoranti la push allo stato di free
#        print >> sys.stderr, "mi dichiaro free"
#        for u in self.account.utentepbx.osservatori.all():
#            xml = { "XML" : '<CiscoIPPhoneExecute>\
#                             <ExecuteItem URL="%s/switch/cisco_updatestatus_hanged/%s/%s/%s/"/>\
#                             </CiscoIPPhoneExecute>' %  (SERVERURL, u.pk, cli, exten)}
#            params = urllib.urlencode(xml)
#            headers = {"TE": "deflate,gzip;q=0.3",
#                       "Connection": "TE, close",
#                       "Authorization": "Basic YWRtaW46Y2lzY28=",
#                       "User-Agent": "thunder-php-ua",
#                       }
#            for a in u.accounts_utentepbx.all():
#                print >> sys.stderr, "mando il post a %s" % a.ipaddr
#                conn = httplib.HTTPConnection("%s" % a.ipaddr)
#                conn.request("POST", "/CGI/Execute", params, headers)


#class DeviceCisco(Device):
#    
#    def save(self, *args, **kwargs):
#        super(DeviceCisco, self).save(*args, **kwargs)
#        self.create_provision_file()
#    
#    def create_provision_file(self):
#        account = self.account
#        utente = account.utentepbx
#        user = utente.get_user()
#        try:
#            phonelabel = "%s %s." % (user.last_name, user.first_name[0:1])
#        except:
#            phonelabel = 'no name set'
#        if len(phonelabel) > 12:
#            phonelabel = phonelabel[0:12]
#        ctx_dict = {'server' : SERVERURL,
#                    'processnodename' : SERVERIP,
#                    'proxy' : SERVERIP,
#                    'name' : self.account.name,
#                    'password' : self.account.secret,
#                    'phonelabel': phonelabel,
#                    'deviceid' : self.pk}
#        content = render_to_string('switch/cisco/provision.xml', ctx_dict)
#        file = open("/srv/tftp/SEP%s.cnf.xml" % self.mac_address.replace(':', '').upper(),
#                    "w")
#        file.write(content)
#        file.close()
#    
#    def pre_dial_action(self, cli, exten):
#        print >> sys.stderr, "INTO CISCO PREDIAL %s %s" % (cli, exten)
#        # se il cli sono io mando ai miei monitoranti la push 
#        # allo stato di calling
#        try:
#            if DeviceCisco.objects.get(account__name=cli) == self:
#                print >> sys.stderr, "%s si dichiara calling a %s" % (self.account.utentepbx, self.account.utentepbx.osservatori.all())
#                for u in self.account.utentepbx.osservatori.all():
#                    for a in u.accounts_utentepbx.all():
#                        xml = { "XML" : '<CiscoIPPhoneExecute>\
#                                <ExecuteItem URL="%s/switch/cisco_updatestatus_calling/%s/%s/%s/"/>\
#                                </CiscoIPPhoneExecute>' %  (SERVERURL, a.pk, cli, exten)}
#                        params = urllib.urlencode(xml)
#                        headers = {"TE": "deflate,gzip;q=0.3",
#                               "Connection": "TE, close",
#                               "Authorization": "Basic YWRtaW46Y2lzY28=",
#                               "User-Agent": "thunder-php-ua",
#                               }
#                        if a.ipaddr:
#                            print >> sys.stderr, "mando il post a %s (%s)" % (a.ipaddr, a.name)
#                            print >> sys.stderr, "alla url: %s/switch/cisco_updatestatus_calling/%s/%s/%s/" %  (SERVERURL, a.pk, cli, exten)
#                            try:
#                                conn = httplib.HTTPConnection("%s" % a.ipaddr, timeout=1)
#                                conn.request("POST", "/CGI/Execute", params, headers)
#                            except Exception, e:
#                                print >> sys.stderr, "fallito post a %s per %s" % (a.ipaddr, str(e))
#                        else:
#                            print >> sys.stderr, "il device di %s non sembra essere registrato" % a.name
#        except Exception, e:
#            print >> sys.stderr, "Exception in DeviceCisco.pre_dial_action: %s" % str(e)
#        # se sono io l'exten chiamata mando ai miei monitoranti la push
#        # allo stati di ringing
#        try:
#            if DeviceCisco.objects.get(account__name=exten) == self:
#                print >> sys.stderr, "%s si dichiara ringing a %s" % (self.account.utentepbx, self.account.utentepbx.osservatori.all())
#                for u in self.account.utentepbx.osservatori.all():
#                    for a in u.accounts_utentepbx.all():
#                        xml = { "XML" : '<CiscoIPPhoneExecute>\
#                                <ExecuteItem URL="%s/switch/cisco_updatestatus_ringing/%s/%s/%s/"/>\
#                                </CiscoIPPhoneExecute>' %  (SERVERURL, a.pk, cli, exten)}
#                        params = urllib.urlencode(xml)
#                        headers = {"TE": "deflate,gzip;q=0.3",
#                               "Connection": "TE, close",
#                               "Authorization": "Basic YWRtaW46Y2lzY28=",
#                               "User-Agent": "thunder-php-ua",
#                               }
#                        if a.ipaddr:
#                            print >> sys.stderr, "mando il post a %s (%s)" % (a.ipaddr, a.name)
#                            print >> sys.stderr, "alla url: %s/switch/cisco_updatestatus_ringing/%s/%s/%s/" %  (SERVERURL, a.pk, cli, exten)
#                            try:
#                                conn = httplib.HTTPConnection("%s" % a.ipaddr, timeout=1)
#                                conn.request("POST", "/CGI/Execute", params, headers)
#                            except Exception, e:
#                                print >> sys.stderr, "fallito post a %s per %s" % (a.ipaddr, str(e))
#                        else:
#                            print >> sys.stderr, "il device di %s non sembra essere registrato" % a.name
#        except Exception, e:
#            print >> sys.stderr, "Exception in DeviceCisco.pre_dial_action: %s" % str(e)
#
#    def answer_action(self, cli, exten):
#        print >> sys.stderr, "INTO CISCO ANSWER %s %s" % (cli, exten)        
#        # se sono io l'exten chiamata mando ai miei monitoranti la push
#        # allo stato di calling
#        try:
#            if DeviceCisco.objects.get(account__name=exten) == self:
#                print >> sys.stderr, "%s si dichiara calling a %s" % (self.account.utentepbx, self.account.utentepbx.osservatori.all())
#                for u in self.account.utentepbx.osservatori.all():
#                    for a in u.accounts_utentepbx.all():
#                        xml = { "XML" : '<CiscoIPPhoneExecute>\
#                                <ExecuteItem URL="%s/switch/cisco_updatestatus_calling/%s/%s/%s/"/>\
#                                </CiscoIPPhoneExecute>' %  (SERVERURL, a.pk, cli, exten)}
#                        params = urllib.urlencode(xml)
#                        headers = {"TE": "deflate,gzip;q=0.3",
#                                   "Connection": "TE, close",
#                                   "Authorization": "Basic YWRtaW46Y2lzY28=",
#                                   "User-Agent": "thunder-php-ua",
#                               }
#                        if a.ipaddr:
#                            print >> sys.stderr, "mando il post a %s (%s)" % (a.ipaddr, a.name)
#                            print >> sys.stderr, "alla url: %s/switch/cisco_updatestatus_calling/%s/%s/%s/" %  (SERVERURL, a.pk, cli, exten)
#                            try:
#                                conn = httplib.HTTPConnection("%s" % a.ipaddr, timeout=1)
#                                conn.request("POST", "/CGI/Execute", params, headers)
#                            except Exception, e:
#                                print >> sys.stderr, "fallito post a %s per %s" % (a.ipaddr, str(e))
#                        else:
#                            print >> sys.stderr, "il device di %s non sembra essere registrato" % a.name
#        except Exception, e:
#            print >> sys.stderr, "Exception in DeviceCisco.answer_action: %s" % str(e)
#        
#    def post_dial_action(self, cli, exten):
#        print >> sys.stderr, "INTO CISCO POSTDIAL %s %s" % (cli, exten)
#        # mando ai miei monitoranti la push allo stato di free
#        try:
#            print >> sys.stderr, "%s si dichiara free a %s" % (self.account.utentepbx, self.account.utentepbx.osservatori.all())
#            for u in self.account.utentepbx.osservatori.all():
#                for a in u.accounts_utentepbx.all():
#                    xml = { "XML" : '<CiscoIPPhoneExecute>\
#                            <ExecuteItem URL="%s/switch/cisco_updatestatus_hanged/%s/%s/%s/"/>\
#                            </CiscoIPPhoneExecute>' %  (SERVERURL, a.pk, cli, exten)}
#                    params = urllib.urlencode(xml)
#                    headers = {"TE": "deflate,gzip;q=0.3",
#                               "Connection": "TE, close",
#                               "Authorization": "Basic YWRtaW46Y2lzY28=",
#                               "User-Agent": "thunder-php-ua",
#                           }
#                    if a.ipaddr:
#                        print >> sys.stderr, "mando il post a %s (%s)" % (a.ipaddr, a.name)
#                        print >> sys.stderr, "alla url: %s/switch/cisco_updatestatus_hanged/%s/%s/%s/" %  (SERVERURL, a.pk, cli, exten)
#                        try:
#                            conn = httplib.HTTPConnection("%s" % a.ipaddr, timeout=1)
#                            conn.request("POST", "/CGI/Execute", params, headers)
#                        except Exception, e:
#                            print >> sys.stderr, "fallito post a %s per %s" % (a.ipaddr, str(e))
#                    else:
#                        print >> sys.stderr, "il device di %s non sembra essere registrato" % a.name
#        except Exception, e:
#            print >> sys.stderr, "Exception in DeviceCisco.post_dial_action: %s" % str(e)
#
#    def restart_action(self):
#        print >> sys.stderr, "INTO RESTART ACTION"
#        a = self.account
#        actions = (('Key:Settings', '.2'),
#                   ('Key:KeyPadStar', '.05'),
#                   ('Key:KeyPadStar', '.05'),
#                   ('Key:KeyPadPound', '.05'),
#                   ('Key:KeyPadStar', '.05'),
#                   ('Key:KeyPadStar', '0'))
##        auth = base64.b64encode("admin:cisco")
#        print >> sys.stderr, "mando il post di reset a %s (%s)" % (a.ipaddr, a.name)
#        for action in actions:
#            xml = { "XML" : '<CiscoIPPhoneExecute><ExecuteItem URL="%s"/></CiscoIPPhoneExecute>' % action[0]}
#            params = urllib.urlencode(xml)
#            headers = {"TE": "deflate,gzip;q=0.3",
#                       "Connection": "TE, close",
#                       "Authorization": "Basic YWRtaW46Y2lzY28=", #auth
#                       "Host": "%s" % a.ipaddr,
#                       "User-Agent": "thunder-php-ua",
#                       }
#    
#            if a.ipaddr:
#                try:
#                    conn = httplib.HTTPConnection("%s" % a.ipaddr, timeout=1)
#                    conn.request("POST", "/CGI/Execute", params, headers)
#                except Exception, e:
#                    print >> sys.stderr, "fallito post a %s per %s" % (a.ipaddr, str(e))
#
#class DeviceCiscoDual(Device):
#    account_due = models.ForeignKey(Account, blank=True, null=True)
#    
#    def save(self, *args, **kwargs):
#        super(DeviceCiscoDual, self).save(*args, **kwargs)
#        self.create_provision_file()
#    
#    def create_provision_file(self):
#        account = self.account
#        utente = account.utentepbx
#        user = utente.get_user()
#        account_due = self.account_due
#        utente_due = account_due.utentepbx
#        user_due = utente_due.get_user()
#        try:
#            phonelabel = "%s %s." % (user.last_name, user.first_name[0:1])
#        except:
#            phonelabel = 'no name set'
#        if len(phonelabel) > 12:
#            phonelabel = phonelabel[0:12]
#        ctx_dict = {'server' : SERVERURL,
#                    'processnodename' : SERVERIP,
#                    'proxy' : SERVERIP,
#                    'name' : self.account.name,
#                    'password' : self.account.secret,
#                    'phonelabel': phonelabel,
#                    'name_due' : self.account_due.name,
#                    'password_due' : self.account_due.secret}
#        content = render_to_string('switch/cisco/provision_dual.xml', ctx_dict)
#        file = open("/srv/tftp/SEP%s.cnf.xml" % self.mac_address.replace(':', '').upper(),
#                    "w")
#        file.write(content)
#        file.close()
#    
#    def pre_dial_action(self, cli, exten):
#        print >> sys.stderr, "INTO CISCO PREDIAL %s %s" % (cli, exten)
#        # se il cli sono io mando ai miei monitoranti la push 
#        # allo stato di calling
#        try:
#            if DeviceCiscoDual.objects.get(account__name=cli) == self:
#                print >> sys.stderr, "%s si dichiara calling a %s" % (self.account.utentepbx, self.account.utentepbx.osservatori.all())
#                for u in self.account.utentepbx.osservatori.all():
#                    for a in u.accounts_utentepbx.all():
#                        xml = { "XML" : '<CiscoIPPhoneExecute>\
#                                <ExecuteItem URL="%s/switch/cisco_updatestatus_calling/%s/%s/%s/"/>\
#                                </CiscoIPPhoneExecute>' %  (SERVERURL, a.pk, cli, exten)}
#                        params = urllib.urlencode(xml)
#                        headers = {"TE": "deflate,gzip;q=0.3",
#                               "Connection": "TE, close",
#                               "Authorization": "Basic YWRtaW46Y2lzY28=",
#                               "User-Agent": "thunder-php-ua",
#                               }
#                        if a.ipaddr:
#                            print >> sys.stderr, "mando il post a %s (%s)" % (a.ipaddr, a.name)
#                            print >> sys.stderr, "alla url: %s/switch/cisco_updatestatus_calling/%s/%s/%s/" %  (SERVERURL, a.pk, cli, exten)
#                            try:
#                                conn = httplib.HTTPConnection("%s" % a.ipaddr, timeout=1)
#                                conn.request("POST", "/CGI/Execute", params, headers)
#                            except Exception, e:
#                                print >> sys.stderr, "fallito post a %s per %s" % (a.ipaddr, str(e))
#                        else:
#                            print >> sys.stderr, "il device di %s non sembra essere registrato" % a.name
#        except Exception, e:
#            print >> sys.stderr, "Exception in DeviceCiscoDual.pre_dial_action: %s" % str(e)
#        # se sono io l'exten chiamata mando ai miei monitoranti la push
#        # allo stati di ringing
#        try:
#            if DeviceCiscoDual.objects.get(account__name=exten) == self:
#                print >> sys.stderr, "%s si dichiara ringing a %s" % (self.account.utentepbx, self.account.utentepbx.osservatori.all())
#                for u in self.account.utentepbx.osservatori.all():
#                    for a in u.accounts_utentepbx.all():
#                        xml = { "XML" : '<CiscoIPPhoneExecute>\
#                                <ExecuteItem URL="%s/switch/cisco_updatestatus_ringing/%s/%s/%s/"/>\
#                                </CiscoIPPhoneExecute>' %  (SERVERURL, a.pk, cli, exten)}
#                        params = urllib.urlencode(xml)
#                        headers = {"TE": "deflate,gzip;q=0.3",
#                               "Connection": "TE, close",
#                               "Authorization": "Basic YWRtaW46Y2lzY28=",
#                               "User-Agent": "thunder-php-ua",
#                               }
#                        if a.ipaddr:
#                            print >> sys.stderr, "mando il post a %s (%s)" % (a.ipaddr, a.name)
#                            print >> sys.stderr, "alla url: %s/switch/cisco_updatestatus_ringing/%s/%s/%s/" %  (SERVERURL, a.pk, cli, exten)
#                            try:
#                                conn = httplib.HTTPConnection("%s" % a.ipaddr, timeout=1)
#                                conn.request("POST", "/CGI/Execute", params, headers)
#                            except Exception, e:
#                                print >> sys.stderr, "fallito post a %s per %s" % (a.ipaddr, str(e))
#                        else:
#                            print >> sys.stderr, "il device di %s non sembra essere registrato" % a.name
#        except Exception, e:
#            print >> sys.stderr, "Exception in DeviceCiscoDual.pre_dial_action: %s" % str(e)
#
#    def answer_action(self, cli, exten):
#        print >> sys.stderr, "INTO CISCO ANSWER %s %s" % (cli, exten)        
#        # se sono io l'exten chiamata mando ai miei monitoranti la push
#        # allo stato di calling
#        try:
#            if DeviceCiscoDual.objects.get(account__name=exten) == self:
#                print >> sys.stderr, "%s si dichiara calling a %s" % (self.account.utentepbx, self.account.utentepbx.osservatori.all())
#                for u in self.account.utentepbx.osservatori.all():
#                    for a in u.accounts_utentepbx.all():
#                        xml = { "XML" : '<CiscoIPPhoneExecute>\
#                                <ExecuteItem URL="%s/switch/cisco_updatestatus_calling/%s/%s/%s/"/>\
#                                </CiscoIPPhoneExecute>' %  (SERVERURL, a.pk, cli, exten)}
#                        params = urllib.urlencode(xml)
#                        headers = {"TE": "deflate,gzip;q=0.3",
#                                   "Connection": "TE, close",
#                                   "Authorization": "Basic YWRtaW46Y2lzY28=",
#                                   "User-Agent": "thunder-php-ua",
#                               }
#                        if a.ipaddr:
#                            print >> sys.stderr, "mando il post a %s (%s)" % (a.ipaddr, a.name)
#                            print >> sys.stderr, "alla url: %s/switch/cisco_updatestatus_calling/%s/%s/%s/" %  (SERVERURL, a.pk, cli, exten)
#                            try:
#                                conn = httplib.HTTPConnection("%s" % a.ipaddr, timeout=1)
#                                conn.request("POST", "/CGI/Execute", params, headers)
#                            except Exception, e:
#                                print >> sys.stderr, "fallito post a %s per %s" % (a.ipaddr, str(e))
#                        else:
#                            print >> sys.stderr, "il device di %s non sembra essere registrato" % a.name
#        except Exception, e:
#            print >> sys.stderr, "Exception in DeviceCiscoDual.answer_action: %s" % str(e)
#        
#    def post_dial_action(self, cli, exten):
#        print >> sys.stderr, "INTO CISCO POSTDIAL %s %s" % (cli, exten)
#        # mando ai miei monitoranti la push allo stato di free
#        try:
#            print >> sys.stderr, "%s si dichiara free a %s" % (self.account.utentepbx, self.account.utentepbx.osservatori.all())
#            for u in self.account.utentepbx.osservatori.all():
#                for a in u.accounts_utentepbx.all():
#                    xml = { "XML" : '<CiscoIPPhoneExecute>\
#                            <ExecuteItem URL="%s/switch/cisco_updatestatus_hanged/%s/%s/%s/"/>\
#                            </CiscoIPPhoneExecute>' %  (SERVERURL, a.pk, cli, exten)}
#                    params = urllib.urlencode(xml)
#                    headers = {"TE": "deflate,gzip;q=0.3",
#                               "Connection": "TE, close",
#                               "Authorization": "Basic YWRtaW46Y2lzY28=",
#                               "User-Agent": "thunder-php-ua",
#                           }
#                    if a.ipaddr:
#                        print >> sys.stderr, "mando il post a %s (%s)" % (a.ipaddr, a.name)
#                        print >> sys.stderr, "alla url: %s/switch/cisco_updatestatus_hanged/%s/%s/%s/" %  (SERVERURL, a.pk, cli, exten)
#                        try:
#                            conn = httplib.HTTPConnection("%s" % a.ipaddr, timeout=1)
#                            conn.request("POST", "/CGI/Execute", params, headers)
#                        except Exception, e:
#                            print >> sys.stderr, "fallito post a %s per %s" % (a.ipaddr, str(e))
#                    else:
#                        print >> sys.stderr, "il device di %s non sembra essere registrato" % a.name
#        except Exception, e:
#            print >> sys.stderr, "Exception in DeviceCiscoDual.post_dial_action: %s" % str(e)
#
#    def restart_action(self):
#        print >> sys.stderr, "INTO RESTART ACTION"
#        a = self.account
#        actions = (('Key:Settings', '.2'),
#                   ('Key:KeyPadStar', '.05'),
#                   ('Key:KeyPadStar', '.05'),
#                   ('Key:KeyPadPound', '.05'),
#                   ('Key:KeyPadStar', '.05'),
#                   ('Key:KeyPadStar', '0'))
##        auth = base64.b64encode("admin:cisco")
#    
#        for action in actions:
#            xml = { "XML" : '<CiscoIPPhoneExecute><ExecuteItem URL="%s"/></CiscoIPPhoneExecute>' % action}
#            params = urllib.urlencode(xml)
#            headers = {"TE": "deflate,gzip;q=0.3",
#                                   "Connection": "TE, close",
#                                   "Authorization": "Basic YWRtaW46Y2lzY28=", #auth
#                                   "Host": "%s" % a.ipaddr,
#                                   "User-Agent": "thunder-php-ua",
#                               }
#    
#            if a.ipaddr:
#                print >> sys.stderr, "mando il post di reset a %s (%s)" % (a.ipaddr, a.name)
#                try:
#                    conn = httplib.HTTPConnection("%s" % a.ipaddr, timeout=1)
#                    conn.request("POST", "/CGI/Execute", params, headers)
#                except Exception, e:
#                    print >> sys.stderr, "fallito post a %s per %s" % (a.ipaddr, str(e))
