# -*- coding: utf-8 -*-
'''
Created on 27/gen/2012

@author: simone cittadini
'''
import os, sys
import re
import httplib, urllib
import shlex
import subprocess
import time
import base64
import threading


from lxml import etree
from django.db import models
from django.db.models.query import QuerySet
from django.utils.translation import ugettext_lazy as _
from django.forms import fields
from django.contrib.contenttypes.models import ContentType

from django.template.loader import render_to_string
from jumbo.utils.functions import get_settings

from pbx.utenti.models import UtentePBX
from pbx.switch.models import Account, Device, SERVERURL, SERVERIP

class DevicePolycom(Device):
    
    def save(self, *args, **kwargs):
        super(DevicePolycom, self).save(*args, **kwargs)
        self.create_provision_file()
        
    def create_provision_file(self):
        account = self.account
        utente = account.utentepbx
        user = utente.get_user()
        
        # mac.cfg
        ctx_dict = { 'number' : account.name }
        content = render_to_string('switch/polycom/mac.cfg', ctx_dict)
        file = open("/srv/tftp/%s.cfg" % self.mac_address.replace(':', '').upper(),
                    "w")
        file.write(content)
        file.close()
        
        # phonenum.cfg
        ctx_dict['password'] = account.secret
        content = render_to_string('switch/polycom/phonenum.cfg', ctx_dict)
        file = open("/srv/tftp/phone%s.cfg" % self.account.name,
                    "w")
        file.write(content)
        file.close()
