# -*- coding: utf-8 -*-
'''
Created on 20/mag/2012

@author: simone cittadini
'''
from django.contrib import admin
from django import forms
from django.utils.translation import ugettext_lazy as _
from django.conf.urls.defaults import patterns, url
from django.core.urlresolvers import reverse

from jumbo.admin.options import ExtendibleModelAdmin

from pbx.switch.views import device_restart
from pbx.switch.models import Account
from models import DeviceSnom

class DeviceSnomSearchForm(forms.ModelForm):
    class Meta:
        model = Account
        display_fields = (
            'mac_address__icontains','account__name__icontains',
        )

    def __init__(self, *args, **kws):
        super(DeviceSnomSearchForm, self).__init__(*args, **kws)
        self.fields['mac_address__icontains'] = forms.CharField(label=_("Mac Address"), required=False)
        self.fields['account__name__icontains'] = forms.CharField(label=_("Numero account"), required=False)

class DeviceSnomAdmin(ExtendibleModelAdmin):
    list_display = ('nome','mac_address')

    search_form = DeviceSnomSearchForm
    no_display_links = False


admin.site.register(DeviceSnom, DeviceSnomAdmin)
