from django.http import HttpResponse, HttpResponseRedirect
from django.shortcuts import render_to_response
from django.template.loader import render_to_string
from django.db import transaction
from django.db.models import Q
from django.views.generic.create_update import update_object
from django.template.context import RequestContext
from django.conf import settings


from pbx.switch.snom.models import DeviceSnom
from pbx.utenti.models import PersonalPhonebookEntry
from pbx.switch.models import Account

def snom_provision(request, mac):
    macaddr = "%s:%s:%s:%s:%s:%s" % (mac[0:2], mac[2:4], mac[4:6], mac[6:8],
                                     mac[8:10], mac[10:12])
    d = DeviceSnom.objects.get(mac_address=macaddr)
    serverurl = getattr(settings, 'SERVERURL')
    serverip = getattr(settings, 'SERVERIP')
    acc = d.account
    return render_to_response('switch/snom/provision.xml',
                              locals(),
                              RequestContext(request))
    
def snom_phonedir(request, mac):
    macaddr = "%s:%s:%s:%s:%s:%s" % (mac[0:2], mac[2:4], mac[4:6], mac[6:8],
                                     mac[8:10], mac[10:12])
    d = DeviceSnom.objects.get(mac_address=macaddr)
    a = d.account
    u = a.utentepbx
    qs_personal_phonebook = PersonalPhonebookEntry.objects.filter(
                                                            utentepbx__exact=u)
    
    qs_accounts = Account.objects.exclude(pk__exact=a.pk)
    return render_to_response('switch/snom/phonedir.xml',
                              locals(),
                              RequestContext(request))