# -*- coding: utf-8 -*-
'''
Created on 4/ago/2011

@author: simone cittadini
'''
import sys
import threading
import subprocess
import httplib, urllib

#import Image, ImageDraw, ImageFont

from django.http import HttpResponse, HttpResponseRedirect
from django.shortcuts import render_to_response
from django.template.loader import render_to_string
from django.db import transaction
from django.db.models import Q
from django.views.generic.create_update import update_object

from jumbo.utils.functions import get_settings
from callfile import CallFile
from callfileexceptions import NoAsteriskPermission

from pbx.views import psse
from pbx.switch.models import Account, SERVERURL, Device, MeetMe, MeetMeUser,\
    CallGroup, Queue, QueueMember, RecallBooking, AccountFunctions, VoiceMail
from pbx.utenti.models import EnabledCookie, BlacklistEntry
from django.core.urlresolvers import reverse
from django.template.context import RequestContext
import datetime
from pbx.switch.forms import MeetmeRoomForm, VoiceMailForm


ASTERISK_SPOOL = '/var/spool/asterisk/outgoing/'
#CISCOIMAGESPATH = get_settings('switch.settings', 'CISCOIMAGESPATH')
#CISCOFONTTYPE = get_settings('switch.settings', 'CISCOFONTTYPE')
#CISCOFONTSIZE = get_settings('switch.settings', 'CISCOFONTSIZE')
#CISCOFONTTYPE = '/usr/share/cups/fonts/FreeMono.ttf'
#CISCOFONTSIZE = 10

#POSITIONS = {1:(5, 1), 3:(5, 13), 5:(5, 25), 7:(5, 37),
#             2:(135, 1), 4:(135, 13), 6:(135, 25), 8:(135, 37)}

#class ThreadPredial(threading.Thread):
#    def __init__(self, device, cli, exten):
#        threading.Thread.__init__(self)
#        print >> sys.stderr, "init predial thread"
#        self.device = device
#        self.cli = cli
#        self.exten = exten
#    def run(self):
#        self.device.as_specific().pre_dial_action(self.cli, self.exten)
#        print >> sys.stderr, "fine run predial thread"
#        
#class ThreadAnswer(threading.Thread):
#    def __init__(self, device, cli, exten):
#        threading.Thread.__init__(self)
#        print >> sys.stderr, "init answer thread"
#        self.device = device
#        self.cli = cli
#        self.exten = exten
#    def run(self):
#        self.device.as_specific().answer_action(self.cli, self.exten)
#        print >> sys.stderr, "fine run answer thread"
#        
#class ThreadPostdial(threading.Thread):
#    def __init__(self, device, cli, exten):
#        threading.Thread.__init__(self)
#        print >> sys.stderr, "init postdial thread"
#        self.device = device
#        self.cli = cli
#        self.exten = exten
#    def run(self):
#        self.device.as_specific().post_dial_action(self.cli, self.exten)
#        print >> sys.stderr, "fine run postdial thread"

ETICHETTA_STATO_FUNZIONI = {True: 'attivo', False: 'disattivo'}
ETICHETTA_STATO_FUNZIONAMENTO_CW = {False: '( disabilitato )', True: ''}
        
class ThreadKickMeetmeUser(threading.Thread):
    def __init__(self, confno, cli, *args, **kwargs):
        threading.Thread.__init__(self)
        self.confno = confno
        self.cli = cli
        #self.exten = exten
    def run(self):
        user = MeetMeUser.objects.get(meetme__confno=self.confno,
                                      account__name=self.cli)
        exit_status = subprocess.call(["asterisk", "-rx" "meetme kick %s %s" % (self.confno, user.number)])
        
class ThreadMuteMeetmeUser(threading.Thread):
    def __init__(self, confno, cli, *args, **kwargs):
        threading.Thread.__init__(self)
        self.confno = confno
        self.cli = cli
        #self.exten = exten
    def run(self):
        user = MeetMeUser.objects.get(meetme__confno=self.confno,
                                      account__name=self.cli)
        exit_status = subprocess.call(["asterisk", "-rx" "meetme mute %s %s" % (self.confno, user.number)])
        
class ThreadUnmuteMeetmeUser(threading.Thread):
    def __init__(self, confno, cli, *args, **kwargs):
        threading.Thread.__init__(self)
        self.confno = confno
        self.cli = cli
        #self.exten = exten
    def run(self):
        user = MeetMeUser.objects.get(meetme__confno=self.confno,
                                      account__name=self.cli)
        exit_status = subprocess.call(["asterisk", "-rx" "meetme unmute %s %s" % (self.confno, user.number)])
        
        
# REFACTOR

@transaction.autocommit
def curl_predial(request, cli, exten):
    """
    Chiamata da asterisk con curl appena prima della dial.
    Setta gli stati degli eventuali account e triggera le 
    predial action degli eventuali device collegati.
    """
    try:
        psse("switch.views.curl_predial: src:%s dst:%s" % (cli, exten))
        try:
            # se il chiamante è un interno triggero la sua predial
            src = Account.objects.get(name=cli)
            src.action_predial_caller(called=exten)
            # poi triggero la predial di chi lo sta monitorando
            for u in src.utentepbx.osservatori.all():
                for a in Account.objects.filter(utentepbx__exact=u):
                    a.action_predial_monitoring(src)
            # poi triggero la predial di chi lui sta monitorando
            for u in src.utentepbx.utenti_monitorati.all():
                for a in Account.objects.filter(utentepbx__exact=u):
                    a.action_predial_monitored(src)
            # se la destinazione è una conference room lo aggiungo agli user
            try:
                room = MeetMe.objects.get(confno=exten)
                MeetMeUser.objects.get_or_create(meetme=room, account=src)
            except:
                pass
        except Account.DoesNotExist:
            psse("caller senza account: %s" % cli)
        try:
            # se il chiamato è un interno triggero la sua predial
            dst = Account.objects.get(name=exten)
            dst.action_predial_called(caller=cli)
            # poi triggero la predial di chi lo sta monitorando
            for u in dst.utentepbx.osservatori.all():
                for a in Account.objects.filter(utentepbx__exact=u):
                    a.action_predial_monitoring(dst)
            # poi tirggero la predial di chi lui sta monitornado
            for u in dst.utentepbx.utenti_monitorati.all():
                for a in Account.objects.filter(utentepbx__exact=u):
                    a.action_predial_monitored(dst)
        except Account.DoesNotExist:
            psse("called senza account: %s" % exten)
    except Exception, e:
        return HttpResponse("KO_predial_%s" % str(e))
    return HttpResponse("OK_predial")

@transaction.autocommit
def curl_answer(request, cli, exten):#, pickedup=False):
    """
    Chiamata da asterisk con curl appena prima dell' answer.
    Setta gli stati degli eventuali account e triggera le
    answer action degli eventuali device collegati.
    """
    try:    
        psse("switch.views.curl_answer: src:%s dst:%s" % (cli, exten))
        try:
            # se il chiamante è un interno triggero la sua answer
            src = Account.objects.get(name=cli)
            src.action_answer_caller(called=exten)
            # poi triggero la answer di chi lo sta monitorando
            for u in src.utentepbx.osservatori.all():
                for a in Account.objects.filter(utentepbx__exact=u):
                    a.action_answer_monitoring(src)
            # poi triggero la answer di chi lui sta monitornado
            for u in src.utentepbx.utenti_monitorati.all():
                for a in Account.objects.filter(utentepbx__exact=u):
                    a.action_answer_monitored(src)
        except Account.DoesNotExist, e:
            psse("\tcaller senza account: %s" % cli)
        try:
            # se il chiamato è un interno triggero la sua answer
            dst = Account.objects.get(name=exten)
            dst.action_answer_called(caller=cli)
            # poi triggero la answer di chi lo sta monitorando
            for u in dst.utentepbx.osservatori.all():
                for a in Account.objects.filter(utentepbx__exact=u):
                    a.action_answer_monitoring(dst)
            # poi triggero la answer di chi lui sta monitornado
            for u in dst.utentepbx.utenti_monitorati.all():
                for a in Account.objects.filter(utentepbx__exact=u):
                    a.action_answer_monitored(dst)
        except Account.DoesNotExist, e:
            psse("\tcalled senza account: %s" % exten)
    except Exception, e:
        return HttpResponse("KO_answer_%s" % str(e))
    return HttpResponse("OK_answer")

@transaction.autocommit
def curl_postdial(request, cli, exten):#, pickedup=False):
    """
    Chiamata da asterisk con curl appena dopo l'hangup.
    Setta gli stati degli eventuali account e triggera le
    postdial action degli eventuali device collegati.
    """
    try:
        psse("switch.views.curl_postdial: src:%s dst:%s" % (cli, exten))
        try:
            # se il chiamante è un interno triggero la sua postdial
            src = Account.objects.get(name=cli)
            src.action_postdial_caller(called=exten)
            # poi triggero la postdial di chi lo sta monitorando
            for u in src.utentepbx.osservatori.all():
                for a in Account.objects.filter(utentepbx__exact=u):
                    a.action_postdial_monitoring(src)
            # poi triggero la postdial di chi lui sta monitorando
            for u in src.utentepbx.utenti_monitorati.all():
                for a in Account.objects.filter(utentepbx__exact=u):
                    a.action_postdial_monitored(src)
            # se la destinazione è una conference room lo tolgo dagli user
            try:
                room = MeetMe.objects.get(confno=exten)
                MeetMeUser.objects.get(meetme=room, account=src).delete()
            except:
                pass
            # controllo se ci sono richiamate prenotate
            RecallBooking.recall(src)
        except Account.DoesNotExist, e:
            psse("\tex caller senza account: %s" % cli)
        try:
            # se il chiamato è un interno triggero la sua postdial
            dst = Account.objects.get(name=exten)
            dst.action_postdial_called(caller=cli)
            # poi triggero la postdial di chi lo sta monitorando
            for u in dst.utentepbx.osservatori.all():
                for a in Account.objects.filter(utentepbx__exact=u):
                    a.action_postdial_monitoring(dst)
            # poi tirggero la postdial di chi lui sta monitornado
            for u in dst.utentepbx.utenti_monitorati.all():
                for a in Account.objects.filter(utentepbx__exact=u):
                    a.action_postdial_monitored(dst)
            # controllo se ci sono richiamate prenotate
            RecallBooking.recall(dst)
        except Account.DoesNotExist, e:
            psse("\tex called senza account: %s" % exten)
    except Exception, e:
        return HttpResponse("KO_postdial_%s" % str(e))
    return HttpResponse("OK_postdial")


def curl_fun_dnd(request, cli, exten):
    """
    Chiamata da asterisk prima della predial per controllare la presenza di
    do not disturb sull'account.
    """
    try:
        psse("switch.views.curl_fun_dnd: src:%s dst:%s" % (cli, exten))
        try:
            dst = Account.objects.get(name=exten)
            if dst.do_not_disturb:
                return HttpResponse("OK_ON")
            return HttpResponse("OK_OFF")
        except Account.DoesNotExist, e:
            psse("called senza account: %s" % exten)
            return HttpResponse("OK")
    except Exception, e:
        return HttpResponse("KO_curl_fun_dnd_%s" % str(e))

def curl_fun_voicemail(request, cli, exten):
    """
    Chiamata da asterisk prima della predial per controllare l'attivazione
    della voicemail.
    """
    try:
        psse("switch.views.curl_fun_voicemail: src:%s dst:%s" % (cli, exten))
        try:
            dst = Account.objects.get(name=exten)
            if dst.voice_mail:
                return HttpResponse("OK_ON")
            return HttpResponse("OK_OFF")
        except Account.DoesNotExist, e:
            psse("called senza account: %s" % exten)
            return HttpResponse("OK")
    except Exception, e:
        return HttpResponse("KO_curl_fun_voicemail_%s" % str(e))
    
def curl_fun_callgroup(request, src, exten):
    """
    Chiamata da asterisk per farsi dire la dial string corrispondente ad un
    callgroup.
    """
    try:
        psse("switch.views.curl_fun_callgroup: exten:%s" % exten)
        try:
            cg = CallGroup.objects.get(exten=exten)
        except CallGroup.DoesNotExist:
            return HttpResponse("NOGROUP")
        output = ""
        for a in cg.accounts.filter(functions__do_not_disturb__exact=False
                                    ).exclude(name__exact=src):
            output = "%sLocal/%s@ext-group&" % (output, a.name)
        return HttpResponse(output[:-1])
    except Exception, e:
        return HttpResponse("KO_curl_fun_callgroup_%s" % str(e))
    
def curl_fun_create_queue_member(request, queue, cli):
    """
    Chiamata da asterisk per creare un membro in una coda.
    """
    try:
        psse("switch.views.curl_fun_callgroup: queue:%s cli:%s" % (queue, cli))
        try:
            q = Queue.objects.get()
        except Queue.DoesNotExist:
            return HttpResponse("NOQUEUE")
    except Exception, e:
        return HttpResponse("KO_curl_fun_create_queue_member_%s" % str(e))

def curl_fun_callwaiting(request, cli, exten):
    """
    Chiamata da asterisk prima della predial per controllare l'attivazione
    del callwaiting.
    """
    try:
        psse("switch.views.curl_fun_callwaiting: src:%s dst:%s" % (cli, exten))
        try:
            dst = Account.objects.get(name=exten)
            if dst.call_waiting:
                return HttpResponse("OK_ON")
            return HttpResponse("OK_OFF")
        except Account.DoesNotExist, e:
            psse("called senza account: %s" % exten)
            return HttpResponse("OK")
    except Exception, e:
        return HttpResponse("KO_curl_fun_callwaiting_%s" % str(e))

def curl_fun_forward(request, cli, exten):
    """
    Chiamata da asterisk prima della predial per controllare l'attivazione
    del forward (e eventuale numero a cui girare).
    """
    try:
        psse("switch.views.curl_fun_forward: src:%s dst:%s" % (cli, exten))
        try:
            dst = Account.objects.get(name=exten)
            if dst.forward and dst.forward_number:
                return HttpResponse("OK_ON_%s" % dst.forward_number)
            return HttpResponse("OK_OFF")
        except Account.DoesNotExist, e:
            psse("called senza account: %s" % exten)
            return HttpResponse("OK")
    except Exception, e:
        return HttpResponse("KO_curl_fun_forward_%s" % str(e))
    
def curl_fun_bookrecall(request, cli, exten):
    """
    Chiamata da asterisk dopo una chiamata non risposta per segnare la messa in
    coda per i tentativi di richiamata automatici.
    """
    try:
        psse("switch.views.curl_fun_bookrecall: src:%s dst:%s" % (cli, exten))
        try:
            caller = Account.objects.get(name=cli)
            called = Account.objects.get(name=exten)
            functions = AccountFunctions.objects.get(account=called)

            if RecallBooking.objects.filter(caller__exact=caller,
                                            called__exact=called).count() > 0:
                return HttpResponse("KO_duplicato_o_waiting_%s_voicemail_%s" % (str(functions.call_waiting), str(functions.voice_mail)))
            if functions.do_not_disturb and functions.voice_mail: 
                return HttpResponse("KO_duplicato_o_waiting_%s_voicemail_%s" % (str(functions.call_waiting), str(functions.voice_mail)))
            if not functions.do_not_disturb and functions.call_waiting:
                return HttpResponse("KO_duplicato_o_waiting_%s_voicemail_%s" % (str(functions.call_waiting), str(functions.voice_mail)))
            if called.stato == 'free':
                callfile = CallFile(
                        trunk_type = 'SIP',
                        trunk_name = None,
                        number = "%s" % caller.name,
                        caller_id = caller.callerid,
                        context = 'from-internal',
                        extension = exten,
                        priority = '1',
                        max_retries = '0',
                        sets = {'SRC' : caller.name,
                                'DST' : called.name},
                        dir = ASTERISK_SPOOL
                        )
                try:
                    callfile.run()
                except NoAsteriskPermission:
                    return HttpResponse("KO_da_asterisk")
            else:
                RecallBooking.objects.create(caller=caller, called=called)
            return HttpResponse("OK")
        except Account.DoesNotExist, e:
            psse("called senza account: %s" % exten)
            return HttpResponse("KO_no_account_%s" % exten)
    except Exception, e:
        return HttpResponse("KO_curl_fun_bookrecall_%s" % str(e))

def curl_get_stato_account(request, cli):
    """
    Torna lo stato dell'account.
    """
    try:
        psse("switch.views.curl_get_stato_account: cli:%s" % cli)
        a = Account.objects.get(name=cli)
        return HttpResponse(a.stato)
    except Exception, e:
        return HttpResponse("KO_%s" % str(e))
    
def curl_get_bookable(request, cli):
    """
    Torna true se lo stato dell'account permette la prenotazione su richiamata.
    """
    try:
        psse("switch.views.curl_get_bookable: cli:%s" % cli)
        a = Account.objects.get(name=cli)
        af = AccountFunctions.objects.get(account=a)
        if af.voice_mail or af.call_waiting:
            return HttpResponse("NO")
        return HttpResponse("ON")
        return HttpResponse(a.stato)
    except Exception, e:
        return HttpResponse("KO_%s" % str(e))

    
def curl_get_free_meetme_space(request, confno):
    """
    Torna OK_FREE se ci sono ancora posti nella conference room, altrimenti
    torna OK_FULL.
    """
    try:
        psse("switch.views.curl_get_free_meetme_space: confno:%s" % confno)
        room = MeetMe.objects.get(confno=confno)
        if room.starttime > datetime.datetime.now() or room.endtime < datetime.datetime.now():
            return HttpResponse("OK_OUTOFDATE")
        if room.maxusers <= room.members and room.maxusers != 0:
            return HttpResponse("OK_FULL")
        return HttpResponse("OK_FREE")
    except Exception, e:
        return HttpResponse("KO_%s" % str(e))
        
def list_meetme_users(request):
    """
    Torna una lista di utenti in una stanza meetme data dal post.
    """
    room_pk = 0
    is_admin = 0
    if request.method == 'POST':
        form = MeetmeRoomForm(request.POST)
        if form.is_valid():
            confno = form.cleaned_data['confno']
            pin = form.cleaned_data['pin']
            try:
                room = MeetMe.objects.get(confno=confno)
                room_pk = room.pk
            except MeetMe.DoesNotExist:
                no_room = True
                room_pk = 0
            if room.pin != pin and room.adminpin != pin:
                wrong_pin = True
            if room.adminpin == pin:
                is_admin = 1
            users = MeetMeUser.objects.filter(meetme__confno=confno)
            return render_to_response('switch/list_meetme_users.html',
                                      locals(), RequestContext(request))
    else:
        form = MeetmeRoomForm()
    return render_to_response('switch/list_meetme_users.html',
                              locals(), RequestContext(request))
    
def get_utenti_meetme(request, room_pk, is_admin):
    room = MeetMe.objects.get(pk=room_pk)
    confno = room.confno
    users = MeetMeUser.objects.filter(meetme__confno=confno)
    return render_to_response('switch/snippets/_table_utenti_meetme.html',
                              locals(), RequestContext(request))
    
def ajax_fun_kick_meetme_user(request, confno, cli):
    psse('switch.views.ajax_fun_kick_meetme_user: confno:%s cli:%s' % (confno, cli))
    t = ThreadKickMeetmeUser(confno, cli)
    t.start()
    return HttpResponse("")

def ajax_fun_mute_meetme_user(request, confno, cli):
    psse('switch.views.ajax_fun_mute_meetme_user: confno:%s cli:%s' % (confno, cli))
    t = ThreadMuteMeetmeUser(confno, cli)
    t.start()
    return HttpResponse("")

def ajax_fun_unmute_meetme_user(request, confno, cli):
    psse('switch.views.ajax_fun_unmute_meetme_user: confno:%s cli:%s' % (confno, cli))
    t = ThreadUnmuteMeetmeUser(confno, cli)
    t.start()
    return HttpResponse("")



# OLD
        
def restart(request, device_id=None):
    """
    Torna una pagina con tutti i device selezionabili per fare un restart.
    O scatena l'action restart del device se è passato l'id ad argomento.
    """
    if not device_id:
        devices = Device.objects.all()
        return render_to_response("switch/restart.html", locals(),
                                  RequestContext(request))
    else:
        try:
            device = Device.objects.get(pk=device_id)
            device.as_specific().restart_action()
        except Exception, e:
            print >> sys.stderr, "Exception in restart_action %s" % str(e)
        return HttpResponseRedirect(reverse('restart_list'))

def click_to_call(request, utentepbx_pk, cli):
    """
    Fa chiamare al telefono associato al browser richiedente 
    il numero ad argomento
    """
    trunk_type = 'SIP'
    trunk_name = None
    extension = cli
    for caller in Account.objects.filter(utentepbx__pk__exact=utentepbx_pk):
        callfile = CallFile(user = 'asterisk',
                            trunk_type = trunk_type,
                            trunk_name = trunk_name,
                            number = caller.name,
                            caller_id = caller.callerid,
                            context = 'from-internal',
                            extension = extension,
                            priority = '1',
                            max_retries = '0',
                            sets = {'CHECKDNID' : 'NO'},
                            dir = ASTERISK_SPOOL
                            )
        print >> sys.stderr, "calling from %s to %s" % (caller.name, cli)
        try:
            callfile.run()
        except NoAsteriskPermission:
            error = "NoAsteriskPermission"
            return render_to_response("switch/error.html", locals())
    return HttpResponseRedirect(reverse("admin:pbx_utenti_dashboard_pbx"))


@transaction.autocommit
def curl_forcehangup(request, cli):
    try:
        src = Account.objects.get(name=cli)
        print >> sys.stderr, "forcehangup: %s" % src
        src.stato = 'free'
        src.currently_calling = None
        src.currently_calledby = None
        src.save()
    except:
        print >> sys.stderr, "chiamato forcehangup ma %s non ha account o device" % cli
    return HttpResponse("OK_forcehangup")

@transaction.autocommit
def curl_fixpickup(request, pickupper, pickupped):
    try:
        pickupped_account = Account.objects.get(name=pickupped)
        if pickupped_account.stato != 'ringing':
            return HttpResponse("OK_fixpickup_ignored")
        #curl_answer(request, '0', pickupper)
        try:
            dst = Account.objects.get(name=pickupper)
            print >> sys.stderr, "FROM called: %s %s, calling %s calledby %s" % (dst, dst.stato, dst.currently_calling, dst.currently_calledby)
            dst.stato = 'calling'
            dst.currently_calledby = 'pickup'
            dst.save()
            print >> sys.stderr, "TO called: %s %s, calling %s calledby %s" % (dst, dst.stato, dst.currently_calling, dst.currently_calledby)
        except Account.DoesNotExist, e:
            print >> sys.stderr, "called senza account: %s" % pickupper
        try:
            caller_device = Device.objects.get(account=dst)
            print >> sys.stderr, "caller device: %s" % caller_device
            print >> sys.stderr, "caller specific: %s" % caller_device.as_specific()
            t = ThreadAnswer(caller_device, 'pickup', pickupper)
            t.start()
        except Device.DoesNotExist, e:
            print >> sys.stderr, "ACCOUNT SENZA DEVICE: %s" % dst
            
        #curl_postdial(request, pickupped, '0')
        try:
            src = Account.objects.get(name=pickupped)
            print >> sys.stderr, "FROM ex caller: %s %s, calling %s calledby %s" % (src, src.stato, src.currently_calling, src.currently_calledby)
            src.stato = 'free'
            src.currently_calling = None
            src.currently_calledby = None
            src.save()
            print >> sys.stderr, "TO ex caller: %s %s, calling %s calledby %s" % (src, src.stato, src.currently_calling, src.currently_calledby)
        except Account.DoesNotExist, e:
            print >> sys.stderr, "ex caller senza account: %s" % pickupped
        try:
            caller_device = Device.objects.get(account=src)
            print >> sys.stderr, "ex caller device: %s" % caller_device
            print >> sys.stderr, "ex caller specific: %s" % caller_device.as_specific()
            t = ThreadPostdial(caller_device, 'pickup', pickupped)
            t.start()
        except Device.DoesNotExist:
            print >> sys.stderr, "ACCOUNT SENZA DEVICE: %s" % src
            pass
        
    except Exception, e:
        print >> sys.stderr, "curl_fixpickup, exception: %s" % str(e)
        return HttpResponse("KO_fixpickup")
    return HttpResponse("OK_fixpickup")


@transaction.autocommit
def curl_predial_nosrc(request, exten):
    print >> sys.stderr, "curl_predial_nosrc, dst: %s" % exten
    return curl_predial(request, 'nocli', exten)

@transaction.autocommit
def curl_answer_nosrc(request, exten):
    print >> sys.stderr, "curl_answer_nosrc, dst: %s" % exten
    return curl_answer(request, 'nocli', exten)

@transaction.autocommit
def curl_postdial_nosrc(request, exten):
    print >> sys.stderr, "curl_postdial_nosrc, dst: %s" % exten
    return curl_postdial(request, 'nocli', exten)

@transaction.autocommit
def curl_predial_nodst(request, cli):
    print >> sys.stderr, "curl_predial_nodst, src: %s" % cli
    return curl_predial(request, cli, 'noext')

@transaction.autocommit
def curl_answer_nodst(request, cli):
    print >> sys.stderr, "curl_answer_nodst, src: %s" % cli
    return curl_answer(request, cli, 'noext')

@transaction.autocommit
def curl_postdial_nodst(request, cli):
    print >> sys.stderr, "curl_postdial_nodst, src: %s" % cli
    return curl_postdial(request, cli, 'noext')

@transaction.autocommit
def curl_predial_picked(request, cli, exten):
    print >> sys.stderr, "curl_predial_picked, src: %s, exten: %s" % (cli, exten)
    return curl_predial(request, cli, exten)

@transaction.autocommit
def curl_answer_picked(request, exten):
    print >> sys.stderr, "curl_answer_picked, exten: %s" %  exten
    return curl_answer(request, "nocli", exten, pickedup=True)

@transaction.autocommit
def curl_postdial_picked(request, exten):
    print >> sys.stderr, "curl_postdial_picked, exten: %s" % exten
    return curl_postdial(request, "nocli", exten, pickedup=True)




#def cisco_authentication(request):
#    """
#    Torna sempre "AUTHORIZED"
#    """
#    return HttpResponse("AUTHORIZED")

#def cisco_directory(request):
#    """
#    Torna un XML con tutti i numeri
#    """
#    accounts = Account.objects.all()
#    serverurl = SERVERURL
#    num_account = accounts.count()
#    xml = render_to_string('switch/cisco/directory.xml', locals())
#    return HttpResponse(xml,  mimetype="text/xml")
    
#def cisco_services(request, device_id):
#    """
#    Torna un XMl statico
#    """
#    serverurl = SERVERURL
#    id = device_id
#    xml = render_to_string('switch/cisco/services.xml', locals())
#    return HttpResponse(xml,  mimetype="text/xml")

#def cisco_services_speeddial(request, device_id):
#    serverurl = SERVERURL
#    id = device_id
#    xml = render_to_string('switch/cisco/services/speeddial.xml', locals())
#    return HttpResponse(xml, mimetype="text/xml")

#def cisco_services_phonebook(request, device_id, first_index):
#    serverurl = SERVERURL
#    id = device_id
#    accounts = Account.objects.all()
#    accounts_count = accounts.count()
#    next_index = int(first_index)+32
#    accounts = accounts[first_index:next_index]
#    xml = render_to_string('switch/cisco/services/phonebook.xml', locals())
#    return HttpResponse(xml, mimetype="text/xml")

#def cisco_services_phonebooksearch(request, device_id):
#    serverurl = SERVERURL
#    id = device_id
#    xml = render_to_string('switch/cisco/services/phonebooksearch.xml', locals())
#    return HttpResponse(xml, mimetype="text/xml")

#def cisco_services_phonebookqs(request, device_id):
#    serverurl = SERVERURL
#    id = device_id
#    search = request.GET['search']
#    accounts = Account.objects.filter(Q(name__icontains=search) | 
#                                      Q(utentepbx__nome__icontains=search))
#    xml = render_to_string('switch/cisco/services/phonebookqs.xml', locals())
#    return HttpResponse(xml, mimetype="text/xml")

#def cisco_services_callwaiting(request, device_id):
#    serverurl = SERVERURL
#    id = device_id
#    xml = render_to_string('switch/cisco/services/callwaiting.xml', locals())
#    return HttpResponse(xml, mimetype="text/xml")

#def cisco_services_queues(request, device_id):
#    serverurl = SERVERURL
#    id = device_id
#    xml = render_to_string('switch/cisco/services/queues.xml', locals())
#    return HttpResponse(xml, mimetype="text/xml")

#def cisco_services_voicemail(request, device_id):
#    serverurl = SERVERURL
#    id = device_id
#    xml = render_to_string('switch/cisco/services/voicemail.xml', locals())
#    return HttpResponse(xml, mimetype="text/xml")

#def cisco_services_blacklist(request, device_id):
#    serverurl = SERVERURL
#    id = device_id
#    entries = BlacklistEntry.objects.all()
#    xml = render_to_string('switch/cisco/services/blacklist.xml', locals())
#    return HttpResponse(xml, mimetype="text/xml")

#def cisco_services_pphonebook_search(request):
#    serverurl = SERVERURL
#    xml = render_to_string('switch/cisco/services/pphonebook_search.xml', locals())
#    return HttpResponse(xml, mimetype="text/xml")

#def cisco_services_pphonebook(request):
#    serverurl = SERVERURL
#    xml = render_to_string('switch/cisco/services/pphonebook.xml', locals())
#    return HttpResponse(xml, mimetype="text/xml")

#def cisco_services_phonebook_search(request):
#    serverurl = SERVERURL
#    xml = render_to_string('switch/cisco/services/phonebook_search.xml', locals())
#    return HttpResponse(xml, mimetype="text/xml")

#def cisco_services_iphonebook(request):
#    serverurl = SERVERURL
#    xml = render_to_string('switch/cisco/services/iphonebook.xml', locals())
#    return HttpResponse(xml, mimetype="text/xml")

#def cisco_services_blacklist_add(request):
#    serverurl = SERVERURL
#    xml = render_to_string('switch/cisco/services/blacklist_add.xml', locals())
#    return HttpResponse(xml, mimetype="text/xml")

#def cisco_services_attendant_enable(request):
#    serverurl = SERVERURL
#    xml = render_to_string('switch/cisco/services/attendant_enable.xml', locals())
#    return HttpResponse(xml, mimetype="text/xml")

#def cisco_services_attendant_disable(request):
#    serverurl = SERVERURL
#    xml = render_to_string('switch/cisco/services/attendant_disable.xml', locals())
#    return HttpResponse(xml, mimetype="text/xml")

#def cisco_services_attendant(request):
#    serverurl = SERVERURL
#    xml = render_to_string('switch/cisco/services/attendant.xml', locals())
#    return HttpResponse(xml, mimetype="text/xml")

#def cisco_services_sms(request):
#    serverurl = SERVERURL
#    xml = render_to_string('switch/cisco/services/sms.xml', locals())
#    return HttpResponse(xml, mimetype="text/xml")


#def cisco_helloworld(request):
#    """
#    Per prove
#    """
#    return HttpResponse("Hello World")

#def cisco_push(request, function_name):
#    """
#    Scatena la push verso il cisco (per prove)
#    """
#    xml = { "XML" : '<CiscoIPPhoneExecute><ExecuteItem URL="%s/switch/cisco_%s/"/></CiscoIPPhoneExecute>' % (SERVERURL, function_name) }
#    params = urllib.urlencode(xml)
#    headers = {
#               "TE": "deflate,gzip;q=0.3",
#               "Connection": "TE, close",
#               "Authorization": "Basic YWRtaW46Y2lzY28=",
#               "User-Agent": "thunder-php-ua",
#               }
#    conn = httplib.HTTPConnection("172.16.2.129")
#    conn.request("POST", "/CGI/Execute", params, headers)
#    print >> sys.stderr, "request"
#    res = conn.getresponse()
#    print >> sys.stderr, "res %s" % res
#    return HttpResponse(res)

def reset(request, cli):
    """
    Reset hw del cisco collegato all'account "cli"
    """
    a = Account.objects.get(name=cli)
    try:
        
        
        return HttpResponse("OK")
    except:
        return HttpResponse("KO")

#def cisco_statusfile(request):
#    """
#    Boh
#    """
#    serverurl = SERVERURL
#    xml = render_to_string('switch/cisco/statusfile.xml', locals())
#    return HttpResponse(xml,  mimetype="text/xml")

#def cisco_updatestatus_ringing(request, account_pk, cli, exten):
#    """
#    Ritorno il file che segna il cli come occupato a chiamare l'exten
#    """
#    serverurl = SERVERURL
#    print >> sys.stderr, "torno xml che manda a: %s/switch/cisco_screen/%s/" % (serverurl, account_pk)
#    xml = render_to_string('switch/cisco/statusupdate.xml', locals())
#    return HttpResponse(xml,  mimetype="text/xml")

#def cisco_updatestatus_calling(request, account_pk, cli, exten):
#    """
#    Ritorno il file che segna il cli come occupato in chiamata con l'exten
#    """
#    serverurl = SERVERURL
#    print >> sys.stderr, "torno xml che manda a: %s/switch/cisco_screen/%s/" % (serverurl, account_pk)
#    xml = render_to_string('switch/cisco/statusupdate.xml', locals())
#    return HttpResponse(xml,  mimetype="text/xml")

#def cisco_updatestatus_hanged(request, account_pk, cli, exten):
#    """
#    Ritorno il file che segna il cli come libero
#    """
#    serverurl = SERVERURL
#    print >> sys.stderr, "torno xml che manda a: %s/switch/cisco_screen/%s/" % (serverurl, account_pk)
#    xml = render_to_string('switch/cisco/statusupdate.xml', locals())
#    return HttpResponse(xml,  mimetype="text/xml")

#def cisco_restart(request):
#    """
#    Restart dei cisco
#    """
#    serverurl = SERVERURL
#    xml = render_to_string('switch/cisco/restart.xml', locals())
#    return HttpResponse(xml,  mimetype="text/xml")

#def cisco_screen(request, account_pk):
#    """
#    Immagine da visualizzare sul display del cisco
#    """
#    a = Account.objects.get(pk=account_pk)
#    u = a.utentepbx
#    mostrati_attivi = []
#    mostrati_free = []
#    monitorati = u.utenti_monitorati.all()
#    for monitorato in monitorati:
#        for account in monitorato.accounts_utentepbx.all():
#            if account.stato == 'calling' or account.stato == 'ringing':
#                mostrati_attivi.append(account)
#            else:
##                mostrati_free.append(account)
#                mostrati_attivi.append(account)
##    if len(mostrati_attivi) < 8:
##        for account in mostrati_free:
##            if len(mostrati_attivi) < 8:
##                mostrati_attivi.append(account)
#    img = Image.new('RGB', (252, 50), (102, 153, 204))
#    imgDrawer = ImageDraw.Draw(img)
#    font = ImageFont.truetype(CISCOFONTTYPE, CISCOFONTSIZE)
#    for mostrato in mostrati_attivi[0:8]:
#        user = mostrato.utentepbx.get_user()
#        if mostrato.stato == 'free':
#            fill= (153, 255, 255)
#        else:
#            fill = (255,255,102)
#        if mostrato.stato == 'ringing':
#            try:
#                if mostrato.currently_calling:
#                    user_label = "%s" % mostrato.currently_calling
#                else:
#                    user_label = "%s" % mostrato.currently_calledby
#            except:
#                user_label = "no name"         
#        else:
#            try:
#                user_label = "%s %s." % (user.last_name, user.first_name[0:1])
#            except:
#                user_label = "no name"
#        if len(user_label) > 13:
#            user_label = user_label[0:13]
#        txt = "%s <%s> %s" % (mostrato.stato[0:1].upper(), mostrato.name, user_label)
#        imgDrawer.text(POSITIONS[mostrati_attivi.index(mostrato)+1], txt,
#                       font=font, fill=fill)
#    img.save("%s%s-screen.png" % (CISCOIMAGESPATH, u.pk))
#        
#    image = open("%s%s-screen.png" % (CISCOIMAGESPATH, u.pk), "rb").read()
#    return HttpResponse(image, mimetype="image/png")

def curl_get_mail_from_int(request, int):
    """
    Dato un numero d'interno ritorna la mail dell'utente associato
    """
    a = Account.objects.get(name=int)
    u = a.utentepbx
    return HttpResponse(u.get_user().email)

def curl_get_fax_for_account(request, int):
    """
    Ritorna lo stato della variabile fax per un certo numero d'interno
    """
    try:
        a = Account.objects.get(name=int)
    except:
        return HttpResponse("KO_404")
    return HttpResponse(a.fax)

def curl_ignore(request):
    return HttpResponse('OK_ignore')

def device_restart(request, device_id):
    try:
        device = Device.objects.get(pk=device_id)
        device.as_specific().restart_action()
    except Exception, e:
        print >> sys.stderr, "Exception in device_restart: %s" % str(e)
    return HttpResponseRedirect('..')

def restart_all(request):
    for d in Device.objects.all():
        pass
        try:
            d.as_specific().restart_action()
        except Exception, e:
            print >> sys.stderr, "Exception in restart_all: %s" % str(e)
    return HttpResponseRedirect('/')



def switch_do_not_disturb(request, account_id):
    a = AccountFunctions.objects.get(account__pk=account_id)
    a.do_not_disturb = not a.do_not_disturb
    a.save()
    return HttpResponse(ETICHETTA_STATO_FUNZIONI[a.do_not_disturb])

def switch_call_waiting(request, account_id):
    a = AccountFunctions.objects.get(account__pk=account_id)
    a.call_waiting = not a.call_waiting
    a.save()
    return HttpResponse(ETICHETTA_STATO_FUNZIONI[a.call_waiting])

def get_abilitazione_call_waiting(request, account_id):
    a = AccountFunctions.objects.get(account__pk=account_id)
    return HttpResponse(ETICHETTA_STATO_FUNZIONAMENTO_CW[a.do_not_disturb])

def switch_voicemail(request, account_id):
    a = AccountFunctions.objects.get(account__pk=account_id)
    a.voice_mail = not a.voice_mail
    a.save()
    return HttpResponse(ETICHETTA_STATO_FUNZIONI[a.voice_mail])

def switch_forward(request, account_id):
    a = AccountFunctions.objects.get(account__pk=account_id)
    a.forward = not a.forward
    a.save()
    return HttpResponse(ETICHETTA_STATO_FUNZIONI[a.forward])

def get_forward_number(request, account_id):
    a = AccountFunctions.objects.get(account__pk=account_id)
    return HttpResponse(a.forward_number)

def update_forward(request, account_id):
    try:
        a = AccountFunctions.objects.get(account__pk=account_id)
        a.forward_number = request.GET['number']
        a.save()
        return HttpResponse("OK")
    except Exception, e:
        return HttpResponse("KO_%s" % str(e))

def update_voicemail(request, account_id):
    try:
        a = Account.objects.get(pk=account_id)
        vm = VoiceMail.objects.get(mailbox=a.name)
        vm.password = request.GET["password"]
        vm.attach = request.GET["attach"]
        vm.maxmsg = int(request.GET["maxmsg"])
        vm.save()
        return HttpResponse("OK")
    except Exception, e:
        return HttpResponse("KO_%s" % str(e))

def get_callgroups(request, account_id):
    a = Account.objects.get(pk=account_id)
    callgroups = a.gruppi_di_chiamata.all()
    return render_to_response('switch/snippets/callgroups_table.html',
                              locals(), RequestContext(request))
    
def get_queues(request, account_id):
    a = Account.objects.get(pk=account_id)
    qs = QueueMember.objects.filter(membername__exact=a.name)
    queues = []
    for q in qs:
        qsa = QueueMember.objects.filter(queue_name__exact=q.queue_name).exclude(membername__exact=a.name)
        nomi = []
        for n in qsa:
            nomi.append(n.utentepbx)
        queues.append({'name' : q.queue_name,
                       'altri_membri' : qsa})
    return render_to_response('switch/snippets/queues_table.html',
                              locals(), RequestContext(request))
    
def get_recalls(request, account_id):
    a = Account.objects.get(pk=account_id)
    qs_caller = RecallBooking.objects.filter(caller__exact=a)
    qs_called = RecallBooking.objects.filter(called__exact=a)
    return render_to_response('switch/snippets/recalls_table.html',
                              locals(), RequestContext(request))
    
def get_conference(request, account_id):
    a = Account.objects.get(pk=account_id)
    conferences = MeetMeUser.objects.filter(account=a)
    return render_to_response('switch/snippets/_table_conference.html',
                              locals(), RequestContext(request))
