# -*- coding: utf-8 -*-
'''
Created on 2/ago/2011

@author: simone cittadini
'''

from django.contrib import admin
from django import forms
from django.utils.translation import ugettext as _
from django.conf.urls.defaults import patterns, url

from jumbo.apps.autocomplete.fields import AutocompleteMultiChoiceField, AutocompleteChoiceField
from jumbo.admin.options import ExtendibleModelAdmin
#from jumbo.apps.auth.admin import JumboUserAdmin
#from jumbo.apps.auth.models import JumboUser
from jumbo.apps.autocomplete.fields import AutocompleteModelChoiceField
from jumbo.forms.models import AdminModelForm
from jumbo.apps.autocomplete import autocomplete
from jumbo.utils.functions import zerofill
from jumbo.apps.profile.models import SCProfiles

from pbx.views import dashboard_pbx, retrieve__personalphonebook
from pbx.utenti.views import create__personalphonebookentry, update__personalphonebookentry
from pbx.utenti.models import SpeedDialEntry, Reparto, UtentePBX
from pbx.utenti.models import PersonalPhonebookEntry, BlacklistEntry


class UtentiPBXSearchForm(forms.ModelForm):
    class Meta:
        model = UtentePBX
        #fields = ('id_impianto', 'codice_amm','rinnovo_tacito','attivita' )
        display_fields = (
            'nome__icontains',
        )

    def __init__(self, *args, **kws):
        super(UtentiPBXSearchForm, self).__init__(*args, **kws)
        self.fields['nome__icontains'] = forms.CharField(label=_("Nome"), required=False)


class UtentPBXAdmin(ExtendibleModelAdmin):

    class Media:
        js = ['admin/js/list_filter_collapse.js']

    list_display = (
        'nome','is_admin',
        'get_detail_icon', 'get_edit_icon', #'get_delete_icon',
    )
    detail_display = ( 'nome','is_admin', )

    #raw_id_fields = ('organization',)
    #form = UtentePBXAdminForm
    save_on_top = False
    search_form = UtentiPBXSearchForm
    search_fields = ('nome',)
    ordering = ('nome', 'is_admin',)
    list_filter = ()
    filter_horizontal = ('utenti_monitorati',)
    no_display_links = False
    
    def get_urls(self):
        urls = super(UtentPBXAdmin, self).get_urls()
        my_urls = patterns('',
            url(r'^dashboard_pbx/$',
                self.admin_site.admin_view(dashboard_pbx),
                name='pbx_utenti_dashboard_pbx'
            ),
            url(r'retrieve__personalphonebook/(?P<utente_pbx_id>\d+)/$',
                self.admin_site.admin_view(retrieve__personalphonebook),
                name='pbx_utenti_retrieve_personalphonebook'),
                           
            url(r'^create__personalphonebookentry/(?P<utente_pbx_id>\d+)/$',
                self.admin_site.admin_view(create__personalphonebookentry),
                name='pbx_utenti_create__personalphonebookentry'),
            url(r'^update__personalphonebookentry/(?P<id>\d+)/$',
                self.admin_site.admin_view(update__personalphonebookentry),
                name='pbx_utenti_update__personalphonebookentry'),
        )
        return my_urls + urls
    
    def utente_reparto_link(self, obj):
        link = u'<a class="iframe" href="/admin/../%s/%s/detail/?_popup=1&nobuttons=1">%s</a>' \
               % ( 'amministratore' , obj.id, obj.id)
        return link
    utente_reparto_link.short_description = _("Reparto")
    utente_reparto_link.allow_tags = True

admin.site.register(Reparto)
admin.site.register(UtentePBX,UtentPBXAdmin)
admin.site.register(PersonalPhonebookEntry)
admin.site.register(BlacklistEntry)
admin.site.register(SCProfiles)
admin.site.register(SpeedDialEntry)

