# encoding: utf-8
import datetime
from south.db import db
from south.v2 import SchemaMigration
from django.db import models

class Migration(SchemaMigration):

    def forwards(self, orm):
        
        # Changing field 'SpeedDialEntry.numero'
        db.alter_column('utenti_speeddialentry', 'numero', self.gf('django.db.models.fields.CharField')(max_length=3))


    def backwards(self, orm):
        
        # Changing field 'SpeedDialEntry.numero'
        db.alter_column('utenti_speeddialentry', 'numero', self.gf('django.db.models.fields.CharField')(max_length=2))


    models = {
        'auth.group': {
            'Meta': {'object_name': 'Group'},
            'id': ('django.db.models.fields.AutoField', [], {'primary_key': 'True'}),
            'name': ('django.db.models.fields.CharField', [], {'unique': 'True', 'max_length': '80'}),
            'permissions': ('django.db.models.fields.related.ManyToManyField', [], {'to': "orm['auth.Permission']", 'symmetrical': 'False', 'blank': 'True'})
        },
        'auth.permission': {
            'Meta': {'ordering': "('content_type__app_label', 'content_type__model', 'codename')", 'unique_together': "(('content_type', 'codename'),)", 'object_name': 'Permission'},
            'codename': ('django.db.models.fields.CharField', [], {'max_length': '100'}),
            'content_type': ('django.db.models.fields.related.ForeignKey', [], {'to': "orm['contenttypes.ContentType']"}),
            'id': ('django.db.models.fields.AutoField', [], {'primary_key': 'True'}),
            'name': ('django.db.models.fields.CharField', [], {'max_length': '50'})
        },
        'auth.user': {
            'Meta': {'object_name': 'User'},
            'date_joined': ('django.db.models.fields.DateTimeField', [], {'default': 'datetime.datetime.now'}),
            'email': ('django.db.models.fields.EmailField', [], {'max_length': '75', 'blank': 'True'}),
            'first_name': ('django.db.models.fields.CharField', [], {'max_length': '30', 'blank': 'True'}),
            'groups': ('django.db.models.fields.related.ManyToManyField', [], {'to': "orm['auth.Group']", 'symmetrical': 'False', 'blank': 'True'}),
            'id': ('django.db.models.fields.AutoField', [], {'primary_key': 'True'}),
            'is_active': ('django.db.models.fields.BooleanField', [], {'default': 'True'}),
            'is_staff': ('django.db.models.fields.BooleanField', [], {'default': 'False'}),
            'is_superuser': ('django.db.models.fields.BooleanField', [], {'default': 'False'}),
            'last_login': ('django.db.models.fields.DateTimeField', [], {'default': 'datetime.datetime.now'}),
            'last_name': ('django.db.models.fields.CharField', [], {'max_length': '30', 'blank': 'True'}),
            'password': ('django.db.models.fields.CharField', [], {'max_length': '128'}),
            'user_permissions': ('django.db.models.fields.related.ManyToManyField', [], {'to': "orm['auth.Permission']", 'symmetrical': 'False', 'blank': 'True'}),
            'username': ('django.db.models.fields.CharField', [], {'unique': 'True', 'max_length': '30'})
        },
        'contenttypes.contenttype': {
            'Meta': {'ordering': "('name',)", 'unique_together': "(('app_label', 'model'),)", 'object_name': 'ContentType', 'db_table': "'django_content_type'"},
            'app_label': ('django.db.models.fields.CharField', [], {'max_length': '100'}),
            'id': ('django.db.models.fields.AutoField', [], {'primary_key': 'True'}),
            'model': ('django.db.models.fields.CharField', [], {'max_length': '100'}),
            'name': ('django.db.models.fields.CharField', [], {'max_length': '100'})
        },
        'profile.scprofile': {
            'Meta': {'object_name': 'SCProfile'},
            'content_type': ('django.db.models.fields.related.ForeignKey', [], {'to': "orm['contenttypes.ContentType']", 'null': 'True'}),
            'id': ('django.db.models.fields.AutoField', [], {'primary_key': 'True'}),
            'scprofiles': ('django.db.models.fields.related.ForeignKey', [], {'to': "orm['profile.SCProfiles']"})
        },
        'profile.scprofiles': {
            'Meta': {'object_name': 'SCProfiles'},
            'id': ('django.db.models.fields.AutoField', [], {'primary_key': 'True'}),
            'user': ('django.db.models.fields.related.OneToOneField', [], {'to': "orm['auth.User']", 'unique': 'True'})
        },
        'utenti.blacklistentry': {
            'Meta': {'ordering': "('verso', 'nome', 'numero')", 'object_name': 'BlacklistEntry'},
            'id': ('django.db.models.fields.AutoField', [], {'primary_key': 'True'}),
            'nome': ('django.db.models.fields.CharField', [], {'max_length': '64'}),
            'numero': ('django.db.models.fields.CharField', [], {'max_length': '64'}),
            'verso': ('django.db.models.fields.CharField', [], {'default': "'BOTH'", 'max_length': '4'})
        },
        'utenti.enabledcookie': {
            'Meta': {'object_name': 'EnabledCookie'},
            'enabled': ('django.db.models.fields.BooleanField', [], {'default': 'False'}),
            'id': ('django.db.models.fields.AutoField', [], {'primary_key': 'True'}),
            'timestamp': ('django.db.models.fields.DateTimeField', [], {'auto_now': 'True', 'blank': 'True'}),
            'value': ('django.db.models.fields.CharField', [], {'unique': 'True', 'max_length': '64'})
        },
        'utenti.pbxprofiles': {
            'Meta': {'object_name': 'PbxProfiles', '_ormbases': ['profile.SCProfiles']},
            'scprofiles_ptr': ('django.db.models.fields.related.OneToOneField', [], {'to': "orm['profile.SCProfiles']", 'unique': 'True', 'primary_key': 'True'})
        },
        'utenti.personalphonebookentry': {
            'Meta': {'ordering': "['nome']", 'object_name': 'PersonalPhonebookEntry'},
            'id': ('django.db.models.fields.AutoField', [], {'primary_key': 'True'}),
            'nome': ('django.db.models.fields.CharField', [], {'max_length': '64'}),
            'numero': ('django.db.models.fields.CharField', [], {'max_length': '64'}),
            'utentepbx': ('django.db.models.fields.related.ForeignKey', [], {'to': "orm['utenti.UtentePBX']"})
        },
        'utenti.reparto': {
            'Meta': {'object_name': 'Reparto'},
            'id': ('django.db.models.fields.AutoField', [], {'primary_key': 'True'}),
            'nome': ('django.db.models.fields.CharField', [], {'unique': 'True', 'max_length': '128'})
        },
        'utenti.speeddialentry': {
            'Meta': {'ordering': "('numero', 'nome')", 'object_name': 'SpeedDialEntry'},
            'destinazione': ('django.db.models.fields.CharField', [], {'max_length': '64'}),
            'id': ('django.db.models.fields.AutoField', [], {'primary_key': 'True'}),
            'nome': ('django.db.models.fields.CharField', [], {'max_length': '64'}),
            'numero': ('django.db.models.fields.CharField', [], {'max_length': '3'})
        },
        'utenti.utentepbx': {
            'Meta': {'ordering': "('nome',)", 'object_name': 'UtentePBX', '_ormbases': ['profile.SCProfile']},
            'is_admin': ('django.db.models.fields.BooleanField', [], {'default': 'False'}),
            'nome': ('django.db.models.fields.CharField', [], {'max_length': '64'}),
            'reparti': ('django.db.models.fields.related.ManyToManyField', [], {'blank': 'True', 'related_name': "'utentipbx'", 'null': 'True', 'symmetrical': 'False', 'to': "orm['utenti.Reparto']"}),
            'scprofile_ptr': ('django.db.models.fields.related.OneToOneField', [], {'to': "orm['profile.SCProfile']", 'unique': 'True', 'primary_key': 'True'}),
            'utenti_monitorati': ('django.db.models.fields.related.ManyToManyField', [], {'blank': 'True', 'related_name': "'osservatori'", 'null': 'True', 'symmetrical': 'False', 'to': "orm['utenti.UtentePBX']"})
        }
    }

    complete_apps = ['utenti']
